import time
import datetime

import requests
import pandas as pd

__all__ = ['weather']

city_dict = {}
city_info = [{'id': '101010100', 'city': '北京', 'province': '北京', 'leader': '北京'}, {'id': '101010200', 'city': '海淀', 'province': '北京', 'leader': '北京'}, {'id': '101010300', 'city': '朝阳', 'province': '北京', 'leader': '北京'}, {'id': '101010400', 'city': '顺义', 'province': '北京', 'leader': '北京'}, {'id': '101010500', 'city': '怀柔', 'province': '北京', 'leader': '北京'}, {'id': '101010600', 'city': '通州', 'province': '北京', 'leader': '北京'}, {'id': '101010700', 'city': '昌平', 'province': '北京', 'leader': '北京'}, {'id': '101010800', 'city': '延庆', 'province': '北京', 'leader': '北京'}, {'id': '101010900', 'city': '丰台', 'province': '北京', 'leader': '北京'}, {'id': '101011000', 'city': '石景山', 'province': '北京', 'leader': '北京'}, {'id': '101011100', 'city': '大兴', 'province': '北京', 'leader': '北京'}, {'id': '101011200', 'city': '房山', 'province': '北京', 'leader': '北京'}, {'id': '101011300', 'city': '密云', 'province': '北京', 'leader': '北京'}, {'id': '101011400', 'city': '门头沟', 'province': '北京', 'leader': '北京'}, {'id': '101011500', 'city': '平谷', 'province': '北京', 'leader': '北京'}, {'id': '101011600', 'city': '东城', 'province': '北京', 'leader': '东城'}, {'id': '101011700', 'city': '西城', 'province': '北京', 'leader': '西城'}, {'id': '101020100', 'city': '上海', 'province': '上海', 'leader': '上海'}, {'id': '101020200', 'city': '闵行', 'province': '上海', 'leader': '上海'}, {'id': '101020300', 'city': '宝山', 'province': '上海', 'leader': '上海'}, {'id': '101020400', 'city': '黄浦', 'province': '上海', 'leader': '黄浦'}, {'id': '101020500', 'city': '嘉定', 'province': '上海', 'leader': '上海'}, {'id': '101020600', 'city': '浦东新区', 'province': '上海', 'leader': '上海'}, {'id': '101020700', 'city': '金山', 'province': '上海', 'leader': '上海'}, {'id': '101020800', 'city': '青浦', 'province': '上海', 'leader': '上海'}, {'id': '101020900', 'city': '松江', 'province': '上海', 'leader': '上海'}, {'id': '101021000', 'city': '奉贤', 'province': '上海', 'leader': '上海'}, {'id': '101021100', 'city': '崇明', 'province': '上海', 'leader': '上海'}, {'id': '101021200', 'city': '徐汇', 'province': '上海', 'leader': '上海'}, {'id': '101021300', 'city': '长宁', 'province': '上海', 'leader': '长宁'}, {'id': '101021400', 'city': '静安', 'province': '上海', 'leader': '静安'}, {'id': '101021500', 'city': '普陀', 'province': '上海', 'leader': '普陀'}, {'id': '101021600', 'city': '虹口', 'province': '上海', 'leader': '虹口'}, {'id': '101021700', 'city': '杨浦', 'province': '上海', 'leader': '杨浦'}, {'id': '101030100', 'city': '天津', 'province': '天津', 'leader': '天津'}, {'id': '101030200', 'city': '武清', 'province': '天津', 'leader': '天津'}, {'id': '101030300', 'city': '宝坻', 'province': '天津', 'leader': '天津'}, {'id': '101030400', 'city': '东丽', 'province': '天津', 'leader': '天津'}, {'id': '101030500', 'city': '西青', 'province': '天津', 'leader': '天津'}, {'id': '101030600', 'city': '北辰', 'province': '天津', 'leader': '天津'}, {'id': '101030700', 'city': '宁河', 'province': '天津', 'leader': '天津'}, {'id': '101030800', 'city': '和平', 'province': '天津', 'leader': '和平'}, {'id': '101030900', 'city': '静海', 'province': '天津', 'leader': '天津'}, {'id': '101031000', 'city': '津南', 'province': '天津', 'leader': '天津'}, {'id': '101031100', 'city': '滨海新区', 'province': '天津', 'leader': '天津'}, {'id': '101031200', 'city': '河东', 'province': '天津', 'leader': '河东'}, {'id': '101031300', 'city': '河西', 'province': '天津', 'leader': '河西'}, {'id': '101031400', 'city': '蓟州', 'province': '天津', 'leader': '天津'}, {'id': '101031500', 'city': '南开', 'province': '天津', 'leader': '南开'}, {'id': '101031600', 'city': '河北', 'province': '天津', 'leader': '河北'}, {'id': '101031700', 'city': '红桥', 'province': '天津', 'leader': '红桥'}, {'id': '101040100', 'city': '重庆', 'province': '重庆', 'leader': '重庆'}, {'id': '101040200', 'city': '永川', 'province': '重庆', 'leader': '重庆'}, {'id': '101040300', 'city': '合川', 'province': '重庆', 'leader': '重庆'}, {'id': '101040400', 'city': '南川', 'province': '重庆', 'leader': '重庆'}, {'id': '101040500', 'city': '江津', 'province': '重庆', 'leader': '重庆'}, {'id': '101040700', 'city': '渝北', 'province': '重庆', 'leader': '重庆'}, {'id': '101040800', 'city': '北碚', 'province': '重庆', 'leader': '重庆'}, {'id': '101040900', 'city': '巴南', 'province': '重庆', 'leader': '重庆'}, {'id': '101041000', 'city': '长寿', 'province': '重庆', 'leader': '重庆'}, {'id': '101041100', 'city': '黔江', 'province': '重庆', 'leader': '重庆'}, {'id': '101041200', 'city': '渝中', 'province': '重庆', 'leader': '渝中'}, {'id': '101041300', 'city': '万州', 'province': '重庆', 'leader': '重庆'}, {'id': '101041400', 'city': '涪陵', 'province': '重庆', 'leader': '重庆'}, {'id': '101041500', 'city': '开县', 'province': '重庆', 'leader': '重庆'}, {'id': '101041600', 'city': '城口', 'province': '重庆', 'leader': '重庆'}, {'id': '101041700', 'city': '云阳', 'province': '重庆', 'leader': '重庆'}, {'id': '101041800', 'city': '巫溪', 'province': '重庆', 'leader': '重庆'}, {'id': '101041900', 'city': '奉节', 'province': '重庆', 'leader': '重庆'}, {'id': '101042000', 'city': '巫山', 'province': '重庆', 'leader': '重庆'}, {'id': '101042100', 'city': '潼南', 'province': '重庆', 'leader': '重庆'}, {'id': '101042200', 'city': '垫江', 'province': '重庆', 'leader': '重庆'}, {'id': '101042300', 'city': '梁平', 'province': '重庆', 'leader': '重庆'}, {'id': '101042400', 'city': '忠县', 'province': '重庆', 'leader': '重庆'}, {'id': '101042500', 'city': '石柱', 'province': '重庆', 'leader': '重庆'}, {'id': '101042600', 'city': '大足', 'province': '重庆', 'leader': '重庆'}, {'id': '101042700', 'city': '荣昌', 'province': '重庆', 'leader': '重庆'}, {'id': '101042800', 'city': '铜梁', 'province': '重庆', 'leader': '重庆'}, {'id': '101042900', 'city': '璧山', 'province': '重庆', 'leader': '重庆'}, {'id': '101043000', 'city': '丰都', 'province': '重庆', 'leader': '重庆'}, {'id': '101043100', 'city': '武隆', 'province': '重庆', 'leader': '重庆'}, {'id': '101043200', 'city': '彭水', 'province': '重庆', 'leader': '重庆'}, {'id': '101043300', 'city': '綦江', 'province': '重庆', 'leader': '重庆'}, {'id': '101043400', 'city': '酉阳', 'province': '重庆', 'leader': '重庆'}, {'id': '101043500', 'city': '大渡口', 'province': '重庆', 'leader': '大渡口'}, {'id': '101043600', 'city': '秀山', 'province': '重庆', 'leader': '重庆'}, {'id': '101043700', 'city': '江北', 'province': '重庆', 'leader': '江北'}, {'id': '101043800', 'city': '沙坪坝', 'province': '重庆', 'leader': '沙坪坝'}, {'id': '101043900', 'city': '九龙坡', 'province': '重庆', 'leader': '九龙坡'}, {'id': '101044000', 'city': '南岸', 'province': '重庆', 'leader': '南岸'}, {'id': '101044100', 'city': '开州', 'province': '重庆', 'leader': '开州'}, {'id': '101050101', 'city': '哈尔滨', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050102', 'city': '双城', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050103', 'city': '呼兰', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050104', 'city': '阿城', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050105', 'city': '宾县', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050106', 'city': '依兰', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050107', 'city': '巴彦', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050108', 'city': '通河', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050109', 'city': '方正', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050110', 'city': '延寿', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050111', 'city': '尚志', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050112', 'city': '五常', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050113', 'city': '木兰', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050114', 'city': '道里', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050115', 'city': '南岗', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050116', 'city': '道外', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050117', 'city': '平房', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050118', 'city': '松北', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050119', 'city': '香坊', 'province': '黑龙江', 'leader': '哈尔滨'}, {'id': '101050201', 'city': '齐齐哈尔', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050202', 'city': '讷河', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050203', 'city': '龙江', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050204', 'city': '甘南', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050205', 'city': '富裕', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050206', 'city': '依安', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050207', 'city': '拜泉', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050208', 'city': '克山', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050209', 'city': '克东', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050210', 'city': '泰来', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050211', 'city': '龙沙', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050212', 'city': '建华', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050213', 'city': '铁锋', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050214', 'city': '昂昂溪', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050215', 'city': '富拉尔基', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050216', 'city': '碾子山', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050217', 'city': '梅里斯', 'province': '黑龙江', 'leader': '齐齐哈尔'}, {'id': '101050301', 'city': '牡丹江', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050302', 'city': '海林', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050303', 'city': '穆棱', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050304', 'city': '林口', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050305', 'city': '绥芬河', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050306', 'city': '宁安', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050307', 'city': '东宁', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050308', 'city': '东安', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050309', 'city': '阳明', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050310', 'city': '爱民', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050311', 'city': '西安', 'province': '黑龙江', 'leader': '牡丹江'}, {'id': '101050401', 'city': '佳木斯', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050402', 'city': '汤原', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050403', 'city': '抚远', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050404', 'city': '桦川', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050405', 'city': '桦南', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050406', 'city': '同江', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050407', 'city': '富锦', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050408', 'city': '向阳', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050409', 'city': '前进', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050410', 'city': '东风', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050411', 'city': '郊区', 'province': '黑龙江', 'leader': '佳木斯'}, {'id': '101050501', 'city': '绥化', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050502', 'city': '肇东', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050503', 'city': '安达', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050504', 'city': '海伦', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050505', 'city': '明水', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050506', 'city': '望奎', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050507', 'city': '兰西', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050508', 'city': '青冈', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050509', 'city': '庆安', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050510', 'city': '绥棱', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050511', 'city': '北林', 'province': '黑龙江', 'leader': '绥化'}, {'id': '101050601', 'city': '黑河', 'province': '黑龙江', 'leader': '黑河'}, {'id': '101050602', 'city': '嫩江', 'province': '黑龙江', 'leader': '黑河'}, {'id': '101050603', 'city': '孙吴', 'province': '黑龙江', 'leader': '黑河'}, {'id': '101050604', 'city': '逊克', 'province': '黑龙江', 'leader': '黑河'}, {'id': '101050605', 'city': '五大连池', 'province': '黑龙江', 'leader': '黑河'}, {'id': '101050606', 'city': '北安', 'province': '黑龙江', 'leader': '黑河'}, {'id': '101050607', 'city': '爱辉', 'province': '黑龙江', 'leader': '黑河'}, {'id': '101050701', 'city': '大兴安岭', 'province': '黑龙江', 'leader': '大兴安岭'}, {'id': '101050702', 'city': '塔河', 'province': '黑龙江', 'leader': '大兴安岭'}, {'id': '101050703', 'city': '漠河', 'province': '黑龙江', 'leader': '大兴安岭'}, {'id': '101050704', 'city': '呼玛', 'province': '黑龙江', 'leader': '大兴安岭'}, {'id': '101050801', 'city': '伊春', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050802', 'city': '乌伊岭', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050803', 'city': '五营', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050804', 'city': '铁力', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050805', 'city': '嘉荫', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050806', 'city': '南岔', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050807', 'city': '友好', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050808', 'city': '西林', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050809', 'city': '翠峦', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050810', 'city': '新青', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050811', 'city': '美溪', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050812', 'city': '金山屯', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050813', 'city': '乌马河', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050814', 'city': '汤旺河', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050815', 'city': '带岭', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050816', 'city': '红星', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050817', 'city': '上甘岭', 'province': '黑龙江', 'leader': '伊春'}, {'id': '101050901', 'city': '大庆', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050902', 'city': '林甸', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050903', 'city': '肇州', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050904', 'city': '肇源', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050905', 'city': '杜尔伯特', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050906', 'city': '萨尔图', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050907', 'city': '龙凤', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050908', 'city': '让胡路', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050909', 'city': '红岗', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101050910', 'city': '大同', 'province': '黑龙江', 'leader': '大庆'}, {'id': '101051001', 'city': '新兴', 'province': '黑龙江', 'leader': '七台河'}, {'id': '101051002', 'city': '七台河', 'province': '黑龙江', 'leader': '七台河'}, {'id': '101051003', 'city': '勃利', 'province': '黑龙江', 'leader': '七台河'}, {'id': '101051004', 'city': '桃山', 'province': '黑龙江', 'leader': '七台河'}, {'id': '101051005', 'city': '茄子河', 'province': '黑龙江', 'leader': '七台河'}, {'id': '101051101', 'city': '鸡西', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051102', 'city': '虎林', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051103', 'city': '密山', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051104', 'city': '鸡东', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051105', 'city': '鸡冠', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051106', 'city': '恒山', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051107', 'city': '滴道', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051108', 'city': '梨树', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051109', 'city': '城子河', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051110', 'city': '麻山', 'province': '黑龙江', 'leader': '鸡西'}, {'id': '101051201', 'city': '鹤岗', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051202', 'city': '绥滨', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051203', 'city': '萝北', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051204', 'city': '向阳', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051205', 'city': '工农', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051206', 'city': '南山', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051207', 'city': '兴安', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051208', 'city': '东山', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051209', 'city': '兴山', 'province': '黑龙江', 'leader': '鹤岗'}, {'id': '101051301', 'city': '双鸭山', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051302', 'city': '集贤', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051303', 'city': '宝清', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051304', 'city': '饶河', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051305', 'city': '友谊', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051306', 'city': '尖山', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051307', 'city': '岭东', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051308', 'city': '四方台', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101051309', 'city': '宝山', 'province': '黑龙江', 'leader': '双鸭山'}, {'id': '101060101', 'city': '长春', 'province': '吉林', 'leader': '长春'}, {'id': '101060102', 'city': '农安', 'province': '吉林', 'leader': '长春'}, {'id': '101060103', 'city': '德惠', 'province': '吉林', 'leader': '长春'}, {'id': '101060104', 'city': '九台', 'province': '吉林', 'leader': '长春'}, {'id': '101060105', 'city': '榆树', 'province': '吉林', 'leader': '长春'}, {'id': '101060106', 'city': '双阳', 'province': '吉林', 'leader': '长春'}, {'id': '101060107', 'city': '二道', 'province': '吉林', 'leader': '长春'}, {'id': '101060108', 'city': '南关', 'province': '吉林', 'leader': '长春'}, {'id': '101060109', 'city': '宽城', 'province': '吉林', 'leader': '长春'}, {'id': '101060110', 'city': '朝阳', 'province': '吉林', 'leader': '长春'}, {'id': '101060111', 'city': '绿园', 'province': '吉林', 'leader': '长春'}, {'id': '101060201', 'city': '吉林', 'province': '吉林', 'leader': '吉林'}, {'id': '101060202', 'city': '舒兰', 'province': '吉林', 'leader': '吉林'}, {'id': '101060203', 'city': '永吉', 'province': '吉林', 'leader': '吉林'}, {'id': '101060204', 'city': '蛟河', 'province': '吉林', 'leader': '吉林'}, {'id': '101060205', 'city': '磐石', 'province': '吉林', 'leader': '吉林'}, {'id': '101060206', 'city': '桦甸', 'province': '吉林', 'leader': '吉林'}, {'id': '101060207', 'city': '昌邑', 'province': '吉林', 'leader': '吉林'}, {'id': '101060208', 'city': '龙潭', 'province': '吉林', 'leader': '吉林'}, {'id': '101060209', 'city': '船营', 'province': '吉林', 'leader': '吉林'}, {'id': '101060210', 'city': '丰满', 'province': '吉林', 'leader': '吉林'}, {'id': '101060301', 'city': '延吉', 'province': '吉林', 'leader': '延边'}, {'id': '101060302', 'city': '敦化', 'province': '吉林', 'leader': '延边'}, {'id': '101060303', 'city': '安图', 'province': '吉林', 'leader': '延边'}, {'id': '101060304', 'city': '汪清', 'province': '吉林', 'leader': '延边'}, {'id': '101060305', 'city': '和龙', 'province': '吉林', 'leader': '延边'}, {'id': '101060306', 'city': '延边', 'province': '吉林', 'leader': '延边'}, {'id': '101060307', 'city': '龙井', 'province': '吉林', 'leader': '延边'}, {'id': '101060308', 'city': '珲春', 'province': '吉林', 'leader': '延边'}, {'id': '101060309', 'city': '图们', 'province': '吉林', 'leader': '延边'}, {'id': '101060401', 'city': '四平', 'province': '吉林', 'leader': '四平'}, {'id': '101060402', 'city': '双辽', 'province': '吉林', 'leader': '四平'}, {'id': '101060403', 'city': '梨树', 'province': '吉林', 'leader': '四平'}, {'id': '101060404', 'city': '公主岭', 'province': '吉林', 'leader': '四平'}, {'id': '101060405', 'city': '伊通', 'province': '吉林', 'leader': '四平'}, {'id': '101060406', 'city': '铁西', 'province': '吉林', 'leader': '四平'}, {'id': '101060407', 'city': '铁东', 'province': '吉林', 'leader': '四平'}, {'id': '101060501', 'city': '通化', 'province': '吉林', 'leader': '通化'}, {'id': '101060502', 'city': '梅河口', 'province': '吉林', 'leader': '通化'}, {'id': '101060503', 'city': '柳河', 'province': '吉林', 'leader': '通化'}, {'id': '101060504', 'city': '辉南', 'province': '吉林', 'leader': '通化'}, {'id': '101060505', 'city': '集安', 'province': '吉林', 'leader': '通化'}, {'id': '101060506', 'city': '通化县', 'province': '吉林', 'leader': '通化'}, {'id': '101060507', 'city': '东昌', 'province': '吉林', 'leader': '通化'}, {'id': '101060508', 'city': '二道江', 'province': '吉林', 'leader': '通化'}, {'id': '101060601', 'city': '白城', 'province': '吉林', 'leader': '白城'}, {'id': '101060602', 'city': '洮南', 'province': '吉林', 'leader': '白城'}, {'id': '101060603', 'city': '大安', 'province': '吉林', 'leader': '白城'}, {'id': '101060604', 'city': '镇赉', 'province': '吉林', 'leader': '白城'}, {'id': '101060605', 'city': '通榆', 'province': '吉林', 'leader': '白城'}, {'id': '101060606', 'city': '洮北', 'province': '吉林', 'leader': '白城'}, {'id': '101060701', 'city': '辽源', 'province': '吉林', 'leader': '辽源'}, {'id': '101060702', 'city': '东丰', 'province': '吉林', 'leader': '辽源'}, {'id': '101060703', 'city': '东辽', 'province': '吉林', 'leader': '辽源'}, {'id': '101060704', 'city': '龙山', 'province': '吉林', 'leader': '辽源'}, {'id': '101060705', 'city': '西安', 'province': '吉林', 'leader': '辽源'}, {'id': '101060801', 'city': '松原', 'province': '吉林', 'leader': '松原'}, {'id': '101060802', 'city': '乾安', 'province': '吉林', 'leader': '松原'}, {'id': '101060803', 'city': '前郭', 'province': '吉林', 'leader': '松原'}, {'id': '101060804', 'city': '长岭', 'province': '吉林', 'leader': '松原'}, {'id': '101060805', 'city': '扶余', 'province': '吉林', 'leader': '松原'}, {'id': '101060806', 'city': '宁江', 'province': '吉林', 'leader': '松原'}, {'id': '101060901', 'city': '白山', 'province': '吉林', 'leader': '白山'}, {'id': '101060902', 'city': '靖宇', 'province': '吉林', 'leader': '白山'}, {'id': '101060903', 'city': '临江', 'province': '吉林', 'leader': '白山'}, {'id': '101060905', 'city': '长白', 'province': '吉林', 'leader': '白山'}, {'id': '101060906', 'city': '抚松', 'province': '吉林', 'leader': '白山'}, {'id': '101060907', 'city': '江源', 'province': '吉林', 'leader': '白山'}, {'id': '101060908', 'city': '浑江', 'province': '吉林', 'leader': '白山'}, {'id': '101070101', 'city': '沈阳', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070102', 'city': '浑南', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070103', 'city': '辽中', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070104', 'city': '康平', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070105', 'city': '法库', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070106', 'city': '新民', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070107', 'city': '和平', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070108', 'city': '沈河', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070109', 'city': '大东', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070110', 'city': '皇姑', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070111', 'city': '铁西', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070112', 'city': '苏家屯', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070113', 'city': '沈北新区', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070114', 'city': '于洪', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070115', 'city': '东陵', 'province': '辽宁', 'leader': '沈阳'}, {'id': '101070201', 'city': '大连', 'province': '辽宁', 'leader': '大连'}, {'id': '101070202', 'city': '瓦房店', 'province': '辽宁', 'leader': '大连'}, {'id': '101070203', 'city': '金州', 'province': '辽宁', 'leader': '大连'}, {'id': '101070204', 'city': '普兰店', 'province': '辽宁', 'leader': '大连'}, {'id': '101070205', 'city': '旅顺', 'province': '辽宁', 'leader': '大连'}, {'id': '101070206', 'city': '长海', 'province': '辽宁', 'leader': '大连'}, {'id': '101070207', 'city': '庄河', 'province': '辽宁', 'leader': '大连'}, {'id': '101070208', 'city': '中山', 'province': '辽宁', 'leader': '大连'}, {'id': '101070209', 'city': '西岗', 'province': '辽宁', 'leader': '大连'}, {'id': '101070210', 'city': '沙河口', 'province': '辽宁', 'leader': '大连'}, {'id': '101070211', 'city': '甘井子', 'province': '辽宁', 'leader': '大连'}, {'id': '101070301', 'city': '鞍山', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070302', 'city': '台安', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070303', 'city': '岫岩', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070304', 'city': '海城', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070305', 'city': '铁东', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070306', 'city': '铁西', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070307', 'city': '立山', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070308', 'city': '千山', 'province': '辽宁', 'leader': '鞍山'}, {'id': '101070401', 'city': '抚顺', 'province': '辽宁', 'leader': '抚顺'}, {'id': '101070402', 'city': '新宾', 'province': '辽宁', 'leader': '抚顺'}, {'id': '101070403', 'city': '清原', 'province': '辽宁', 'leader': '抚顺'}, {'id': '101070405', 'city': '新抚', 'province': '辽宁', 'leader': '抚顺'}, {'id': '101070406', 'city': '东洲', 'province': '辽宁', 'leader': '抚顺'}, {'id': '101070407', 'city': '望花', 'province': '辽宁', 'leader': '抚顺'}, {'id': '101070408', 'city': '顺城', 'province': '辽宁', 'leader': '抚顺'}, {'id': '101070501', 'city': '本溪', 'province': '辽宁', 'leader': '本溪'}, {'id': '101070502', 'city': '本溪县', 'province': '辽宁', 'leader': '本溪'}, {'id': '101070503', 'city': '平山', 'province': '辽宁', 'leader': '本溪'}, {'id': '101070504', 'city': '桓仁', 'province': '辽宁', 'leader': '本溪'}, {'id': '101070505', 'city': '溪湖', 'province': '辽宁', 'leader': '本溪'}, {'id': '101070506', 'city': '明山', 'province': '辽宁', 'leader': '本溪'}, {'id': '101070507', 'city': '南芬', 'province': '辽宁', 'leader': '本溪'}, {'id': '101070601', 'city': '丹东', 'province': '辽宁', 'leader': '丹东'}, {'id': '101070602', 'city': '凤城', 'province': '辽宁', 'leader': '丹东'}, {'id': '101070603', 'city': '宽甸', 'province': '辽宁', 'leader': '丹东'}, {'id': '101070604', 'city': '东港', 'province': '辽宁', 'leader': '丹东'}, {'id': '101070605', 'city': '元宝', 'province': '辽宁', 'leader': '丹东'}, {'id': '101070606', 'city': '振兴', 'province': '辽宁', 'leader': '丹东'}, {'id': '101070607', 'city': '振安', 'province': '辽宁', 'leader': '丹东'}, {'id': '101070701', 'city': '锦州', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070702', 'city': '凌海', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070703', 'city': '古塔', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070704', 'city': '义县', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070705', 'city': '黑山', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070706', 'city': '北镇', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070707', 'city': '凌河', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070708', 'city': '太和', 'province': '辽宁', 'leader': '锦州'}, {'id': '101070801', 'city': '营口', 'province': '辽宁', 'leader': '营口'}, {'id': '101070802', 'city': '大石桥', 'province': '辽宁', 'leader': '营口'}, {'id': '101070803', 'city': '盖州', 'province': '辽宁', 'leader': '营口'}, {'id': '101070804', 'city': '站前', 'province': '辽宁', 'leader': '营口'}, {'id': '101070805', 'city': '西市', 'province': '辽宁', 'leader': '营口'}, {'id': '101070806', 'city': '鲅鱼圈', 'province': '辽宁', 'leader': '营口'}, {'id': '101070807', 'city': '老边', 'province': '辽宁', 'leader': '营口'}, {'id': '101070901', 'city': '阜新', 'province': '辽宁', 'leader': '阜新'}, {'id': '101070902', 'city': '彰武', 'province': '辽宁', 'leader': '阜新'}, {'id': '101070903', 'city': '海州', 'province': '辽宁', 'leader': '阜新'}, {'id': '101070904', 'city': '新邱', 'province': '辽宁', 'leader': '阜新'}, {'id': '101070905', 'city': '太平', 'province': '辽宁', 'leader': '阜新'}, {'id': '101070906', 'city': '清河门', 'province': '辽宁', 'leader': '阜新'}, {'id': '101070907', 'city': '细河', 'province': '辽宁', 'leader': '阜新'}, {'id': '101071001', 'city': '辽阳', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071002', 'city': '辽阳县', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071003', 'city': '灯塔', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071004', 'city': '弓长岭', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071005', 'city': '白塔', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071006', 'city': '文圣', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071007', 'city': '宏伟', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071008', 'city': '太子河', 'province': '辽宁', 'leader': '辽阳'}, {'id': '101071101', 'city': '铁岭', 'province': '辽宁', 'leader': '铁岭'}, {'id': '101071102', 'city': '开原', 'province': '辽宁', 'leader': '铁岭'}, {'id': '101071103', 'city': '昌图', 'province': '辽宁', 'leader': '铁岭'}, {'id': '101071104', 'city': '西丰', 'province': '辽宁', 'leader': '铁岭'}, {'id': '101071105', 'city': '调兵山', 'province': '辽宁', 'leader': '铁岭'}, {'id': '101071106', 'city': '银州', 'province': '辽宁', 'leader': '铁岭'}, {'id': '101071107', 'city': '清河', 'province': '辽宁', 'leader': '铁岭'}, {'id': '101071201', 'city': '朝阳', 'province': '辽宁', 'leader': '朝阳'}, {'id': '101071202', 'city': '双塔', 'province': '辽宁', 'leader': '朝阳'}, {'id': '101071203', 'city': '凌源', 'province': '辽宁', 'leader': '朝阳'}, {'id': '101071204', 'city': '喀左', 'province': '辽宁', 'leader': '朝阳'}, {'id': '101071205', 'city': '北票', 'province': '辽宁', 'leader': '朝阳'}, {'id': '101071206', 'city': '龙城', 'province': '辽宁', 'leader': '朝阳'}, {'id': '101071207', 'city': '建平县', 'province': '辽宁', 'leader': '朝阳'}, {'id': '101071301', 'city': '盘锦', 'province': '辽宁', 'leader': '盘锦'}, {'id': '101071302', 'city': '大洼', 'province': '辽宁', 'leader': '盘锦'}, {'id': '101071303', 'city': '盘山', 'province': '辽宁', 'leader': '盘锦'}, {'id': '101071304', 'city': '双台子', 'province': '辽宁', 'leader': '盘锦'}, {'id': '101071305', 'city': '兴隆台', 'province': '辽宁', 'leader': '盘锦'}, {'id': '101071401', 'city': '葫芦岛', 'province': '辽宁', 'leader': '葫芦岛'}, {'id': '101071402', 'city': '建昌', 'province': '辽宁', 'leader': '葫芦岛'}, {'id': '101071403', 'city': '绥中', 'province': '辽宁', 'leader': '葫芦岛'}, {'id': '101071404', 'city': '兴城', 'province': '辽宁', 'leader': '葫芦岛'}, {'id': '101071405', 'city': '连山', 'province': '辽宁', 'leader': '葫芦岛'}, {'id': '101071406', 'city': '龙港', 'province': '辽宁', 'leader': '葫芦岛'}, {'id': '101071407', 'city': '南票', 'province': '辽宁', 'leader': '葫芦岛'}, {'id': '101080101', 'city': '呼和浩特', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080102', 'city': '土左旗', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080103', 'city': '托县', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080104', 'city': '和林', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080105', 'city': '清水河', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080106', 'city': '赛罕', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080107', 'city': '武川', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080108', 'city': '新城', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080109', 'city': '回民', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080110', 'city': '玉泉', 'province': '内蒙古', 'leader': '呼和浩特'}, {'id': '101080201', 'city': '包头', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080202', 'city': '白云鄂博', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080204', 'city': '土右旗', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080205', 'city': '固阳', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080206', 'city': '达茂旗', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080208', 'city': '东河', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080209', 'city': '昆都仑', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080210', 'city': '青山', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080211', 'city': '石拐', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080212', 'city': '九原', 'province': '内蒙古', 'leader': '包头'}, {'id': '101080301', 'city': '乌海', 'province': '内蒙古', 'leader': '乌海'}, {'id': '101080302', 'city': '海勃湾', 'province': '内蒙古', 'leader': '乌海'}, {'id': '101080303', 'city': '海南', 'province': '内蒙古', 'leader': '乌海'}, {'id': '101080304', 'city': '乌达', 'province': '内蒙古', 'leader': '乌海'}, {'id': '101080401', 'city': '集宁', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080402', 'city': '卓资', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080403', 'city': '化德', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080404', 'city': '商都', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080405', 'city': '乌兰察布', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080406', 'city': '兴和', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080407', 'city': '凉城', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080408', 'city': '察右前旗', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080409', 'city': '察右中旗', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080410', 'city': '察右后旗', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080411', 'city': '四子王旗', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080412', 'city': '丰镇', 'province': '内蒙古', 'leader': '乌兰察布'}, {'id': '101080501', 'city': '通辽', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080503', 'city': '科左中旗', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080504', 'city': '科左后旗', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080506', 'city': '开鲁', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080507', 'city': '库伦', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080508', 'city': '奈曼', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080509', 'city': '扎鲁特', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080510', 'city': '科尔沁', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080512', 'city': '霍林郭勒', 'province': '内蒙古', 'leader': '通辽'}, {'id': '101080601', 'city': '赤峰', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080602', 'city': '红山', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080603', 'city': '阿鲁旗', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080605', 'city': '巴林左旗', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080606', 'city': '巴林右旗', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080607', 'city': '林西', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080608', 'city': '克什克腾', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080609', 'city': '翁牛特', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080611', 'city': '喀喇沁', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080613', 'city': '宁城', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080614', 'city': '敖汉', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080616', 'city': '元宝山', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080617', 'city': '松山', 'province': '内蒙古', 'leader': '赤峰'}, {'id': '101080701', 'city': '鄂尔多斯', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080703', 'city': '达拉特', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080704', 'city': '准格尔', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080705', 'city': '鄂前旗', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080708', 'city': '鄂托克', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080709', 'city': '杭锦旗', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080710', 'city': '乌审旗', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080711', 'city': '伊金霍洛', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080713', 'city': '东胜', 'province': '内蒙古', 'leader': '鄂尔多斯'}, {'id': '101080801', 'city': '临河', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080802', 'city': '五原', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080803', 'city': '磴口', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080804', 'city': '乌前旗', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080806', 'city': '乌中旗', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080807', 'city': '乌后旗', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080810', 'city': '杭锦后旗', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080811', 'city': '巴彦淖尔', 'province': '内蒙古', 'leader': '巴彦淖尔'}, {'id': '101080901', 'city': '锡林浩特', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080902', 'city': '锡林郭勒', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080903', 'city': '二连浩特', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080904', 'city': '阿巴嘎', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080906', 'city': '苏左旗', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080907', 'city': '苏右旗', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080909', 'city': '东乌旗', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080910', 'city': '西乌旗', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080911', 'city': '太仆寺', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080912', 'city': '镶黄旗', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080913', 'city': '正镶白旗', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080914', 'city': '正蓝旗', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101080915', 'city': '多伦', 'province': '内蒙古', 'leader': '锡林郭勒'}, {'id': '101081001', 'city': '海拉尔', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081003', 'city': '阿荣旗', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081004', 'city': '莫力达瓦', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081005', 'city': '鄂伦春旗', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081006', 'city': '鄂温克旗', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081007', 'city': '陈旗', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081008', 'city': '新左旗', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081009', 'city': '新右旗', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081010', 'city': '满洲里', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081011', 'city': '牙克石', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081012', 'city': '扎兰屯', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081013', 'city': '呼伦贝尔', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081014', 'city': '额尔古纳', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081015', 'city': '根河', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081017', 'city': '扎赉诺尔', 'province': '内蒙古', 'leader': '呼伦贝尔'}, {'id': '101081101', 'city': '乌兰浩特', 'province': '内蒙古', 'leader': '兴安盟'}, {'id': '101081102', 'city': '阿尔山', 'province': '内蒙古', 'leader': '兴安盟'}, {'id': '101081103', 'city': '科右中旗', 'province': '内蒙古', 'leader': '兴安盟'}, {'id': '101081105', 'city': '扎赉特', 'province': '内蒙古', 'leader': '兴安盟'}, {'id': '101081107', 'city': '突泉', 'province': '内蒙古', 'leader': '兴安盟'}, {'id': '101081108', 'city': '兴安盟', 'province': '内蒙古', 'leader': '兴安盟'}, {'id': '101081109', 'city': '科右前旗', 'province': '内蒙古', 'leader': '兴安盟'}, {'id': '101081201', 'city': '阿左旗', 'province': '内蒙古', 'leader': '阿拉善盟'}, {'id': '101081202', 'city': '阿右旗', 'province': '内蒙古', 'leader': '阿拉善盟'}, {'id': '101081203', 'city': '额济纳', 'province': '内蒙古', 'leader': '阿拉善盟'}, {'id': '101081213', 'city': '阿拉善盟', 'province': '内蒙古', 'leader': '阿拉善盟'}, {'id': '101090101', 'city': '石家庄', 'province': '河北', 'leader': '石家庄'}, {'id': '101090102', 'city': '井陉', 'province': '河北', 'leader': '石家庄'}, {'id': '101090103', 'city': '正定', 'province': '河北', 'leader': '石家庄'}, {'id': '101090104', 'city': '栾城', 'province': '河北', 'leader': '石家庄'}, {'id': '101090105', 'city': '行唐', 'province': '河北', 'leader': '石家庄'}, {'id': '101090106', 'city': '灵寿', 'province': '河北', 'leader': '石家庄'}, {'id': '101090107', 'city': '高邑', 'province': '河北', 'leader': '石家庄'}, {'id': '101090108', 'city': '深泽', 'province': '河北', 'leader': '石家庄'}, {'id': '101090109', 'city': '赞皇', 'province': '河北', 'leader': '石家庄'}, {'id': '101090110', 'city': '无极', 'province': '河北', 'leader': '石家庄'}, {'id': '101090111', 'city': '平山', 'province': '河北', 'leader': '石家庄'}, {'id': '101090112', 'city': '元氏', 'province': '河北', 'leader': '石家庄'}, {'id': '101090113', 'city': '赵县', 'province': '河北', 'leader': '石家庄'}, {'id': '101090114', 'city': '辛集', 'province': '河北', 'leader': '石家庄'}, {'id': '101090115', 'city': '藁城', 'province': '河北', 'leader': '石家庄'}, {'id': '101090116', 'city': '晋州', 'province': '河北', 'leader': '石家庄'}, {'id': '101090117', 'city': '新乐', 'province': '河北', 'leader': '石家庄'}, {'id': '101090118', 'city': '鹿泉', 'province': '河北', 'leader': '石家庄'}, {'id': '101090119', 'city': '长安', 'province': '河北', 'leader': '石家庄'}, {'id': '101090120', 'city': '桥西', 'province': '河北', 'leader': '石家庄'}, {'id': '101090121', 'city': '新华', 'province': '河北', 'leader': '石家庄'}, {'id': '101090122', 'city': '井陉矿区', 'province': '河北', 'leader': '石家庄'}, {'id': '101090123', 'city': '裕华', 'province': '河北', 'leader': '石家庄'}, {'id': '101090201', 'city': '保定', 'province': '河北', 'leader': '保定'}, {'id': '101090202', 'city': '满城', 'province': '河北', 'leader': '保定'}, {'id': '101090203', 'city': '阜平', 'province': '河北', 'leader': '保定'}, {'id': '101090204', 'city': '徐水', 'province': '河北', 'leader': '保定'}, {'id': '101090205', 'city': '唐县', 'province': '河北', 'leader': '保定'}, {'id': '101090206', 'city': '高阳', 'province': '河北', 'leader': '保定'}, {'id': '101090207', 'city': '容城', 'province': '河北', 'leader': '保定'}, {'id': '101090208', 'city': '竞秀', 'province': '河北', 'leader': '保定'}, {'id': '101090209', 'city': '涞源', 'province': '河北', 'leader': '保定'}, {'id': '101090210', 'city': '望都', 'province': '河北', 'leader': '保定'}, {'id': '101090211', 'city': '安新', 'province': '河北', 'leader': '保定'}, {'id': '101090212', 'city': '易县', 'province': '河北', 'leader': '保定'}, {'id': '101090213', 'city': '莲池', 'province': '河北', 'leader': '保定'}, {'id': '101090214', 'city': '曲阳', 'province': '河北', 'leader': '保定'}, {'id': '101090215', 'city': '蠡县', 'province': '河北', 'leader': '保定'}, {'id': '101090216', 'city': '顺平', 'province': '河北', 'leader': '保定'}, {'id': '101090217', 'city': '雄县', 'province': '河北', 'leader': '保定'}, {'id': '101090218', 'city': '涿州', 'province': '河北', 'leader': '保定'}, {'id': '101090219', 'city': '定州', 'province': '河北', 'leader': '保定'}, {'id': '101090220', 'city': '安国', 'province': '河北', 'leader': '保定'}, {'id': '101090221', 'city': '高碑店', 'province': '河北', 'leader': '保定'}, {'id': '101090222', 'city': '涞水', 'province': '河北', 'leader': '保定'}, {'id': '101090223', 'city': '定兴', 'province': '河北', 'leader': '保定'}, {'id': '101090224', 'city': '清苑', 'province': '河北', 'leader': '保定'}, {'id': '101090225', 'city': '博野', 'province': '河北', 'leader': '保定'}, {'id': '101090226', 'city': '南市', 'province': '河北', 'leader': '保定'}, {'id': '101090301', 'city': '张家口', 'province': '河北', 'leader': '张家口'}, {'id': '101090302', 'city': '宣化', 'province': '河北', 'leader': '张家口'}, {'id': '101090303', 'city': '张北', 'province': '河北', 'leader': '张家口'}, {'id': '101090304', 'city': '康保', 'province': '河北', 'leader': '张家口'}, {'id': '101090305', 'city': '沽源', 'province': '河北', 'leader': '张家口'}, {'id': '101090306', 'city': '尚义', 'province': '河北', 'leader': '张家口'}, {'id': '101090307', 'city': '蔚县', 'province': '河北', 'leader': '张家口'}, {'id': '101090308', 'city': '阳原', 'province': '河北', 'leader': '张家口'}, {'id': '101090309', 'city': '怀安', 'province': '河北', 'leader': '张家口'}, {'id': '101090310', 'city': '万全', 'province': '河北', 'leader': '张家口'}, {'id': '101090311', 'city': '怀来', 'province': '河北', 'leader': '张家口'}, {'id': '101090312', 'city': '涿鹿', 'province': '河北', 'leader': '张家口'}, {'id': '101090313', 'city': '赤城', 'province': '河北', 'leader': '张家口'}, {'id': '101090314', 'city': '崇礼', 'province': '河北', 'leader': '张家口'}, {'id': '101090315', 'city': '桥东', 'province': '河北', 'leader': '张家口'}, {'id': '101090316', 'city': '桥西', 'province': '河北', 'leader': '张家口'}, {'id': '101090317', 'city': '下花园', 'province': '河北', 'leader': '张家口'}, {'id': '101090401', 'city': '双桥', 'province': '河北', 'leader': '承德'}, {'id': '101090402', 'city': '承德', 'province': '河北', 'leader': '承德'}, {'id': '101090403', 'city': '承德县', 'province': '河北', 'leader': '承德'}, {'id': '101090404', 'city': '兴隆', 'province': '河北', 'leader': '承德'}, {'id': '101090405', 'city': '平泉', 'province': '河北', 'leader': '承德'}, {'id': '101090406', 'city': '滦平', 'province': '河北', 'leader': '承德'}, {'id': '101090407', 'city': '隆化', 'province': '河北', 'leader': '承德'}, {'id': '101090408', 'city': '丰宁', 'province': '河北', 'leader': '承德'}, {'id': '101090409', 'city': '宽城', 'province': '河北', 'leader': '承德'}, {'id': '101090410', 'city': '围场', 'province': '河北', 'leader': '承德'}, {'id': '101090411', 'city': '双滦', 'province': '河北', 'leader': '承德'}, {'id': '101090412', 'city': '鹰手营子矿', 'province': '河北', 'leader': '承德'}, {'id': '101090501', 'city': '唐山', 'province': '河北', 'leader': '唐山'}, {'id': '101090502', 'city': '丰南', 'province': '河北', 'leader': '唐山'}, {'id': '101090503', 'city': '丰润', 'province': '河北', 'leader': '唐山'}, {'id': '101090504', 'city': '滦县', 'province': '河北', 'leader': '唐山'}, {'id': '101090505', 'city': '滦南', 'province': '河北', 'leader': '唐山'}, {'id': '101090506', 'city': '乐亭', 'province': '河北', 'leader': '唐山'}, {'id': '101090507', 'city': '迁西', 'province': '河北', 'leader': '唐山'}, {'id': '101090508', 'city': '玉田', 'province': '河北', 'leader': '唐山'}, {'id': '101090509', 'city': '曹妃甸', 'province': '河北', 'leader': '唐山'}, {'id': '101090510', 'city': '遵化', 'province': '河北', 'leader': '唐山'}, {'id': '101090511', 'city': '迁安', 'province': '河北', 'leader': '唐山'}, {'id': '101090513', 'city': '路南', 'province': '河北', 'leader': '唐山'}, {'id': '101090514', 'city': '路北', 'province': '河北', 'leader': '唐山'}, {'id': '101090515', 'city': '古冶', 'province': '河北', 'leader': '唐山'}, {'id': '101090516', 'city': '开平', 'province': '河北', 'leader': '唐山'}, {'id': '101090601', 'city': '廊坊', 'province': '河北', 'leader': '廊坊'}, {'id': '101090602', 'city': '固安', 'province': '河北', 'leader': '廊坊'}, {'id': '101090603', 'city': '永清', 'province': '河北', 'leader': '廊坊'}, {'id': '101090604', 'city': '香河', 'province': '河北', 'leader': '廊坊'}, {'id': '101090605', 'city': '大城', 'province': '河北', 'leader': '廊坊'}, {'id': '101090606', 'city': '文安', 'province': '河北', 'leader': '廊坊'}, {'id': '101090607', 'city': '大厂', 'province': '河北', 'leader': '廊坊'}, {'id': '101090608', 'city': '霸州', 'province': '河北', 'leader': '廊坊'}, {'id': '101090609', 'city': '三河', 'province': '河北', 'leader': '廊坊'}, {'id': '101090610', 'city': '安次', 'province': '河北', 'leader': '廊坊'}, {'id': '101090611', 'city': '广阳', 'province': '河北', 'leader': '廊坊'}, {'id': '101090701', 'city': '沧州', 'province': '河北', 'leader': '沧州'}, {'id': '101090702', 'city': '青县', 'province': '河北', 'leader': '沧州'}, {'id': '101090703', 'city': '东光', 'province': '河北', 'leader': '沧州'}, {'id': '101090704', 'city': '海兴', 'province': '河北', 'leader': '沧州'}, {'id': '101090705', 'city': '盐山', 'province': '河北', 'leader': '沧州'}, {'id': '101090706', 'city': '肃宁', 'province': '河北', 'leader': '沧州'}, {'id': '101090707', 'city': '南皮', 'province': '河北', 'leader': '沧州'}, {'id': '101090708', 'city': '吴桥', 'province': '河北', 'leader': '沧州'}, {'id': '101090709', 'city': '献县', 'province': '河北', 'leader': '沧州'}, {'id': '101090710', 'city': '孟村', 'province': '河北', 'leader': '沧州'}, {'id': '101090711', 'city': '泊头', 'province': '河北', 'leader': '沧州'}, {'id': '101090712', 'city': '任丘', 'province': '河北', 'leader': '沧州'}, {'id': '101090713', 'city': '黄骅', 'province': '河北', 'leader': '沧州'}, {'id': '101090714', 'city': '河间', 'province': '河北', 'leader': '沧州'}, {'id': '101090715', 'city': '新华', 'province': '河北', 'leader': '沧州'}, {'id': '101090716', 'city': '沧县', 'province': '河北', 'leader': '沧州'}, {'id': '101090717', 'city': '运河', 'province': '河北', 'leader': '沧州'}, {'id': '101090801', 'city': '衡水', 'province': '河北', 'leader': '衡水'}, {'id': '101090802', 'city': '枣强', 'province': '河北', 'leader': '衡水'}, {'id': '101090803', 'city': '武邑', 'province': '河北', 'leader': '衡水'}, {'id': '101090804', 'city': '武强', 'province': '河北', 'leader': '衡水'}, {'id': '101090805', 'city': '饶阳', 'province': '河北', 'leader': '衡水'}, {'id': '101090806', 'city': '安平', 'province': '河北', 'leader': '衡水'}, {'id': '101090807', 'city': '故城', 'province': '河北', 'leader': '衡水'}, {'id': '101090808', 'city': '景县', 'province': '河北', 'leader': '衡水'}, {'id': '101090809', 'city': '阜城', 'province': '河北', 'leader': '衡水'}, {'id': '101090810', 'city': '冀州', 'province': '河北', 'leader': '衡水'}, {'id': '101090811', 'city': '深州', 'province': '河北', 'leader': '衡水'}, {'id': '101090812', 'city': '桃城', 'province': '河北', 'leader': '衡水'}, {'id': '101090901', 'city': '邢台', 'province': '河北', 'leader': '邢台'}, {'id': '101090902', 'city': '临城', 'province': '河北', 'leader': '邢台'}, {'id': '101090903', 'city': '桥东', 'province': '河北', 'leader': '邢台'}, {'id': '101090904', 'city': '内丘', 'province': '河北', 'leader': '邢台'}, {'id': '101090905', 'city': '柏乡', 'province': '河北', 'leader': '邢台'}, {'id': '101090906', 'city': '隆尧', 'province': '河北', 'leader': '邢台'}, {'id': '101090907', 'city': '南和', 'province': '河北', 'leader': '邢台'}, {'id': '101090908', 'city': '宁晋', 'province': '河北', 'leader': '邢台'}, {'id': '101090909', 'city': '巨鹿', 'province': '河北', 'leader': '邢台'}, {'id': '101090910', 'city': '新河', 'province': '河北', 'leader': '邢台'}, {'id': '101090911', 'city': '广宗', 'province': '河北', 'leader': '邢台'}, {'id': '101090912', 'city': '平乡', 'province': '河北', 'leader': '邢台'}, {'id': '101090913', 'city': '威县', 'province': '河北', 'leader': '邢台'}, {'id': '101090914', 'city': '清河', 'province': '河北', 'leader': '邢台'}, {'id': '101090915', 'city': '临西', 'province': '河北', 'leader': '邢台'}, {'id': '101090916', 'city': '南宫', 'province': '河北', 'leader': '邢台'}, {'id': '101090917', 'city': '沙河', 'province': '河北', 'leader': '邢台'}, {'id': '101090918', 'city': '任县', 'province': '河北', 'leader': '邢台'}, {'id': '101090919', 'city': '桥西', 'province': '河北', 'leader': '邢台'}, {'id': '101091001', 'city': '邯郸', 'province': '河北', 'leader': '邯郸'}, {'id': '101091002', 'city': '峰峰', 'province': '河北', 'leader': '邯郸'}, {'id': '101091003', 'city': '临漳', 'province': '河北', 'leader': '邯郸'}, {'id': '101091004', 'city': '成安', 'province': '河北', 'leader': '邯郸'}, {'id': '101091005', 'city': '大名', 'province': '河北', 'leader': '邯郸'}, {'id': '101091006', 'city': '涉县', 'province': '河北', 'leader': '邯郸'}, {'id': '101091007', 'city': '磁县', 'province': '河北', 'leader': '邯郸'}, {'id': '101091008', 'city': '肥乡', 'province': '河北', 'leader': '邯郸'}, {'id': '101091009', 'city': '永年', 'province': '河北', 'leader': '邯郸'}, {'id': '101091010', 'city': '邱县', 'province': '河北', 'leader': '邯郸'}, {'id': '101091011', 'city': '鸡泽', 'province': '河北', 'leader': '邯郸'}, {'id': '101091012', 'city': '广平', 'province': '河北', 'leader': '邯郸'}, {'id': '101091013', 'city': '馆陶', 'province': '河北', 'leader': '邯郸'}, {'id': '101091014', 'city': '魏县', 'province': '河北', 'leader': '邯郸'}, {'id': '101091015', 'city': '曲周', 'province': '河北', 'leader': '邯郸'}, {'id': '101091016', 'city': '武安', 'province': '河北', 'leader': '邯郸'}, {'id': '101091017', 'city': '邯山', 'province': '河北', 'leader': '邯郸'}, {'id': '101091018', 'city': '丛台', 'province': '河北', 'leader': '邯郸'}, {'id': '101091019', 'city': '复兴', 'province': '河北', 'leader': '邯郸'}, {'id': '101091101', 'city': '秦皇岛', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101091102', 'city': '青龙', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101091103', 'city': '昌黎', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101091104', 'city': '抚宁', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101091105', 'city': '卢龙', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101091106', 'city': '北戴河', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101091107', 'city': '海港', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101091108', 'city': '山海关', 'province': '河北', 'leader': '秦皇岛'}, {'id': '101100101', 'city': '太原', 'province': '山西', 'leader': '太原'}, {'id': '101100102', 'city': '清徐', 'province': '山西', 'leader': '太原'}, {'id': '101100103', 'city': '阳曲', 'province': '山西', 'leader': '太原'}, {'id': '101100104', 'city': '娄烦', 'province': '山西', 'leader': '太原'}, {'id': '101100105', 'city': '古交', 'province': '山西', 'leader': '太原'}, {'id': '101100106', 'city': '尖草坪区', 'province': '山西', 'leader': '太原'}, {'id': '101100107', 'city': '小店区', 'province': '山西', 'leader': '太原'}, {'id': '101100108', 'city': '迎泽', 'province': '山西', 'leader': '太原'}, {'id': '101100109', 'city': '杏花岭', 'province': '山西', 'leader': '太原'}, {'id': '101100110', 'city': '万柏林', 'province': '山西', 'leader': '太原'}, {'id': '101100111', 'city': '晋源', 'province': '山西', 'leader': '太原'}, {'id': '101100201', 'city': '大同', 'province': '山西', 'leader': '大同'}, {'id': '101100202', 'city': '阳高', 'province': '山西', 'leader': '大同'}, {'id': '101100203', 'city': '大同县', 'province': '山西', 'leader': '大同'}, {'id': '101100204', 'city': '天镇', 'province': '山西', 'leader': '大同'}, {'id': '101100205', 'city': '广灵', 'province': '山西', 'leader': '大同'}, {'id': '101100206', 'city': '灵丘', 'province': '山西', 'leader': '大同'}, {'id': '101100207', 'city': '浑源', 'province': '山西', 'leader': '大同'}, {'id': '101100208', 'city': '左云', 'province': '山西', 'leader': '大同'}, {'id': '101100209', 'city': '矿区', 'province': '山西', 'leader': '大同'}, {'id': '101100210', 'city': '南郊', 'province': '山西', 'leader': '大同'}, {'id': '101100211', 'city': '新荣', 'province': '山西', 'leader': '大同'}, {'id': '101100301', 'city': '阳泉', 'province': '山西', 'leader': '阳泉'}, {'id': '101100302', 'city': '盂县', 'province': '山西', 'leader': '阳泉'}, {'id': '101100303', 'city': '平定', 'province': '山西', 'leader': '阳泉'}, {'id': '101100304', 'city': '矿区', 'province': '山西', 'leader': '阳泉'}, {'id': '101100305', 'city': '郊区', 'province': '山西', 'leader': '阳泉'}, {'id': '101100401', 'city': '晋中', 'province': '山西', 'leader': '晋中'}, {'id': '101100402', 'city': '榆次', 'province': '山西', 'leader': '晋中'}, {'id': '101100403', 'city': '榆社', 'province': '山西', 'leader': '晋中'}, {'id': '101100404', 'city': '左权', 'province': '山西', 'leader': '晋中'}, {'id': '101100405', 'city': '和顺', 'province': '山西', 'leader': '晋中'}, {'id': '101100406', 'city': '昔阳', 'province': '山西', 'leader': '晋中'}, {'id': '101100407', 'city': '寿阳', 'province': '山西', 'leader': '晋中'}, {'id': '101100408', 'city': '太谷', 'province': '山西', 'leader': '晋中'}, {'id': '101100409', 'city': '祁县', 'province': '山西', 'leader': '晋中'}, {'id': '101100410', 'city': '平遥', 'province': '山西', 'leader': '晋中'}, {'id': '101100411', 'city': '灵石', 'province': '山西', 'leader': '晋中'}, {'id': '101100412', 'city': '介休', 'province': '山西', 'leader': '晋中'}, {'id': '101100501', 'city': '长治', 'province': '山西', 'leader': '长治'}, {'id': '101100502', 'city': '黎城', 'province': '山西', 'leader': '长治'}, {'id': '101100503', 'city': '屯留', 'province': '山西', 'leader': '长治'}, {'id': '101100504', 'city': '潞城', 'province': '山西', 'leader': '长治'}, {'id': '101100505', 'city': '襄垣', 'province': '山西', 'leader': '长治'}, {'id': '101100506', 'city': '平顺', 'province': '山西', 'leader': '长治'}, {'id': '101100507', 'city': '武乡', 'province': '山西', 'leader': '长治'}, {'id': '101100508', 'city': '沁县', 'province': '山西', 'leader': '长治'}, {'id': '101100509', 'city': '长子', 'province': '山西', 'leader': '长治'}, {'id': '101100510', 'city': '沁源', 'province': '山西', 'leader': '长治'}, {'id': '101100511', 'city': '壶关', 'province': '山西', 'leader': '长治'}, {'id': '101100512', 'city': '郊区', 'province': '山西', 'leader': '长治'}, {'id': '101100601', 'city': '晋城', 'province': '山西', 'leader': '晋城'}, {'id': '101100602', 'city': '沁水', 'province': '山西', 'leader': '晋城'}, {'id': '101100603', 'city': '阳城', 'province': '山西', 'leader': '晋城'}, {'id': '101100604', 'city': '陵川', 'province': '山西', 'leader': '晋城'}, {'id': '101100605', 'city': '高平', 'province': '山西', 'leader': '晋城'}, {'id': '101100606', 'city': '泽州', 'province': '山西', 'leader': '晋城'}, {'id': '101100701', 'city': '临汾', 'province': '山西', 'leader': '临汾'}, {'id': '101100702', 'city': '曲沃', 'province': '山西', 'leader': '临汾'}, {'id': '101100703', 'city': '永和', 'province': '山西', 'leader': '临汾'}, {'id': '101100704', 'city': '隰县', 'province': '山西', 'leader': '临汾'}, {'id': '101100705', 'city': '大宁', 'province': '山西', 'leader': '临汾'}, {'id': '101100706', 'city': '吉县', 'province': '山西', 'leader': '临汾'}, {'id': '101100707', 'city': '襄汾', 'province': '山西', 'leader': '临汾'}, {'id': '101100708', 'city': '蒲县', 'province': '山西', 'leader': '临汾'}, {'id': '101100709', 'city': '汾西', 'province': '山西', 'leader': '临汾'}, {'id': '101100710', 'city': '洪洞', 'province': '山西', 'leader': '临汾'}, {'id': '101100711', 'city': '霍州', 'province': '山西', 'leader': '临汾'}, {'id': '101100712', 'city': '乡宁', 'province': '山西', 'leader': '临汾'}, {'id': '101100713', 'city': '翼城', 'province': '山西', 'leader': '临汾'}, {'id': '101100714', 'city': '侯马', 'province': '山西', 'leader': '临汾'}, {'id': '101100715', 'city': '浮山', 'province': '山西', 'leader': '临汾'}, {'id': '101100716', 'city': '安泽', 'province': '山西', 'leader': '临汾'}, {'id': '101100717', 'city': '古县', 'province': '山西', 'leader': '临汾'}, {'id': '101100718', 'city': '尧都', 'province': '山西', 'leader': '临汾'}, {'id': '101100801', 'city': '运城', 'province': '山西', 'leader': '运城'}, {'id': '101100802', 'city': '临猗', 'province': '山西', 'leader': '运城'}, {'id': '101100803', 'city': '稷山', 'province': '山西', 'leader': '运城'}, {'id': '101100804', 'city': '万荣', 'province': '山西', 'leader': '运城'}, {'id': '101100805', 'city': '河津', 'province': '山西', 'leader': '运城'}, {'id': '101100806', 'city': '新绛', 'province': '山西', 'leader': '运城'}, {'id': '101100807', 'city': '绛县', 'province': '山西', 'leader': '运城'}, {'id': '101100808', 'city': '闻喜', 'province': '山西', 'leader': '运城'}, {'id': '101100809', 'city': '垣曲', 'province': '山西', 'leader': '运城'}, {'id': '101100810', 'city': '永济', 'province': '山西', 'leader': '运城'}, {'id': '101100811', 'city': '芮城', 'province': '山西', 'leader': '运城'}, {'id': '101100812', 'city': '夏县', 'province': '山西', 'leader': '运城'}, {'id': '101100813', 'city': '平陆', 'province': '山西', 'leader': '运城'}, {'id': '101100814', 'city': '盐湖', 'province': '山西', 'leader': '运城'}, {'id': '101100901', 'city': '朔州', 'province': '山西', 'leader': '朔州'}, {'id': '101100902', 'city': '平鲁', 'province': '山西', 'leader': '朔州'}, {'id': '101100903', 'city': '山阴', 'province': '山西', 'leader': '朔州'}, {'id': '101100904', 'city': '右玉', 'province': '山西', 'leader': '朔州'}, {'id': '101100905', 'city': '应县', 'province': '山西', 'leader': '朔州'}, {'id': '101100906', 'city': '怀仁', 'province': '山西', 'leader': '朔州'}, {'id': '101100907', 'city': '朔城', 'province': '山西', 'leader': '朔州'}, {'id': '101101001', 'city': '忻州', 'province': '山西', 'leader': '忻州'}, {'id': '101101002', 'city': '定襄', 'province': '山西', 'leader': '忻州'}, {'id': '101101003', 'city': '五台县', 'province': '山西', 'leader': '忻州'}, {'id': '101101004', 'city': '河曲', 'province': '山西', 'leader': '忻州'}, {'id': '101101005', 'city': '偏关', 'province': '山西', 'leader': '忻州'}, {'id': '101101006', 'city': '神池', 'province': '山西', 'leader': '忻州'}, {'id': '101101007', 'city': '宁武', 'province': '山西', 'leader': '忻州'}, {'id': '101101008', 'city': '代县', 'province': '山西', 'leader': '忻州'}, {'id': '101101009', 'city': '繁峙', 'province': '山西', 'leader': '忻州'}, {'id': '101101011', 'city': '保德', 'province': '山西', 'leader': '忻州'}, {'id': '101101012', 'city': '静乐', 'province': '山西', 'leader': '忻州'}, {'id': '101101013', 'city': '岢岚', 'province': '山西', 'leader': '忻州'}, {'id': '101101014', 'city': '五寨', 'province': '山西', 'leader': '忻州'}, {'id': '101101015', 'city': '原平', 'province': '山西', 'leader': '忻州'}, {'id': '101101016', 'city': '忻府', 'province': '山西', 'leader': '忻州'}, {'id': '101101100', 'city': '吕梁', 'province': '山西', 'leader': '吕梁'}, {'id': '101101101', 'city': '离石', 'province': '山西', 'leader': '吕梁'}, {'id': '101101102', 'city': '临县', 'province': '山西', 'leader': '吕梁'}, {'id': '101101103', 'city': '兴县', 'province': '山西', 'leader': '吕梁'}, {'id': '101101104', 'city': '岚县', 'province': '山西', 'leader': '吕梁'}, {'id': '101101105', 'city': '柳林', 'province': '山西', 'leader': '吕梁'}, {'id': '101101106', 'city': '石楼', 'province': '山西', 'leader': '吕梁'}, {'id': '101101107', 'city': '方山', 'province': '山西', 'leader': '吕梁'}, {'id': '101101108', 'city': '交口', 'province': '山西', 'leader': '吕梁'}, {'id': '101101109', 'city': '中阳', 'province': '山西', 'leader': '吕梁'}, {'id': '101101110', 'city': '孝义', 'province': '山西', 'leader': '吕梁'}, {'id': '101101111', 'city': '汾阳', 'province': '山西', 'leader': '吕梁'}, {'id': '101101112', 'city': '文水', 'province': '山西', 'leader': '吕梁'}, {'id': '101101113', 'city': '交城', 'province': '山西', 'leader': '吕梁'}, {'id': '101110101', 'city': '西安', 'province': '陕西', 'leader': '西安'}, {'id': '101110102', 'city': '长安', 'province': '陕西', 'leader': '西安'}, {'id': '101110103', 'city': '临潼', 'province': '陕西', 'leader': '西安'}, {'id': '101110104', 'city': '蓝田', 'province': '陕西', 'leader': '西安'}, {'id': '101110105', 'city': '周至', 'province': '陕西', 'leader': '西安'}, {'id': '101110106', 'city': '户县', 'province': '陕西', 'leader': '西安'}, {'id': '101110107', 'city': '高陵', 'province': '陕西', 'leader': '西安'}, {'id': '101110108', 'city': '新城', 'province': '陕西', 'leader': '西安'}, {'id': '101110109', 'city': '碑林', 'province': '陕西', 'leader': '西安'}, {'id': '101110110', 'city': '莲湖', 'province': '陕西', 'leader': '西安'}, {'id': '101110111', 'city': '灞桥', 'province': '陕西', 'leader': '西安'}, {'id': '101110112', 'city': '未央', 'province': '陕西', 'leader': '西安'}, {'id': '101110113', 'city': '雁塔', 'province': '陕西', 'leader': '西安'}, {'id': '101110114', 'city': '阎良', 'province': '陕西', 'leader': '西安'}, {'id': '101110200', 'city': '咸阳', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110201', 'city': '三原', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110202', 'city': '礼泉', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110203', 'city': '永寿', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110204', 'city': '淳化', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110205', 'city': '泾阳', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110206', 'city': '武功', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110207', 'city': '乾县', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110208', 'city': '彬县', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110209', 'city': '长武', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110210', 'city': '旬邑', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110211', 'city': '兴平', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110212', 'city': '秦都', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110213', 'city': '渭城', 'province': '陕西', 'leader': '咸阳'}, {'id': '101110300', 'city': '延安', 'province': '陕西', 'leader': '延安'}, {'id': '101110301', 'city': '延长', 'province': '陕西', 'leader': '延安'}, {'id': '101110302', 'city': '延川', 'province': '陕西', 'leader': '延安'}, {'id': '101110303', 'city': '子长', 'province': '陕西', 'leader': '延安'}, {'id': '101110304', 'city': '宜川', 'province': '陕西', 'leader': '延安'}, {'id': '101110305', 'city': '富县', 'province': '陕西', 'leader': '延安'}, {'id': '101110306', 'city': '志丹', 'province': '陕西', 'leader': '延安'}, {'id': '101110307', 'city': '安塞', 'province': '陕西', 'leader': '延安'}, {'id': '101110308', 'city': '甘泉', 'province': '陕西', 'leader': '延安'}, {'id': '101110309', 'city': '洛川', 'province': '陕西', 'leader': '延安'}, {'id': '101110310', 'city': '黄陵', 'province': '陕西', 'leader': '延安'}, {'id': '101110311', 'city': '黄龙', 'province': '陕西', 'leader': '延安'}, {'id': '101110312', 'city': '吴起', 'province': '陕西', 'leader': '延安'}, {'id': '101110313', 'city': '宝塔', 'province': '陕西', 'leader': '延安'}, {'id': '101110401', 'city': '榆林', 'province': '陕西', 'leader': '榆林'}, {'id': '101110402', 'city': '府谷', 'province': '陕西', 'leader': '榆林'}, {'id': '101110403', 'city': '神木', 'province': '陕西', 'leader': '榆林'}, {'id': '101110404', 'city': '佳县', 'province': '陕西', 'leader': '榆林'}, {'id': '101110405', 'city': '定边', 'province': '陕西', 'leader': '榆林'}, {'id': '101110406', 'city': '靖边', 'province': '陕西', 'leader': '榆林'}, {'id': '101110407', 'city': '横山', 'province': '陕西', 'leader': '榆林'}, {'id': '101110408', 'city': '米脂', 'province': '陕西', 'leader': '榆林'}, {'id': '101110409', 'city': '子洲', 'province': '陕西', 'leader': '榆林'}, {'id': '101110410', 'city': '绥德', 'province': '陕西', 'leader': '榆林'}, {'id': '101110411', 'city': '吴堡', 'province': '陕西', 'leader': '榆林'}, {'id': '101110412', 'city': '清涧', 'province': '陕西', 'leader': '榆林'}, {'id': '101110413', 'city': '榆阳', 'province': '陕西', 'leader': '榆林'}, {'id': '101110501', 'city': '渭南', 'province': '陕西', 'leader': '渭南'}, {'id': '101110502', 'city': '华县', 'province': '陕西', 'leader': '渭南'}, {'id': '101110503', 'city': '潼关', 'province': '陕西', 'leader': '渭南'}, {'id': '101110504', 'city': '大荔', 'province': '陕西', 'leader': '渭南'}, {'id': '101110505', 'city': '白水', 'province': '陕西', 'leader': '渭南'}, {'id': '101110506', 'city': '富平', 'province': '陕西', 'leader': '渭南'}, {'id': '101110507', 'city': '蒲城', 'province': '陕西', 'leader': '渭南'}, {'id': '101110508', 'city': '澄城', 'province': '陕西', 'leader': '渭南'}, {'id': '101110509', 'city': '合阳', 'province': '陕西', 'leader': '渭南'}, {'id': '101110510', 'city': '韩城', 'province': '陕西', 'leader': '渭南'}, {'id': '101110511', 'city': '华阴', 'province': '陕西', 'leader': '渭南'}, {'id': '101110512', 'city': '临渭', 'province': '陕西', 'leader': '渭南'}, {'id': '101110513', 'city': '华州', 'province': '陕西', 'leader': '渭南'}, {'id': '101110601', 'city': '商洛', 'province': '陕西', 'leader': '商洛'}, {'id': '101110602', 'city': '洛南', 'province': '陕西', 'leader': '商洛'}, {'id': '101110603', 'city': '柞水', 'province': '陕西', 'leader': '商洛'}, {'id': '101110604', 'city': '商州', 'province': '陕西', 'leader': '商洛'}, {'id': '101110605', 'city': '镇安', 'province': '陕西', 'leader': '商洛'}, {'id': '101110606', 'city': '丹凤', 'province': '陕西', 'leader': '商洛'}, {'id': '101110607', 'city': '商南', 'province': '陕西', 'leader': '商洛'}, {'id': '101110608', 'city': '山阳', 'province': '陕西', 'leader': '商洛'}, {'id': '101110701', 'city': '安康', 'province': '陕西', 'leader': '安康'}, {'id': '101110702', 'city': '紫阳', 'province': '陕西', 'leader': '安康'}, {'id': '101110703', 'city': '石泉', 'province': '陕西', 'leader': '安康'}, {'id': '101110704', 'city': '汉阴', 'province': '陕西', 'leader': '安康'}, {'id': '101110705', 'city': '旬阳', 'province': '陕西', 'leader': '安康'}, {'id': '101110706', 'city': '岚皋', 'province': '陕西', 'leader': '安康'}, {'id': '101110707', 'city': '平利', 'province': '陕西', 'leader': '安康'}, {'id': '101110708', 'city': '白河', 'province': '陕西', 'leader': '安康'}, {'id': '101110709', 'city': '镇坪', 'province': '陕西', 'leader': '安康'}, {'id': '101110710', 'city': '宁陕', 'province': '陕西', 'leader': '安康'}, {'id': '101110711', 'city': '汉滨', 'province': '陕西', 'leader': '安康'}, {'id': '101110801', 'city': '汉中', 'province': '陕西', 'leader': '汉中'}, {'id': '101110802', 'city': '略阳', 'province': '陕西', 'leader': '汉中'}, {'id': '101110803', 'city': '勉县', 'province': '陕西', 'leader': '汉中'}, {'id': '101110804', 'city': '留坝', 'province': '陕西', 'leader': '汉中'}, {'id': '101110805', 'city': '洋县', 'province': '陕西', 'leader': '汉中'}, {'id': '101110806', 'city': '城固', 'province': '陕西', 'leader': '汉中'}, {'id': '101110807', 'city': '西乡', 'province': '陕西', 'leader': '汉中'}, {'id': '101110808', 'city': '佛坪', 'province': '陕西', 'leader': '汉中'}, {'id': '101110809', 'city': '宁强', 'province': '陕西', 'leader': '汉中'}, {'id': '101110810', 'city': '南郑', 'province': '陕西', 'leader': '汉中'}, {'id': '101110811', 'city': '镇巴', 'province': '陕西', 'leader': '汉中'}, {'id': '101110812', 'city': '汉台', 'province': '陕西', 'leader': '汉中'}, {'id': '101110901', 'city': '宝鸡', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110902', 'city': '渭滨', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110903', 'city': '千阳', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110904', 'city': '麟游', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110905', 'city': '岐山', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110906', 'city': '凤翔', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110907', 'city': '扶风', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110908', 'city': '眉县', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110909', 'city': '太白', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110910', 'city': '凤县', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110911', 'city': '陇县', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110912', 'city': '陈仓', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101110913', 'city': '金台', 'province': '陕西', 'leader': '宝鸡'}, {'id': '101111001', 'city': '铜川', 'province': '陕西', 'leader': '铜川'}, {'id': '101111003', 'city': '宜君', 'province': '陕西', 'leader': '铜川'}, {'id': '101111004', 'city': '耀州', 'province': '陕西', 'leader': '铜川'}, {'id': '101111005', 'city': '王益', 'province': '陕西', 'leader': '铜川'}, {'id': '101111006', 'city': '印台', 'province': '陕西', 'leader': '铜川'}, {'id': '101111101', 'city': '杨凌', 'province': '陕西', 'leader': '杨凌'}, {'id': '101111102', 'city': '杨陵', 'province': '陕西', 'leader': '杨凌'}, {'id': '101120101', 'city': '济南', 'province': '山东', 'leader': '济南'}, {'id': '101120102', 'city': '长清', 'province': '山东', 'leader': '济南'}, {'id': '101120103', 'city': '商河', 'province': '山东', 'leader': '济南'}, {'id': '101120104', 'city': '章丘', 'province': '山东', 'leader': '济南'}, {'id': '101120105', 'city': '平阴', 'province': '山东', 'leader': '济南'}, {'id': '101120106', 'city': '济阳', 'province': '山东', 'leader': '济南'}, {'id': '101120107', 'city': '历下', 'province': '山东', 'leader': '济南'}, {'id': '101120108', 'city': '市中', 'province': '山东', 'leader': '济南'}, {'id': '101120109', 'city': '槐荫', 'province': '山东', 'leader': '济南'}, {'id': '101120110', 'city': '天桥', 'province': '山东', 'leader': '济南'}, {'id': '101120111', 'city': '历城', 'province': '山东', 'leader': '济南'}, {'id': '101120201', 'city': '青岛', 'province': '山东', 'leader': '青岛'}, {'id': '101120202', 'city': '崂山', 'province': '山东', 'leader': '青岛'}, {'id': '101120203', 'city': '市南', 'province': '山东', 'leader': '青岛'}, {'id': '101120204', 'city': '即墨', 'province': '山东', 'leader': '青岛'}, {'id': '101120205', 'city': '胶州', 'province': '山东', 'leader': '青岛'}, {'id': '101120206', 'city': '黄岛', 'province': '山东', 'leader': '青岛'}, {'id': '101120207', 'city': '莱西', 'province': '山东', 'leader': '青岛'}, {'id': '101120208', 'city': '平度', 'province': '山东', 'leader': '青岛'}, {'id': '101120209', 'city': '市北', 'province': '山东', 'leader': '青岛'}, {'id': '101120210', 'city': '李沧', 'province': '山东', 'leader': '青岛'}, {'id': '101120211', 'city': '城阳', 'province': '山东', 'leader': '青岛'}, {'id': '101120301', 'city': '淄博', 'province': '山东', 'leader': '淄博'}, {'id': '101120302', 'city': '淄川', 'province': '山东', 'leader': '淄博'}, {'id': '101120303', 'city': '博山', 'province': '山东', 'leader': '淄博'}, {'id': '101120304', 'city': '高青', 'province': '山东', 'leader': '淄博'}, {'id': '101120305', 'city': '周村', 'province': '山东', 'leader': '淄博'}, {'id': '101120306', 'city': '沂源', 'province': '山东', 'leader': '淄博'}, {'id': '101120307', 'city': '桓台', 'province': '山东', 'leader': '淄博'}, {'id': '101120308', 'city': '临淄', 'province': '山东', 'leader': '淄博'}, {'id': '101120309', 'city': '张店', 'province': '山东', 'leader': '淄博'}, {'id': '101120401', 'city': '德州', 'province': '山东', 'leader': '德州'}, {'id': '101120402', 'city': '武城', 'province': '山东', 'leader': '德州'}, {'id': '101120403', 'city': '临邑', 'province': '山东', 'leader': '德州'}, {'id': '101120405', 'city': '齐河', 'province': '山东', 'leader': '德州'}, {'id': '101120406', 'city': '乐陵', 'province': '山东', 'leader': '德州'}, {'id': '101120407', 'city': '庆云', 'province': '山东', 'leader': '德州'}, {'id': '101120408', 'city': '平原', 'province': '山东', 'leader': '德州'}, {'id': '101120409', 'city': '宁津', 'province': '山东', 'leader': '德州'}, {'id': '101120410', 'city': '夏津', 'province': '山东', 'leader': '德州'}, {'id': '101120411', 'city': '禹城', 'province': '山东', 'leader': '德州'}, {'id': '101120412', 'city': '德城', 'province': '山东', 'leader': '德州'}, {'id': '101120413', 'city': '陵城', 'province': '山东', 'leader': '德州'}, {'id': '101120501', 'city': '烟台', 'province': '山东', 'leader': '烟台'}, {'id': '101120502', 'city': '莱州', 'province': '山东', 'leader': '烟台'}, {'id': '101120503', 'city': '长岛', 'province': '山东', 'leader': '烟台'}, {'id': '101120504', 'city': '蓬莱', 'province': '山东', 'leader': '烟台'}, {'id': '101120505', 'city': '龙口', 'province': '山东', 'leader': '烟台'}, {'id': '101120506', 'city': '招远', 'province': '山东', 'leader': '烟台'}, {'id': '101120507', 'city': '栖霞', 'province': '山东', 'leader': '烟台'}, {'id': '101120508', 'city': '福山', 'province': '山东', 'leader': '烟台'}, {'id': '101120509', 'city': '牟平', 'province': '山东', 'leader': '烟台'}, {'id': '101120510', 'city': '莱阳', 'province': '山东', 'leader': '烟台'}, {'id': '101120511', 'city': '海阳', 'province': '山东', 'leader': '烟台'}, {'id': '101120512', 'city': '芝罘', 'province': '山东', 'leader': '烟台'}, {'id': '101120513', 'city': '莱山', 'province': '山东', 'leader': '烟台'}, {'id': '101120601', 'city': '潍坊', 'province': '山东', 'leader': '潍坊'}, {'id': '101120602', 'city': '青州', 'province': '山东', 'leader': '潍坊'}, {'id': '101120603', 'city': '寿光', 'province': '山东', 'leader': '潍坊'}, {'id': '101120604', 'city': '临朐', 'province': '山东', 'leader': '潍坊'}, {'id': '101120605', 'city': '昌乐', 'province': '山东', 'leader': '潍坊'}, {'id': '101120606', 'city': '昌邑', 'province': '山东', 'leader': '潍坊'}, {'id': '101120607', 'city': '安丘', 'province': '山东', 'leader': '潍坊'}, {'id': '101120608', 'city': '高密', 'province': '山东', 'leader': '潍坊'}, {'id': '101120609', 'city': '诸城', 'province': '山东', 'leader': '潍坊'}, {'id': '101120610', 'city': '潍城', 'province': '山东', 'leader': '潍坊'}, {'id': '101120611', 'city': '寒亭', 'province': '山东', 'leader': '潍坊'}, {'id': '101120612', 'city': '坊子', 'province': '山东', 'leader': '潍坊'}, {'id': '101120613', 'city': '奎文', 'province': '山东', 'leader': '潍坊'}, {'id': '101120701', 'city': '济宁', 'province': '山东', 'leader': '济宁'}, {'id': '101120702', 'city': '嘉祥', 'province': '山东', 'leader': '济宁'}, {'id': '101120703', 'city': '微山', 'province': '山东', 'leader': '济宁'}, {'id': '101120704', 'city': '鱼台', 'province': '山东', 'leader': '济宁'}, {'id': '101120705', 'city': '兖州', 'province': '山东', 'leader': '济宁'}, {'id': '101120706', 'city': '金乡', 'province': '山东', 'leader': '济宁'}, {'id': '101120707', 'city': '汶上', 'province': '山东', 'leader': '济宁'}, {'id': '101120708', 'city': '泗水', 'province': '山东', 'leader': '济宁'}, {'id': '101120709', 'city': '梁山', 'province': '山东', 'leader': '济宁'}, {'id': '101120710', 'city': '曲阜', 'province': '山东', 'leader': '济宁'}, {'id': '101120711', 'city': '邹城', 'province': '山东', 'leader': '济宁'}, {'id': '101120712', 'city': '任城', 'province': '山东', 'leader': '济宁'}, {'id': '101120801', 'city': '泰安', 'province': '山东', 'leader': '泰安'}, {'id': '101120802', 'city': '新泰', 'province': '山东', 'leader': '泰安'}, {'id': '101120803', 'city': '泰山', 'province': '山东', 'leader': '泰安'}, {'id': '101120804', 'city': '肥城', 'province': '山东', 'leader': '泰安'}, {'id': '101120805', 'city': '东平', 'province': '山东', 'leader': '泰安'}, {'id': '101120806', 'city': '宁阳', 'province': '山东', 'leader': '泰安'}, {'id': '101120807', 'city': '岱岳', 'province': '山东', 'leader': '泰安'}, {'id': '101120901', 'city': '临沂', 'province': '山东', 'leader': '临沂'}, {'id': '101120902', 'city': '莒南', 'province': '山东', 'leader': '临沂'}, {'id': '101120903', 'city': '沂南', 'province': '山东', 'leader': '临沂'}, {'id': '101120904', 'city': '兰陵', 'province': '山东', 'leader': '临沂'}, {'id': '101120905', 'city': '临沭', 'province': '山东', 'leader': '临沂'}, {'id': '101120906', 'city': '郯城', 'province': '山东', 'leader': '临沂'}, {'id': '101120907', 'city': '蒙阴', 'province': '山东', 'leader': '临沂'}, {'id': '101120908', 'city': '平邑', 'province': '山东', 'leader': '临沂'}, {'id': '101120909', 'city': '费县', 'province': '山东', 'leader': '临沂'}, {'id': '101120910', 'city': '沂水', 'province': '山东', 'leader': '临沂'}, {'id': '101120911', 'city': '兰山', 'province': '山东', 'leader': '临沂'}, {'id': '101120912', 'city': '罗庄', 'province': '山东', 'leader': '临沂'}, {'id': '101120913', 'city': '河东', 'province': '山东', 'leader': '临沂'}, {'id': '101121001', 'city': '菏泽', 'province': '山东', 'leader': '菏泽'}, {'id': '101121002', 'city': '鄄城', 'province': '山东', 'leader': '菏泽'}, {'id': '101121003', 'city': '郓城', 'province': '山东', 'leader': '菏泽'}, {'id': '101121004', 'city': '东明', 'province': '山东', 'leader': '菏泽'}, {'id': '101121005', 'city': '定陶', 'province': '山东', 'leader': '菏泽'}, {'id': '101121006', 'city': '巨野', 'province': '山东', 'leader': '菏泽'}, {'id': '101121007', 'city': '曹县', 'province': '山东', 'leader': '菏泽'}, {'id': '101121008', 'city': '成武', 'province': '山东', 'leader': '菏泽'}, {'id': '101121009', 'city': '单县', 'province': '山东', 'leader': '菏泽'}, {'id': '101121010', 'city': '牡丹', 'province': '山东', 'leader': '菏泽'}, {'id': '101121101', 'city': '滨州', 'province': '山东', 'leader': '滨州'}, {'id': '101121102', 'city': '博兴', 'province': '山东', 'leader': '滨州'}, {'id': '101121103', 'city': '无棣', 'province': '山东', 'leader': '滨州'}, {'id': '101121104', 'city': '阳信', 'province': '山东', 'leader': '滨州'}, {'id': '101121105', 'city': '惠民', 'province': '山东', 'leader': '滨州'}, {'id': '101121106', 'city': '沾化', 'province': '山东', 'leader': '滨州'}, {'id': '101121107', 'city': '邹平', 'province': '山东', 'leader': '滨州'}, {'id': '101121108', 'city': '滨城', 'province': '山东', 'leader': '滨州'}, {'id': '101121201', 'city': '东营', 'province': '山东', 'leader': '东营'}, {'id': '101121202', 'city': '河口', 'province': '山东', 'leader': '东营'}, {'id': '101121203', 'city': '垦利', 'province': '山东', 'leader': '东营'}, {'id': '101121204', 'city': '利津', 'province': '山东', 'leader': '东营'}, {'id': '101121205', 'city': '广饶', 'province': '山东', 'leader': '东营'}, {'id': '101121301', 'city': '威海', 'province': '山东', 'leader': '威海'}, {'id': '101121302', 'city': '文登', 'province': '山东', 'leader': '威海'}, {'id': '101121303', 'city': '荣成', 'province': '山东', 'leader': '威海'}, {'id': '101121304', 'city': '乳山', 'province': '山东', 'leader': '威海'}, {'id': '101121307', 'city': '环翠', 'province': '山东', 'leader': '威海'}, {'id': '101121401', 'city': '枣庄', 'province': '山东', 'leader': '枣庄'}, {'id': '101121402', 'city': '薛城', 'province': '山东', 'leader': '枣庄'}, {'id': '101121403', 'city': '峄城', 'province': '山东', 'leader': '枣庄'}, {'id': '101121404', 'city': '台儿庄', 'province': '山东', 'leader': '枣庄'}, {'id': '101121405', 'city': '滕州', 'province': '山东', 'leader': '枣庄'}, {'id': '101121406', 'city': '市中', 'province': '山东', 'leader': '枣庄'}, {'id': '101121407', 'city': '山亭', 'province': '山东', 'leader': '枣庄'}, {'id': '101121501', 'city': '日照', 'province': '山东', 'leader': '日照'}, {'id': '101121502', 'city': '五莲', 'province': '山东', 'leader': '日照'}, {'id': '101121503', 'city': '莒县', 'province': '山东', 'leader': '日照'}, {'id': '101121504', 'city': '东港', 'province': '山东', 'leader': '日照'}, {'id': '101121505', 'city': '岚山', 'province': '山东', 'leader': '日照'}, {'id': '101121601', 'city': '莱芜', 'province': '山东', 'leader': '莱芜'}, {'id': '101121602', 'city': '莱城', 'province': '山东', 'leader': '莱芜'}, {'id': '101121603', 'city': '钢城', 'province': '山东', 'leader': '莱芜'}, {'id': '101121701', 'city': '聊城', 'province': '山东', 'leader': '聊城'}, {'id': '101121702', 'city': '冠县', 'province': '山东', 'leader': '聊城'}, {'id': '101121703', 'city': '阳谷', 'province': '山东', 'leader': '聊城'}, {'id': '101121704', 'city': '高唐', 'province': '山东', 'leader': '聊城'}, {'id': '101121705', 'city': '茌平', 'province': '山东', 'leader': '聊城'}, {'id': '101121706', 'city': '东阿', 'province': '山东', 'leader': '聊城'}, {'id': '101121707', 'city': '临清', 'province': '山东', 'leader': '聊城'}, {'id': '101121708', 'city': '东昌府', 'province': '山东', 'leader': '聊城'}, {'id': '101121709', 'city': '莘县', 'province': '山东', 'leader': '聊城'}, {'id': '101130101', 'city': '乌鲁木齐', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130102', 'city': '天山', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130104', 'city': '沙依巴克', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130105', 'city': '达坂城', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130106', 'city': '新市', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130107', 'city': '水磨沟', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130111', 'city': '头屯河', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130112', 'city': '米东', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130113', 'city': '乌鲁木齐县', 'province': '新疆', 'leader': '乌鲁木齐'}, {'id': '101130201', 'city': '克拉玛依', 'province': '新疆', 'leader': '克拉玛依'}, {'id': '101130202', 'city': '乌尔禾', 'province': '新疆', 'leader': '克拉玛依'}, {'id': '101130203', 'city': '白碱滩', 'province': '新疆', 'leader': '克拉玛依'}, {'id': '101130204', 'city': '独山子', 'province': '新疆', 'leader': '克拉玛依'}, {'id': '101130301', 'city': '石河子', 'province': '新疆', 'leader': '石河子'}, {'id': '101130401', 'city': '昌吉', 'province': '新疆', 'leader': '昌吉'}, {'id': '101130402', 'city': '呼图壁', 'province': '新疆', 'leader': '昌吉'}, {'id': '101130404', 'city': '阜康', 'province': '新疆', 'leader': '昌吉'}, {'id': '101130405', 'city': '吉木萨尔', 'province': '新疆', 'leader': '昌吉'}, {'id': '101130406', 'city': '奇台', 'province': '新疆', 'leader': '昌吉'}, {'id': '101130407', 'city': '玛纳斯', 'province': '新疆', 'leader': '昌吉'}, {'id': '101130408', 'city': '木垒', 'province': '新疆', 'leader': '昌吉'}, {'id': '101130501', 'city': '吐鲁番', 'province': '新疆', 'leader': '吐鲁番'}, {'id': '101130502', 'city': '托克逊', 'province': '新疆', 'leader': '吐鲁番'}, {'id': '101130503', 'city': '高昌', 'province': '新疆', 'leader': '吐鲁番'}, {'id': '101130504', 'city': '鄯善', 'province': '新疆', 'leader': '吐鲁番'}, {'id': '101130601', 'city': '库尔勒', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130602', 'city': '轮台', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130603', 'city': '尉犁', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130604', 'city': '若羌', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130605', 'city': '且末', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130606', 'city': '和静', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130607', 'city': '焉耆', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130608', 'city': '和硕', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130609', 'city': '巴音郭楞', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130612', 'city': '博湖', 'province': '新疆', 'leader': '巴音郭楞'}, {'id': '101130701', 'city': '阿拉尔', 'province': '新疆', 'leader': '阿拉尔'}, {'id': '101130801', 'city': '阿克苏', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130802', 'city': '乌什', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130803', 'city': '温宿', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130804', 'city': '拜城', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130805', 'city': '新和', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130806', 'city': '沙雅', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130807', 'city': '库车', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130808', 'city': '柯坪', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130809', 'city': '阿瓦提', 'province': '新疆', 'leader': '阿克苏'}, {'id': '101130901', 'city': '喀什', 'province': '新疆', 'leader': '喀什'}, {'id': '101130902', 'city': '英吉沙', 'province': '新疆', 'leader': '喀什'}, {'id': '101130903', 'city': '塔什库尔干', 'province': '新疆', 'leader': '喀什'}, {'id': '101130904', 'city': '麦盖提', 'province': '新疆', 'leader': '喀什'}, {'id': '101130905', 'city': '莎车', 'province': '新疆', 'leader': '喀什'}, {'id': '101130906', 'city': '叶城', 'province': '新疆', 'leader': '喀什'}, {'id': '101130907', 'city': '泽普', 'province': '新疆', 'leader': '喀什'}, {'id': '101130908', 'city': '巴楚', 'province': '新疆', 'leader': '喀什'}, {'id': '101130909', 'city': '岳普湖', 'province': '新疆', 'leader': '喀什'}, {'id': '101130910', 'city': '伽师', 'province': '新疆', 'leader': '喀什'}, {'id': '101130911', 'city': '疏附', 'province': '新疆', 'leader': '喀什'}, {'id': '101130912', 'city': '疏勒', 'province': '新疆', 'leader': '喀什'}, {'id': '101131001', 'city': '伊宁', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131002', 'city': '察布查尔', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131003', 'city': '尼勒克', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131004', 'city': '伊宁县', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131005', 'city': '巩留', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131006', 'city': '新源', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131007', 'city': '昭苏', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131008', 'city': '特克斯', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131009', 'city': '霍城', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131010', 'city': '霍尔果斯', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131011', 'city': '奎屯', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131012', 'city': '伊犁', 'province': '新疆', 'leader': '伊犁'}, {'id': '101131101', 'city': '塔城', 'province': '新疆', 'leader': '塔城'}, {'id': '101131102', 'city': '裕民', 'province': '新疆', 'leader': '塔城'}, {'id': '101131103', 'city': '额敏', 'province': '新疆', 'leader': '塔城'}, {'id': '101131104', 'city': '和布克赛尔', 'province': '新疆', 'leader': '塔城'}, {'id': '101131105', 'city': '托里', 'province': '新疆', 'leader': '塔城'}, {'id': '101131106', 'city': '乌苏', 'province': '新疆', 'leader': '塔城'}, {'id': '101131107', 'city': '沙湾', 'province': '新疆', 'leader': '塔城'}, {'id': '101131201', 'city': '哈密', 'province': '新疆', 'leader': '哈密'}, {'id': '101131202', 'city': '伊州', 'province': '新疆', 'leader': '哈密'}, {'id': '101131203', 'city': '巴里坤', 'province': '新疆', 'leader': '哈密'}, {'id': '101131204', 'city': '伊吾', 'province': '新疆', 'leader': '哈密'}, {'id': '101131301', 'city': '和田', 'province': '新疆', 'leader': '和田'}, {'id': '101131302', 'city': '皮山', 'province': '新疆', 'leader': '和田'}, {'id': '101131303', 'city': '策勒', 'province': '新疆', 'leader': '和田'}, {'id': '101131304', 'city': '墨玉', 'province': '新疆', 'leader': '和田'}, {'id': '101131305', 'city': '洛浦', 'province': '新疆', 'leader': '和田'}, {'id': '101131306', 'city': '民丰', 'province': '新疆', 'leader': '和田'}, {'id': '101131307', 'city': '于田', 'province': '新疆', 'leader': '和田'}, {'id': '101131401', 'city': '阿勒泰', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131402', 'city': '哈巴河', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131405', 'city': '吉木乃', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131406', 'city': '布尔津', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131407', 'city': '福海', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131408', 'city': '富蕴', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131409', 'city': '青河', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131410', 'city': '北屯', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131412', 'city': '双河', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131413', 'city': '可克达拉', 'province': '新疆', 'leader': '阿勒泰'}, {'id': '101131501', 'city': '阿图什', 'province': '新疆', 'leader': '克州'}, {'id': '101131502', 'city': '乌恰', 'province': '新疆', 'leader': '克州'}, {'id': '101131503', 'city': '阿克陶', 'province': '新疆', 'leader': '克州'}, {'id': '101131504', 'city': '阿合奇', 'province': '新疆', 'leader': '克州'}, {'id': '101131505', 'city': '克州', 'province': '新疆', 'leader': '克州'}, {'id': '101131601', 'city': '博乐', 'province': '新疆', 'leader': '博尔塔拉'}, {'id': '101131602', 'city': '温泉', 'province': '新疆', 'leader': '博尔塔拉'}, {'id': '101131603', 'city': '精河', 'province': '新疆', 'leader': '博尔塔拉'}, {'id': '101131604', 'city': '博尔塔拉', 'province': '新疆', 'leader': '博尔塔拉'}, {'id': '101131606', 'city': '阿拉山口', 'province': '新疆', 'leader': '博尔塔拉'}, {'id': '101131701', 'city': '图木舒克', 'province': '新疆', 'leader': '图木舒克'}, {'id': '101131801', 'city': '五家渠', 'province': '新疆', 'leader': '五家渠'}, {'id': '101131901', 'city': '铁门关', 'province': '新疆', 'leader': '铁门关'}, {'id': '101140101', 'city': '拉萨', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140102', 'city': '当雄', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140103', 'city': '尼木', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140104', 'city': '林周', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140105', 'city': '堆龙德庆', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140106', 'city': '曲水', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140107', 'city': '达孜', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140108', 'city': '墨竹工卡', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140109', 'city': '城关', 'province': '西藏', 'leader': '拉萨'}, {'id': '101140201', 'city': '日喀则', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140202', 'city': '拉孜', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140203', 'city': '南木林', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140204', 'city': '聂拉木', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140205', 'city': '定日', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140206', 'city': '江孜', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140208', 'city': '仲巴', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140209', 'city': '萨嘎', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140210', 'city': '吉隆', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140211', 'city': '昂仁', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140212', 'city': '定结', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140213', 'city': '萨迦', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140214', 'city': '谢通门', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140215', 'city': '桑珠孜', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140216', 'city': '岗巴', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140217', 'city': '白朗', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140218', 'city': '亚东', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140219', 'city': '康马', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140220', 'city': '仁布', 'province': '西藏', 'leader': '日喀则'}, {'id': '101140301', 'city': '山南', 'province': '西藏', 'leader': '山南'}, {'id': '101140302', 'city': '贡嘎', 'province': '西藏', 'leader': '山南'}, {'id': '101140303', 'city': '扎囊', 'province': '西藏', 'leader': '山南'}, {'id': '101140304', 'city': '加查', 'province': '西藏', 'leader': '山南'}, {'id': '101140305', 'city': '浪卡子', 'province': '西藏', 'leader': '山南'}, {'id': '101140306', 'city': '错那', 'province': '西藏', 'leader': '山南'}, {'id': '101140307', 'city': '隆子', 'province': '西藏', 'leader': '山南'}, {'id': '101140309', 'city': '乃东', 'province': '西藏', 'leader': '山南'}, {'id': '101140310', 'city': '桑日', 'province': '西藏', 'leader': '山南'}, {'id': '101140311', 'city': '洛扎', 'province': '西藏', 'leader': '山南'}, {'id': '101140312', 'city': '措美', 'province': '西藏', 'leader': '山南'}, {'id': '101140313', 'city': '琼结', 'province': '西藏', 'leader': '山南'}, {'id': '101140314', 'city': '曲松', 'province': '西藏', 'leader': '山南'}, {'id': '101140401', 'city': '林芝', 'province': '西藏', 'leader': '林芝'}, {'id': '101140402', 'city': '波密', 'province': '西藏', 'leader': '林芝'}, {'id': '101140403', 'city': '米林', 'province': '西藏', 'leader': '林芝'}, {'id': '101140404', 'city': '察隅', 'province': '西藏', 'leader': '林芝'}, {'id': '101140405', 'city': '工布江达', 'province': '西藏', 'leader': '林芝'}, {'id': '101140406', 'city': '朗县', 'province': '西藏', 'leader': '林芝'}, {'id': '101140407', 'city': '墨脱', 'province': '西藏', 'leader': '林芝'}, {'id': '101140408', 'city': '巴宜', 'province': '西藏', 'leader': '林芝'}, {'id': '101140501', 'city': '昌都', 'province': '西藏', 'leader': '昌都'}, {'id': '101140502', 'city': '丁青', 'province': '西藏', 'leader': '昌都'}, {'id': '101140503', 'city': '边坝', 'province': '西藏', 'leader': '昌都'}, {'id': '101140504', 'city': '洛隆', 'province': '西藏', 'leader': '昌都'}, {'id': '101140505', 'city': '左贡', 'province': '西藏', 'leader': '昌都'}, {'id': '101140506', 'city': '芒康', 'province': '西藏', 'leader': '昌都'}, {'id': '101140507', 'city': '类乌齐', 'province': '西藏', 'leader': '昌都'}, {'id': '101140508', 'city': '八宿', 'province': '西藏', 'leader': '昌都'}, {'id': '101140509', 'city': '江达', 'province': '西藏', 'leader': '昌都'}, {'id': '101140510', 'city': '察雅', 'province': '西藏', 'leader': '昌都'}, {'id': '101140511', 'city': '贡觉', 'province': '西藏', 'leader': '昌都'}, {'id': '101140512', 'city': '卡若', 'province': '西藏', 'leader': '昌都'}, {'id': '101140601', 'city': '那曲', 'province': '西藏', 'leader': '那曲'}, {'id': '101140602', 'city': '尼玛', 'province': '西藏', 'leader': '那曲'}, {'id': '101140603', 'city': '嘉黎', 'province': '西藏', 'leader': '那曲'}, {'id': '101140604', 'city': '班戈', 'province': '西藏', 'leader': '那曲'}, {'id': '101140605', 'city': '安多', 'province': '西藏', 'leader': '那曲'}, {'id': '101140606', 'city': '索县', 'province': '西藏', 'leader': '那曲'}, {'id': '101140607', 'city': '聂荣', 'province': '西藏', 'leader': '那曲'}, {'id': '101140608', 'city': '巴青', 'province': '西藏', 'leader': '那曲'}, {'id': '101140609', 'city': '比如', 'province': '西藏', 'leader': '那曲'}, {'id': '101140610', 'city': '双湖', 'province': '西藏', 'leader': '那曲'}, {'id': '101140611', 'city': '申扎', 'province': '西藏', 'leader': '那曲'}, {'id': '101140701', 'city': '阿里', 'province': '西藏', 'leader': '阿里'}, {'id': '101140702', 'city': '改则', 'province': '西藏', 'leader': '阿里'}, {'id': '101140705', 'city': '普兰', 'province': '西藏', 'leader': '阿里'}, {'id': '101140706', 'city': '札达', 'province': '西藏', 'leader': '阿里'}, {'id': '101140707', 'city': '噶尔', 'province': '西藏', 'leader': '阿里'}, {'id': '101140708', 'city': '日土', 'province': '西藏', 'leader': '阿里'}, {'id': '101140709', 'city': '革吉', 'province': '西藏', 'leader': '阿里'}, {'id': '101140710', 'city': '措勤', 'province': '西藏', 'leader': '阿里'}, {'id': '101150101', 'city': '西宁', 'province': '青海', 'leader': '西宁'}, {'id': '101150102', 'city': '大通', 'province': '青海', 'leader': '西宁'}, {'id': '101150103', 'city': '湟源', 'province': '青海', 'leader': '西宁'}, {'id': '101150104', 'city': '湟中', 'province': '青海', 'leader': '西宁'}, {'id': '101150105', 'city': '城东', 'province': '青海', 'leader': '西宁'}, {'id': '101150106', 'city': '城中', 'province': '青海', 'leader': '西宁'}, {'id': '101150107', 'city': '城西', 'province': '青海', 'leader': '西宁'}, {'id': '101150108', 'city': '城北', 'province': '青海', 'leader': '西宁'}, {'id': '101150201', 'city': '平安', 'province': '青海', 'leader': '海东'}, {'id': '101150202', 'city': '乐都', 'province': '青海', 'leader': '海东'}, {'id': '101150203', 'city': '民和', 'province': '青海', 'leader': '海东'}, {'id': '101150204', 'city': '互助', 'province': '青海', 'leader': '海东'}, {'id': '101150205', 'city': '化隆', 'province': '青海', 'leader': '海东'}, {'id': '101150206', 'city': '循化', 'province': '青海', 'leader': '海东'}, {'id': '101150207', 'city': '海东', 'province': '青海', 'leader': '海东'}, {'id': '101150301', 'city': '同仁', 'province': '青海', 'leader': '黄南'}, {'id': '101150302', 'city': '尖扎', 'province': '青海', 'leader': '黄南'}, {'id': '101150303', 'city': '泽库', 'province': '青海', 'leader': '黄南'}, {'id': '101150304', 'city': '河南', 'province': '青海', 'leader': '黄南'}, {'id': '101150305', 'city': '黄南', 'province': '青海', 'leader': '黄南'}, {'id': '101150401', 'city': '共和', 'province': '青海', 'leader': '海南'}, {'id': '101150402', 'city': '海南', 'province': '青海', 'leader': '海南'}, {'id': '101150404', 'city': '贵德', 'province': '青海', 'leader': '海南'}, {'id': '101150406', 'city': '兴海', 'province': '青海', 'leader': '海南'}, {'id': '101150407', 'city': '贵南', 'province': '青海', 'leader': '海南'}, {'id': '101150408', 'city': '同德', 'province': '青海', 'leader': '海南'}, {'id': '101150501', 'city': '玛沁', 'province': '青海', 'leader': '果洛'}, {'id': '101150502', 'city': '班玛', 'province': '青海', 'leader': '果洛'}, {'id': '101150503', 'city': '甘德', 'province': '青海', 'leader': '果洛'}, {'id': '101150504', 'city': '达日', 'province': '青海', 'leader': '果洛'}, {'id': '101150505', 'city': '久治', 'province': '青海', 'leader': '果洛'}, {'id': '101150506', 'city': '玛多', 'province': '青海', 'leader': '果洛'}, {'id': '101150507', 'city': '果洛', 'province': '青海', 'leader': '果洛'}, {'id': '101150601', 'city': '玉树', 'province': '青海', 'leader': '玉树'}, {'id': '101150602', 'city': '称多', 'province': '青海', 'leader': '玉树'}, {'id': '101150603', 'city': '治多', 'province': '青海', 'leader': '玉树'}, {'id': '101150604', 'city': '杂多', 'province': '青海', 'leader': '玉树'}, {'id': '101150605', 'city': '囊谦', 'province': '青海', 'leader': '玉树'}, {'id': '101150606', 'city': '曲麻莱', 'province': '青海', 'leader': '玉树'}, {'id': '101150701', 'city': '德令哈', 'province': '青海', 'leader': '海西'}, {'id': '101150702', 'city': '海西', 'province': '青海', 'leader': '海西'}, {'id': '101150708', 'city': '天峻', 'province': '青海', 'leader': '海西'}, {'id': '101150709', 'city': '乌兰', 'province': '青海', 'leader': '海西'}, {'id': '101150712', 'city': '茫崖', 'province': '青海', 'leader': '海西'}, {'id': '101150713', 'city': '大柴旦', 'province': '青海', 'leader': '海西'}, {'id': '101150714', 'city': '格尔木', 'province': '青海', 'leader': '海西'}, {'id': '101150715', 'city': '都兰', 'province': '青海', 'leader': '海西'}, {'id': '101150716', 'city': '冷湖', 'province': '青海', 'leader': '海西'}, {'id': '101150801', 'city': '海晏', 'province': '青海', 'leader': '海北'}, {'id': '101150802', 'city': '门源', 'province': '青海', 'leader': '海北'}, {'id': '101150803', 'city': '祁连', 'province': '青海', 'leader': '海北'}, {'id': '101150804', 'city': '海北', 'province': '青海', 'leader': '海北'}, {'id': '101150806', 'city': '刚察', 'province': '青海', 'leader': '海北'}, {'id': '101160101', 'city': '兰州', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160102', 'city': '皋兰', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160103', 'city': '永登', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160104', 'city': '榆中', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160105', 'city': '城关', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160106', 'city': '七里河', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160107', 'city': '西固', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160108', 'city': '安宁', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160109', 'city': '红古', 'province': '甘肃', 'leader': '兰州'}, {'id': '101160201', 'city': '定西', 'province': '甘肃', 'leader': '定西'}, {'id': '101160202', 'city': '通渭', 'province': '甘肃', 'leader': '定西'}, {'id': '101160203', 'city': '陇西', 'province': '甘肃', 'leader': '定西'}, {'id': '101160204', 'city': '渭源', 'province': '甘肃', 'leader': '定西'}, {'id': '101160205', 'city': '临洮', 'province': '甘肃', 'leader': '定西'}, {'id': '101160206', 'city': '漳县', 'province': '甘肃', 'leader': '定西'}, {'id': '101160207', 'city': '岷县', 'province': '甘肃', 'leader': '定西'}, {'id': '101160208', 'city': '安定', 'province': '甘肃', 'leader': '定西'}, {'id': '101160301', 'city': '平凉', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160302', 'city': '泾川', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160303', 'city': '灵台', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160304', 'city': '崇信', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160305', 'city': '华亭', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160306', 'city': '庄浪', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160307', 'city': '静宁', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160308', 'city': '崆峒', 'province': '甘肃', 'leader': '平凉'}, {'id': '101160401', 'city': '庆阳', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160402', 'city': '西峰', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160403', 'city': '环县', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160404', 'city': '华池', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160405', 'city': '合水', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160406', 'city': '正宁', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160407', 'city': '宁县', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160408', 'city': '镇原', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160409', 'city': '庆城', 'province': '甘肃', 'leader': '庆阳'}, {'id': '101160501', 'city': '武威', 'province': '甘肃', 'leader': '武威'}, {'id': '101160502', 'city': '民勤', 'province': '甘肃', 'leader': '武威'}, {'id': '101160503', 'city': '古浪', 'province': '甘肃', 'leader': '武威'}, {'id': '101160504', 'city': '凉州', 'province': '甘肃', 'leader': '武威'}, {'id': '101160505', 'city': '天祝', 'province': '甘肃', 'leader': '武威'}, {'id': '101160601', 'city': '金昌', 'province': '甘肃', 'leader': '金昌'}, {'id': '101160602', 'city': '永昌', 'province': '甘肃', 'leader': '金昌'}, {'id': '101160603', 'city': '金川', 'province': '甘肃', 'leader': '金昌'}, {'id': '101160701', 'city': '张掖', 'province': '甘肃', 'leader': '张掖'}, {'id': '101160702', 'city': '肃南', 'province': '甘肃', 'leader': '张掖'}, {'id': '101160703', 'city': '民乐', 'province': '甘肃', 'leader': '张掖'}, {'id': '101160704', 'city': '临泽', 'province': '甘肃', 'leader': '张掖'}, {'id': '101160705', 'city': '高台', 'province': '甘肃', 'leader': '张掖'}, {'id': '101160706', 'city': '山丹', 'province': '甘肃', 'leader': '张掖'}, {'id': '101160707', 'city': '甘州', 'province': '甘肃', 'leader': '张掖'}, {'id': '101160801', 'city': '酒泉', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160802', 'city': '肃州', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160803', 'city': '金塔', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160804', 'city': '阿克塞', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160805', 'city': '瓜州', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160806', 'city': '肃北', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160807', 'city': '玉门', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160808', 'city': '敦煌', 'province': '甘肃', 'leader': '酒泉'}, {'id': '101160901', 'city': '天水', 'province': '甘肃', 'leader': '天水'}, {'id': '101160902', 'city': '秦州', 'province': '甘肃', 'leader': '天水'}, {'id': '101160903', 'city': '清水', 'province': '甘肃', 'leader': '天水'}, {'id': '101160904', 'city': '秦安', 'province': '甘肃', 'leader': '天水'}, {'id': '101160905', 'city': '甘谷', 'province': '甘肃', 'leader': '天水'}, {'id': '101160906', 'city': '武山', 'province': '甘肃', 'leader': '天水'}, {'id': '101160907', 'city': '张家川', 'province': '甘肃', 'leader': '天水'}, {'id': '101160908', 'city': '麦积', 'province': '甘肃', 'leader': '天水'}, {'id': '101161001', 'city': '武都', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161002', 'city': '成县', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161003', 'city': '文县', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161004', 'city': '宕昌', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161005', 'city': '康县', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161006', 'city': '西和', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161007', 'city': '礼县', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161008', 'city': '徽县', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161009', 'city': '两当', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161010', 'city': '陇南', 'province': '甘肃', 'leader': '陇南'}, {'id': '101161101', 'city': '临夏', 'province': '甘肃', 'leader': '临夏'}, {'id': '101161102', 'city': '康乐', 'province': '甘肃', 'leader': '临夏'}, {'id': '101161103', 'city': '永靖', 'province': '甘肃', 'leader': '临夏'}, {'id': '101161104', 'city': '广河', 'province': '甘肃', 'leader': '临夏'}, {'id': '101161105', 'city': '和政', 'province': '甘肃', 'leader': '临夏'}, {'id': '101161106', 'city': '东乡', 'province': '甘肃', 'leader': '临夏'}, {'id': '101161107', 'city': '积石山', 'province': '甘肃', 'leader': '临夏'}, {'id': '101161201', 'city': '合作', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161202', 'city': '临潭', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161203', 'city': '卓尼', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161204', 'city': '舟曲', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161205', 'city': '迭部', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161206', 'city': '玛曲', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161207', 'city': '碌曲', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161208', 'city': '夏河', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161209', 'city': '甘南', 'province': '甘肃', 'leader': '甘南'}, {'id': '101161301', 'city': '白银', 'province': '甘肃', 'leader': '白银'}, {'id': '101161302', 'city': '靖远', 'province': '甘肃', 'leader': '白银'}, {'id': '101161303', 'city': '会宁', 'province': '甘肃', 'leader': '白银'}, {'id': '101161304', 'city': '平川', 'province': '甘肃', 'leader': '白银'}, {'id': '101161305', 'city': '景泰', 'province': '甘肃', 'leader': '白银'}, {'id': '101161401', 'city': '嘉峪关', 'province': '甘肃', 'leader': '嘉峪关'}, {'id': '101170101', 'city': '银川', 'province': '宁夏', 'leader': '银川'}, {'id': '101170102', 'city': '永宁', 'province': '宁夏', 'leader': '银川'}, {'id': '101170103', 'city': '灵武', 'province': '宁夏', 'leader': '银川'}, {'id': '101170104', 'city': '贺兰', 'province': '宁夏', 'leader': '银川'}, {'id': '101170105', 'city': '兴庆', 'province': '宁夏', 'leader': '银川'}, {'id': '101170106', 'city': '西夏', 'province': '宁夏', 'leader': '银川'}, {'id': '101170107', 'city': '金凤', 'province': '宁夏', 'leader': '银川'}, {'id': '101170201', 'city': '石嘴山', 'province': '宁夏', 'leader': '石嘴山'}, {'id': '101170202', 'city': '惠农', 'province': '宁夏', 'leader': '石嘴山'}, {'id': '101170203', 'city': '平罗', 'province': '宁夏', 'leader': '石嘴山'}, {'id': '101170205', 'city': '大武口', 'province': '宁夏', 'leader': '石嘴山'}, {'id': '101170301', 'city': '吴忠', 'province': '宁夏', 'leader': '吴忠'}, {'id': '101170302', 'city': '同心', 'province': '宁夏', 'leader': '吴忠'}, {'id': '101170303', 'city': '盐池', 'province': '宁夏', 'leader': '吴忠'}, {'id': '101170304', 'city': '利通', 'province': '宁夏', 'leader': '吴忠'}, {'id': '101170305', 'city': '红寺堡', 'province': '宁夏', 'leader': '吴忠'}, {'id': '101170306', 'city': '青铜峡', 'province': '宁夏', 'leader': '吴忠'}, {'id': '101170401', 'city': '固原', 'province': '宁夏', 'leader': '固原'}, {'id': '101170402', 'city': '西吉', 'province': '宁夏', 'leader': '固原'}, {'id': '101170403', 'city': '隆德', 'province': '宁夏', 'leader': '固原'}, {'id': '101170404', 'city': '泾源', 'province': '宁夏', 'leader': '固原'}, {'id': '101170405', 'city': '原州', 'province': '宁夏', 'leader': '固原'}, {'id': '101170406', 'city': '彭阳', 'province': '宁夏', 'leader': '固原'}, {'id': '101170501', 'city': '中卫', 'province': '宁夏', 'leader': '中卫'}, {'id': '101170502', 'city': '中宁', 'province': '宁夏', 'leader': '中卫'}, {'id': '101170503', 'city': '沙坡头', 'province': '宁夏', 'leader': '中卫'}, {'id': '101170504', 'city': '海原', 'province': '宁夏', 'leader': '中卫'}, {'id': '101180101', 'city': '郑州', 'province': '河南', 'leader': '郑州'}, {'id': '101180102', 'city': '巩义', 'province': '河南', 'leader': '郑州'}, {'id': '101180103', 'city': '荥阳', 'province': '河南', 'leader': '郑州'}, {'id': '101180104', 'city': '登封', 'province': '河南', 'leader': '郑州'}, {'id': '101180105', 'city': '新密', 'province': '河南', 'leader': '郑州'}, {'id': '101180106', 'city': '新郑', 'province': '河南', 'leader': '郑州'}, {'id': '101180107', 'city': '中牟', 'province': '河南', 'leader': '郑州'}, {'id': '101180108', 'city': '上街', 'province': '河南', 'leader': '郑州'}, {'id': '101180109', 'city': '中原', 'province': '河南', 'leader': '郑州'}, {'id': '101180110', 'city': '二七', 'province': '河南', 'leader': '郑州'}, {'id': '101180111', 'city': '管城', 'province': '河南', 'leader': '郑州'}, {'id': '101180112', 'city': '金水', 'province': '河南', 'leader': '郑州'}, {'id': '101180113', 'city': '惠济', 'province': '河南', 'leader': '郑州'}, {'id': '101180201', 'city': '安阳', 'province': '河南', 'leader': '安阳'}, {'id': '101180202', 'city': '汤阴', 'province': '河南', 'leader': '安阳'}, {'id': '101180203', 'city': '滑县', 'province': '河南', 'leader': '安阳'}, {'id': '101180204', 'city': '内黄', 'province': '河南', 'leader': '安阳'}, {'id': '101180205', 'city': '林州', 'province': '河南', 'leader': '安阳'}, {'id': '101180206', 'city': '文峰', 'province': '河南', 'leader': '安阳'}, {'id': '101180207', 'city': '北关', 'province': '河南', 'leader': '安阳'}, {'id': '101180208', 'city': '殷都', 'province': '河南', 'leader': '安阳'}, {'id': '101180209', 'city': '龙安', 'province': '河南', 'leader': '安阳'}, {'id': '101180301', 'city': '新乡', 'province': '河南', 'leader': '新乡'}, {'id': '101180302', 'city': '获嘉', 'province': '河南', 'leader': '新乡'}, {'id': '101180303', 'city': '原阳', 'province': '河南', 'leader': '新乡'}, {'id': '101180304', 'city': '辉县', 'province': '河南', 'leader': '新乡'}, {'id': '101180305', 'city': '卫辉', 'province': '河南', 'leader': '新乡'}, {'id': '101180306', 'city': '延津', 'province': '河南', 'leader': '新乡'}, {'id': '101180307', 'city': '封丘', 'province': '河南', 'leader': '新乡'}, {'id': '101180308', 'city': '长垣', 'province': '河南', 'leader': '新乡'}, {'id': '101180309', 'city': '红旗', 'province': '河南', 'leader': '新乡'}, {'id': '101180310', 'city': '卫滨', 'province': '河南', 'leader': '新乡'}, {'id': '101180311', 'city': '凤泉', 'province': '河南', 'leader': '新乡'}, {'id': '101180312', 'city': '牧野', 'province': '河南', 'leader': '新乡'}, {'id': '101180401', 'city': '许昌', 'province': '河南', 'leader': '许昌'}, {'id': '101180402', 'city': '鄢陵', 'province': '河南', 'leader': '许昌'}, {'id': '101180403', 'city': '襄城', 'province': '河南', 'leader': '许昌'}, {'id': '101180404', 'city': '长葛', 'province': '河南', 'leader': '许昌'}, {'id': '101180405', 'city': '禹州', 'province': '河南', 'leader': '许昌'}, {'id': '101180406', 'city': '魏都', 'province': '河南', 'leader': '许昌'}, {'id': '101180501', 'city': '平顶山', 'province': '河南', 'leader': '平顶山'}, {'id': '101180502', 'city': '郏县', 'province': '河南', 'leader': '平顶山'}, {'id': '101180503', 'city': '宝丰', 'province': '河南', 'leader': '平顶山'}, {'id': '101180504', 'city': '汝州', 'province': '河南', 'leader': '平顶山'}, {'id': '101180505', 'city': '叶县', 'province': '河南', 'leader': '平顶山'}, {'id': '101180506', 'city': '舞钢', 'province': '河南', 'leader': '平顶山'}, {'id': '101180507', 'city': '鲁山', 'province': '河南', 'leader': '平顶山'}, {'id': '101180508', 'city': '石龙', 'province': '河南', 'leader': '平顶山'}, {'id': '101180509', 'city': '新华', 'province': '河南', 'leader': '平顶山'}, {'id': '101180510', 'city': '卫东', 'province': '河南', 'leader': '平顶山'}, {'id': '101180511', 'city': '湛河', 'province': '河南', 'leader': '平顶山'}, {'id': '101180601', 'city': '信阳', 'province': '河南', 'leader': '信阳'}, {'id': '101180602', 'city': '息县', 'province': '河南', 'leader': '信阳'}, {'id': '101180603', 'city': '罗山', 'province': '河南', 'leader': '信阳'}, {'id': '101180604', 'city': '光山', 'province': '河南', 'leader': '信阳'}, {'id': '101180605', 'city': '新县', 'province': '河南', 'leader': '信阳'}, {'id': '101180606', 'city': '淮滨', 'province': '河南', 'leader': '信阳'}, {'id': '101180607', 'city': '潢川', 'province': '河南', 'leader': '信阳'}, {'id': '101180608', 'city': '固始', 'province': '河南', 'leader': '信阳'}, {'id': '101180609', 'city': '商城', 'province': '河南', 'leader': '信阳'}, {'id': '101180610', 'city': '浉河', 'province': '河南', 'leader': '信阳'}, {'id': '101180611', 'city': '平桥', 'province': '河南', 'leader': '信阳'}, {'id': '101180701', 'city': '南阳', 'province': '河南', 'leader': '南阳'}, {'id': '101180702', 'city': '南召', 'province': '河南', 'leader': '南阳'}, {'id': '101180703', 'city': '方城', 'province': '河南', 'leader': '南阳'}, {'id': '101180704', 'city': '社旗', 'province': '河南', 'leader': '南阳'}, {'id': '101180705', 'city': '西峡', 'province': '河南', 'leader': '南阳'}, {'id': '101180706', 'city': '内乡', 'province': '河南', 'leader': '南阳'}, {'id': '101180707', 'city': '镇平', 'province': '河南', 'leader': '南阳'}, {'id': '101180708', 'city': '淅川', 'province': '河南', 'leader': '南阳'}, {'id': '101180709', 'city': '新野', 'province': '河南', 'leader': '南阳'}, {'id': '101180710', 'city': '唐河', 'province': '河南', 'leader': '南阳'}, {'id': '101180711', 'city': '邓州', 'province': '河南', 'leader': '南阳'}, {'id': '101180712', 'city': '桐柏', 'province': '河南', 'leader': '南阳'}, {'id': '101180713', 'city': '宛城', 'province': '河南', 'leader': '南阳'}, {'id': '101180714', 'city': '卧龙', 'province': '河南', 'leader': '南阳'}, {'id': '101180801', 'city': '开封', 'province': '河南', 'leader': '开封'}, {'id': '101180802', 'city': '杞县', 'province': '河南', 'leader': '开封'}, {'id': '101180803', 'city': '尉氏', 'province': '河南', 'leader': '开封'}, {'id': '101180804', 'city': '通许', 'province': '河南', 'leader': '开封'}, {'id': '101180805', 'city': '兰考', 'province': '河南', 'leader': '开封'}, {'id': '101180806', 'city': '龙亭', 'province': '河南', 'leader': '开封'}, {'id': '101180807', 'city': '顺河', 'province': '河南', 'leader': '开封'}, {'id': '101180808', 'city': '鼓楼', 'province': '河南', 'leader': '开封'}, {'id': '101180809', 'city': '禹王台', 'province': '河南', 'leader': '开封'}, {'id': '101180810', 'city': '祥符', 'province': '河南', 'leader': '开封'}, {'id': '101180901', 'city': '洛阳', 'province': '河南', 'leader': '洛阳'}, {'id': '101180902', 'city': '新安', 'province': '河南', 'leader': '洛阳'}, {'id': '101180903', 'city': '孟津', 'province': '河南', 'leader': '洛阳'}, {'id': '101180904', 'city': '宜阳', 'province': '河南', 'leader': '洛阳'}, {'id': '101180905', 'city': '洛宁', 'province': '河南', 'leader': '洛阳'}, {'id': '101180906', 'city': '伊川', 'province': '河南', 'leader': '洛阳'}, {'id': '101180907', 'city': '嵩县', 'province': '河南', 'leader': '洛阳'}, {'id': '101180908', 'city': '偃师', 'province': '河南', 'leader': '洛阳'}, {'id': '101180909', 'city': '栾川', 'province': '河南', 'leader': '洛阳'}, {'id': '101180910', 'city': '汝阳', 'province': '河南', 'leader': '洛阳'}, {'id': '101180911', 'city': '吉利', 'province': '河南', 'leader': '洛阳'}, {'id': '101180912', 'city': '老城', 'province': '河南', 'leader': '洛阳'}, {'id': '101180913', 'city': '西工', 'province': '河南', 'leader': '洛阳'}, {'id': '101180914', 'city': '瀍河', 'province': '河南', 'leader': '洛阳'}, {'id': '101180915', 'city': '涧西', 'province': '河南', 'leader': '洛阳'}, {'id': '101180916', 'city': '洛龙', 'province': '河南', 'leader': '洛阳'}, {'id': '101181001', 'city': '商丘', 'province': '河南', 'leader': '商丘'}, {'id': '101181002', 'city': '梁园', 'province': '河南', 'leader': '商丘'}, {'id': '101181003', 'city': '睢县', 'province': '河南', 'leader': '商丘'}, {'id': '101181004', 'city': '民权', 'province': '河南', 'leader': '商丘'}, {'id': '101181005', 'city': '虞城', 'province': '河南', 'leader': '商丘'}, {'id': '101181006', 'city': '柘城', 'province': '河南', 'leader': '商丘'}, {'id': '101181007', 'city': '宁陵', 'province': '河南', 'leader': '商丘'}, {'id': '101181008', 'city': '夏邑', 'province': '河南', 'leader': '商丘'}, {'id': '101181009', 'city': '永城', 'province': '河南', 'leader': '商丘'}, {'id': '101181010', 'city': '睢阳', 'province': '河南', 'leader': '商丘'}, {'id': '101181101', 'city': '焦作', 'province': '河南', 'leader': '焦作'}, {'id': '101181102', 'city': '修武', 'province': '河南', 'leader': '焦作'}, {'id': '101181103', 'city': '武陟', 'province': '河南', 'leader': '焦作'}, {'id': '101181104', 'city': '沁阳', 'province': '河南', 'leader': '焦作'}, {'id': '101181105', 'city': '解放', 'province': '河南', 'leader': '焦作'}, {'id': '101181106', 'city': '博爱', 'province': '河南', 'leader': '焦作'}, {'id': '101181107', 'city': '温县', 'province': '河南', 'leader': '焦作'}, {'id': '101181108', 'city': '孟州', 'province': '河南', 'leader': '焦作'}, {'id': '101181109', 'city': '中站', 'province': '河南', 'leader': '焦作'}, {'id': '101181110', 'city': '马村', 'province': '河南', 'leader': '焦作'}, {'id': '101181111', 'city': '山阳', 'province': '河南', 'leader': '焦作'}, {'id': '101181201', 'city': '鹤壁', 'province': '河南', 'leader': '鹤壁'}, {'id': '101181202', 'city': '浚县', 'province': '河南', 'leader': '鹤壁'}, {'id': '101181203', 'city': '淇县', 'province': '河南', 'leader': '鹤壁'}, {'id': '101181204', 'city': '鹤山', 'province': '河南', 'leader': '鹤壁'}, {'id': '101181205', 'city': '山城', 'province': '河南', 'leader': '鹤壁'}, {'id': '101181206', 'city': '淇滨', 'province': '河南', 'leader': '鹤壁'}, {'id': '101181301', 'city': '濮阳', 'province': '河南', 'leader': '濮阳'}, {'id': '101181302', 'city': '台前', 'province': '河南', 'leader': '濮阳'}, {'id': '101181303', 'city': '南乐', 'province': '河南', 'leader': '濮阳'}, {'id': '101181304', 'city': '清丰', 'province': '河南', 'leader': '濮阳'}, {'id': '101181305', 'city': '范县', 'province': '河南', 'leader': '濮阳'}, {'id': '101181306', 'city': '华龙', 'province': '河南', 'leader': '濮阳'}, {'id': '101181401', 'city': '周口', 'province': '河南', 'leader': '周口'}, {'id': '101181402', 'city': '扶沟', 'province': '河南', 'leader': '周口'}, {'id': '101181403', 'city': '太康', 'province': '河南', 'leader': '周口'}, {'id': '101181404', 'city': '淮阳', 'province': '河南', 'leader': '周口'}, {'id': '101181405', 'city': '西华', 'province': '河南', 'leader': '周口'}, {'id': '101181406', 'city': '商水', 'province': '河南', 'leader': '周口'}, {'id': '101181407', 'city': '项城', 'province': '河南', 'leader': '周口'}, {'id': '101181408', 'city': '郸城', 'province': '河南', 'leader': '周口'}, {'id': '101181409', 'city': '鹿邑', 'province': '河南', 'leader': '周口'}, {'id': '101181410', 'city': '沈丘', 'province': '河南', 'leader': '周口'}, {'id': '101181411', 'city': '川汇', 'province': '河南', 'leader': '周口'}, {'id': '101181501', 'city': '漯河', 'province': '河南', 'leader': '漯河'}, {'id': '101181502', 'city': '临颍', 'province': '河南', 'leader': '漯河'}, {'id': '101181503', 'city': '舞阳', 'province': '河南', 'leader': '漯河'}, {'id': '101181504', 'city': '源汇', 'province': '河南', 'leader': '漯河'}, {'id': '101181505', 'city': '郾城', 'province': '河南', 'leader': '漯河'}, {'id': '101181506', 'city': '召陵', 'province': '河南', 'leader': '漯河'}, {'id': '101181601', 'city': '驻马店', 'province': '河南', 'leader': '驻马店'}, {'id': '101181602', 'city': '西平', 'province': '河南', 'leader': '驻马店'}, {'id': '101181603', 'city': '遂平', 'province': '河南', 'leader': '驻马店'}, {'id': '101181604', 'city': '上蔡', 'province': '河南', 'leader': '驻马店'}, {'id': '101181605', 'city': '汝南', 'province': '河南', 'leader': '驻马店'}, {'id': '101181606', 'city': '泌阳', 'province': '河南', 'leader': '驻马店'}, {'id': '101181607', 'city': '平舆', 'province': '河南', 'leader': '驻马店'}, {'id': '101181608', 'city': '新蔡', 'province': '河南', 'leader': '驻马店'}, {'id': '101181609', 'city': '确山', 'province': '河南', 'leader': '驻马店'}, {'id': '101181610', 'city': '正阳', 'province': '河南', 'leader': '驻马店'}, {'id': '101181611', 'city': '驿城', 'province': '河南', 'leader': '驻马店'}, {'id': '101181701', 'city': '三门峡', 'province': '河南', 'leader': '三门峡'}, {'id': '101181702', 'city': '灵宝', 'province': '河南', 'leader': '三门峡'}, {'id': '101181703', 'city': '渑池', 'province': '河南', 'leader': '三门峡'}, {'id': '101181704', 'city': '卢氏', 'province': '河南', 'leader': '三门峡'}, {'id': '101181705', 'city': '义马', 'province': '河南', 'leader': '三门峡'}, {'id': '101181706', 'city': '陕县', 'province': '河南', 'leader': '三门峡'}, {'id': '101181707', 'city': '湖滨', 'province': '河南', 'leader': '三门峡'}, {'id': '101181708', 'city': '陕州', 'province': '河南', 'leader': '三门峡'}, {'id': '101181801', 'city': '济源', 'province': '河南', 'leader': '济源'}, {'id': '101190101', 'city': '南京', 'province': '江苏', 'leader': '南京'}, {'id': '101190102', 'city': '溧水', 'province': '江苏', 'leader': '南京'}, {'id': '101190103', 'city': '高淳', 'province': '江苏', 'leader': '南京'}, {'id': '101190104', 'city': '江宁', 'province': '江苏', 'leader': '南京'}, {'id': '101190105', 'city': '六合', 'province': '江苏', 'leader': '南京'}, {'id': '101190107', 'city': '浦口', 'province': '江苏', 'leader': '南京'}, {'id': '101190108', 'city': '玄武', 'province': '江苏', 'leader': '南京'}, {'id': '101190109', 'city': '秦淮', 'province': '江苏', 'leader': '南京'}, {'id': '101190110', 'city': '建邺', 'province': '江苏', 'leader': '南京'}, {'id': '101190111', 'city': '鼓楼', 'province': '江苏', 'leader': '南京'}, {'id': '101190112', 'city': '栖霞', 'province': '江苏', 'leader': '南京'}, {'id': '101190113', 'city': '雨花台', 'province': '江苏', 'leader': '南京'}, {'id': '101190201', 'city': '无锡', 'province': '江苏', 'leader': '无锡'}, {'id': '101190202', 'city': '江阴', 'province': '江苏', 'leader': '无锡'}, {'id': '101190203', 'city': '宜兴', 'province': '江苏', 'leader': '无锡'}, {'id': '101190204', 'city': '锡山', 'province': '江苏', 'leader': '无锡'}, {'id': '101190205', 'city': '惠山', 'province': '江苏', 'leader': '无锡'}, {'id': '101190206', 'city': '滨湖', 'province': '江苏', 'leader': '无锡'}, {'id': '101190207', 'city': '梁溪', 'province': '江苏', 'leader': '无锡'}, {'id': '101190208', 'city': '新吴', 'province': '江苏', 'leader': '无锡'}, {'id': '101190301', 'city': '镇江', 'province': '江苏', 'leader': '镇江'}, {'id': '101190302', 'city': '丹阳', 'province': '江苏', 'leader': '镇江'}, {'id': '101190303', 'city': '扬中', 'province': '江苏', 'leader': '镇江'}, {'id': '101190304', 'city': '句容', 'province': '江苏', 'leader': '镇江'}, {'id': '101190305', 'city': '丹徒', 'province': '江苏', 'leader': '镇江'}, {'id': '101190306', 'city': '京口', 'province': '江苏', 'leader': '镇江'}, {'id': '101190307', 'city': '润州', 'province': '江苏', 'leader': '镇江'}, {'id': '101190401', 'city': '苏州', 'province': '江苏', 'leader': '苏州'}, {'id': '101190402', 'city': '常熟', 'province': '江苏', 'leader': '苏州'}, {'id': '101190403', 'city': '张家港', 'province': '江苏', 'leader': '苏州'}, {'id': '101190404', 'city': '昆山', 'province': '江苏', 'leader': '苏州'}, {'id': '101190405', 'city': '吴中', 'province': '江苏', 'leader': '苏州'}, {'id': '101190406', 'city': '虎丘', 'province': '江苏', 'leader': '苏州'}, {'id': '101190407', 'city': '吴江', 'province': '江苏', 'leader': '苏州'}, {'id': '101190408', 'city': '太仓', 'province': '江苏', 'leader': '苏州'}, {'id': '101190409', 'city': '相城', 'province': '江苏', 'leader': '苏州'}, {'id': '101190410', 'city': '姑苏', 'province': '江苏', 'leader': '苏州'}, {'id': '101190501', 'city': '南通', 'province': '江苏', 'leader': '南通'}, {'id': '101190502', 'city': '海安', 'province': '江苏', 'leader': '南通'}, {'id': '101190503', 'city': '如皋', 'province': '江苏', 'leader': '南通'}, {'id': '101190504', 'city': '如东', 'province': '江苏', 'leader': '南通'}, {'id': '101190505', 'city': '崇川', 'province': '江苏', 'leader': '南通'}, {'id': '101190506', 'city': '港闸', 'province': '江苏', 'leader': '南通'}, {'id': '101190507', 'city': '启东', 'province': '江苏', 'leader': '南通'}, {'id': '101190508', 'city': '海门', 'province': '江苏', 'leader': '南通'}, {'id': '101190509', 'city': '通州', 'province': '江苏', 'leader': '南通'}, {'id': '101190601', 'city': '扬州', 'province': '江苏', 'leader': '扬州'}, {'id': '101190602', 'city': '宝应', 'province': '江苏', 'leader': '扬州'}, {'id': '101190603', 'city': '仪征', 'province': '江苏', 'leader': '扬州'}, {'id': '101190604', 'city': '高邮', 'province': '江苏', 'leader': '扬州'}, {'id': '101190605', 'city': '江都', 'province': '江苏', 'leader': '扬州'}, {'id': '101190606', 'city': '邗江', 'province': '江苏', 'leader': '扬州'}, {'id': '101190607', 'city': '广陵', 'province': '江苏', 'leader': '扬州'}, {'id': '101190701', 'city': '盐城', 'province': '江苏', 'leader': '盐城'}, {'id': '101190702', 'city': '响水', 'province': '江苏', 'leader': '盐城'}, {'id': '101190703', 'city': '滨海', 'province': '江苏', 'leader': '盐城'}, {'id': '101190704', 'city': '阜宁', 'province': '江苏', 'leader': '盐城'}, {'id': '101190705', 'city': '射阳', 'province': '江苏', 'leader': '盐城'}, {'id': '101190706', 'city': '建湖', 'province': '江苏', 'leader': '盐城'}, {'id': '101190707', 'city': '东台', 'province': '江苏', 'leader': '盐城'}, {'id': '101190708', 'city': '大丰', 'province': '江苏', 'leader': '盐城'}, {'id': '101190709', 'city': '盐都', 'province': '江苏', 'leader': '盐城'}, {'id': '101190710', 'city': '亭湖', 'province': '江苏', 'leader': '盐城'}, {'id': '101190801', 'city': '徐州', 'province': '江苏', 'leader': '徐州'}, {'id': '101190802', 'city': '铜山', 'province': '江苏', 'leader': '徐州'}, {'id': '101190803', 'city': '丰县', 'province': '江苏', 'leader': '徐州'}, {'id': '101190804', 'city': '沛县', 'province': '江苏', 'leader': '徐州'}, {'id': '101190805', 'city': '邳州', 'province': '江苏', 'leader': '徐州'}, {'id': '101190806', 'city': '睢宁', 'province': '江苏', 'leader': '徐州'}, {'id': '101190807', 'city': '新沂', 'province': '江苏', 'leader': '徐州'}, {'id': '101190808', 'city': '鼓楼', 'province': '江苏', 'leader': '徐州'}, {'id': '101190809', 'city': '云龙', 'province': '江苏', 'leader': '徐州'}, {'id': '101190810', 'city': '贾汪', 'province': '江苏', 'leader': '徐州'}, {'id': '101190811', 'city': '泉山', 'province': '江苏', 'leader': '徐州'}, {'id': '101190901', 'city': '淮安', 'province': '江苏', 'leader': '淮安'}, {'id': '101190902', 'city': '金湖', 'province': '江苏', 'leader': '淮安'}, {'id': '101190903', 'city': '盱眙', 'province': '江苏', 'leader': '淮安'}, {'id': '101190904', 'city': '洪泽', 'province': '江苏', 'leader': '淮安'}, {'id': '101190905', 'city': '涟水', 'province': '江苏', 'leader': '淮安'}, {'id': '101190906', 'city': '淮阴区', 'province': '江苏', 'leader': '淮安'}, {'id': '101190907', 'city': '清河', 'province': '江苏', 'leader': '淮安'}, {'id': '101190908', 'city': '淮安区', 'province': '江苏', 'leader': '淮安'}, {'id': '101190909', 'city': '清浦', 'province': '江苏', 'leader': '淮安'}, {'id': '101191001', 'city': '连云港', 'province': '江苏', 'leader': '连云港'}, {'id': '101191002', 'city': '东海', 'province': '江苏', 'leader': '连云港'}, {'id': '101191003', 'city': '赣榆', 'province': '江苏', 'leader': '连云港'}, {'id': '101191004', 'city': '灌云', 'province': '江苏', 'leader': '连云港'}, {'id': '101191005', 'city': '灌南', 'province': '江苏', 'leader': '连云港'}, {'id': '101191006', 'city': '海州', 'province': '江苏', 'leader': '连云港'}, {'id': '101191101', 'city': '常州', 'province': '江苏', 'leader': '常州'}, {'id': '101191102', 'city': '溧阳', 'province': '江苏', 'leader': '常州'}, {'id': '101191103', 'city': '金坛', 'province': '江苏', 'leader': '常州'}, {'id': '101191104', 'city': '武进', 'province': '江苏', 'leader': '常州'}, {'id': '101191105', 'city': '天宁', 'province': '江苏', 'leader': '常州'}, {'id': '101191106', 'city': '钟楼', 'province': '江苏', 'leader': '常州'}, {'id': '101191107', 'city': '新北', 'province': '江苏', 'leader': '常州'}, {'id': '101191201', 'city': '泰州', 'province': '江苏', 'leader': '泰州'}, {'id': '101191202', 'city': '兴化', 'province': '江苏', 'leader': '泰州'}, {'id': '101191203', 'city': '泰兴', 'province': '江苏', 'leader': '泰州'}, {'id': '101191204', 'city': '姜堰', 'province': '江苏', 'leader': '泰州'}, {'id': '101191205', 'city': '靖江', 'province': '江苏', 'leader': '泰州'}, {'id': '101191206', 'city': '海陵', 'province': '江苏', 'leader': '泰州'}, {'id': '101191207', 'city': '高港', 'province': '江苏', 'leader': '泰州'}, {'id': '101191301', 'city': '宿迁', 'province': '江苏', 'leader': '宿迁'}, {'id': '101191302', 'city': '沭阳', 'province': '江苏', 'leader': '宿迁'}, {'id': '101191303', 'city': '泗阳', 'province': '江苏', 'leader': '宿迁'}, {'id': '101191304', 'city': '泗洪', 'province': '江苏', 'leader': '宿迁'}, {'id': '101191305', 'city': '宿豫', 'province': '江苏', 'leader': '宿迁'}, {'id': '101191306', 'city': '宿城', 'province': '江苏', 'leader': '宿迁'}, {'id': '101200101', 'city': '武汉', 'province': '湖北', 'leader': '武汉'}, {'id': '101200102', 'city': '蔡甸', 'province': '湖北', 'leader': '武汉'}, {'id': '101200103', 'city': '黄陂', 'province': '湖北', 'leader': '武汉'}, {'id': '101200104', 'city': '新洲', 'province': '湖北', 'leader': '武汉'}, {'id': '101200105', 'city': '江夏', 'province': '湖北', 'leader': '武汉'}, {'id': '101200106', 'city': '东西湖', 'province': '湖北', 'leader': '武汉'}, {'id': '101200107', 'city': '江岸', 'province': '湖北', 'leader': '武汉'}, {'id': '101200108', 'city': '江汉', 'province': '湖北', 'leader': '武汉'}, {'id': '101200109', 'city': '硚口', 'province': '湖北', 'leader': '武汉'}, {'id': '101200110', 'city': '汉阳', 'province': '湖北', 'leader': '武汉'}, {'id': '101200111', 'city': '武昌', 'province': '湖北', 'leader': '武汉'}, {'id': '101200112', 'city': '青山', 'province': '湖北', 'leader': '武汉'}, {'id': '101200113', 'city': '洪山', 'province': '湖北', 'leader': '武汉'}, {'id': '101200114', 'city': '汉南', 'province': '湖北', 'leader': '武汉'}, {'id': '101200201', 'city': '襄阳', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200202', 'city': '襄州', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200203', 'city': '保康', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200204', 'city': '南漳', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200205', 'city': '宜城', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200206', 'city': '老河口', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200207', 'city': '谷城', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200208', 'city': '枣阳', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200209', 'city': '襄城', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200210', 'city': '樊城', 'province': '湖北', 'leader': '襄阳'}, {'id': '101200301', 'city': '鄂州', 'province': '湖北', 'leader': '鄂州'}, {'id': '101200302', 'city': '梁子湖', 'province': '湖北', 'leader': '鄂州'}, {'id': '101200303', 'city': '华容', 'province': '湖北', 'leader': '鄂州'}, {'id': '101200304', 'city': '鄂城', 'province': '湖北', 'leader': '鄂州'}, {'id': '101200401', 'city': '孝感', 'province': '湖北', 'leader': '孝感'}, {'id': '101200402', 'city': '安陆', 'province': '湖北', 'leader': '孝感'}, {'id': '101200403', 'city': '云梦', 'province': '湖北', 'leader': '孝感'}, {'id': '101200404', 'city': '大悟', 'province': '湖北', 'leader': '孝感'}, {'id': '101200405', 'city': '应城', 'province': '湖北', 'leader': '孝感'}, {'id': '101200406', 'city': '汉川', 'province': '湖北', 'leader': '孝感'}, {'id': '101200407', 'city': '孝昌', 'province': '湖北', 'leader': '孝感'}, {'id': '101200408', 'city': '孝南', 'province': '湖北', 'leader': '孝感'}, {'id': '101200501', 'city': '黄冈', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200502', 'city': '红安', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200503', 'city': '麻城', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200504', 'city': '罗田', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200505', 'city': '英山', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200506', 'city': '浠水', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200507', 'city': '蕲春', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200508', 'city': '黄梅', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200509', 'city': '武穴', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200510', 'city': '团风', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200511', 'city': '黄州', 'province': '湖北', 'leader': '黄冈'}, {'id': '101200601', 'city': '黄石', 'province': '湖北', 'leader': '黄石'}, {'id': '101200602', 'city': '大冶', 'province': '湖北', 'leader': '黄石'}, {'id': '101200603', 'city': '阳新', 'province': '湖北', 'leader': '黄石'}, {'id': '101200604', 'city': '铁山', 'province': '湖北', 'leader': '黄石'}, {'id': '101200605', 'city': '下陆', 'province': '湖北', 'leader': '黄石'}, {'id': '101200606', 'city': '西塞山', 'province': '湖北', 'leader': '黄石'}, {'id': '101200607', 'city': '黄石港', 'province': '湖北', 'leader': '黄石'}, {'id': '101200701', 'city': '咸宁', 'province': '湖北', 'leader': '咸宁'}, {'id': '101200702', 'city': '赤壁', 'province': '湖北', 'leader': '咸宁'}, {'id': '101200703', 'city': '嘉鱼', 'province': '湖北', 'leader': '咸宁'}, {'id': '101200704', 'city': '崇阳', 'province': '湖北', 'leader': '咸宁'}, {'id': '101200705', 'city': '通城', 'province': '湖北', 'leader': '咸宁'}, {'id': '101200706', 'city': '通山', 'province': '湖北', 'leader': '咸宁'}, {'id': '101200707', 'city': '咸安', 'province': '湖北', 'leader': '咸宁'}, {'id': '101200801', 'city': '荆州', 'province': '湖北', 'leader': '荆州'}, {'id': '101200802', 'city': '江陵', 'province': '湖北', 'leader': '荆州'}, {'id': '101200803', 'city': '公安', 'province': '湖北', 'leader': '荆州'}, {'id': '101200804', 'city': '石首', 'province': '湖北', 'leader': '荆州'}, {'id': '101200805', 'city': '监利', 'province': '湖北', 'leader': '荆州'}, {'id': '101200806', 'city': '洪湖', 'province': '湖北', 'leader': '荆州'}, {'id': '101200807', 'city': '松滋', 'province': '湖北', 'leader': '荆州'}, {'id': '101200808', 'city': '沙市', 'province': '湖北', 'leader': '荆州'}, {'id': '101200901', 'city': '宜昌', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200902', 'city': '远安', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200903', 'city': '秭归', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200904', 'city': '兴山', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200905', 'city': '西陵', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200906', 'city': '五峰', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200907', 'city': '当阳', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200908', 'city': '长阳', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200909', 'city': '宜都', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200910', 'city': '枝江', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200912', 'city': '夷陵', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200913', 'city': '伍家岗', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200914', 'city': '点军', 'province': '湖北', 'leader': '宜昌'}, {'id': '101200915', 'city': '猇亭', 'province': '湖北', 'leader': '宜昌'}, {'id': '101201001', 'city': '恩施', 'province': '湖北', 'leader': '恩施'}, {'id': '101201002', 'city': '利川', 'province': '湖北', 'leader': '恩施'}, {'id': '101201003', 'city': '建始', 'province': '湖北', 'leader': '恩施'}, {'id': '101201004', 'city': '咸丰', 'province': '湖北', 'leader': '恩施'}, {'id': '101201005', 'city': '宣恩', 'province': '湖北', 'leader': '恩施'}, {'id': '101201006', 'city': '鹤峰', 'province': '湖北', 'leader': '恩施'}, {'id': '101201007', 'city': '来凤', 'province': '湖北', 'leader': '恩施'}, {'id': '101201008', 'city': '巴东', 'province': '湖北', 'leader': '恩施'}, {'id': '101201101', 'city': '十堰', 'province': '湖北', 'leader': '十堰'}, {'id': '101201102', 'city': '竹溪', 'province': '湖北', 'leader': '十堰'}, {'id': '101201103', 'city': '郧西', 'province': '湖北', 'leader': '十堰'}, {'id': '101201104', 'city': '郧阳', 'province': '湖北', 'leader': '十堰'}, {'id': '101201105', 'city': '竹山', 'province': '湖北', 'leader': '十堰'}, {'id': '101201106', 'city': '房县', 'province': '湖北', 'leader': '十堰'}, {'id': '101201107', 'city': '丹江口', 'province': '湖北', 'leader': '十堰'}, {'id': '101201108', 'city': '茅箭', 'province': '湖北', 'leader': '十堰'}, {'id': '101201109', 'city': '张湾', 'province': '湖北', 'leader': '十堰'}, {'id': '101201201', 'city': '神农架', 'province': '湖北', 'leader': '神农架'}, {'id': '101201301', 'city': '随州', 'province': '湖北', 'leader': '随州'}, {'id': '101201302', 'city': '广水', 'province': '湖北', 'leader': '随州'}, {'id': '101201303', 'city': '曾都', 'province': '湖北', 'leader': '随州'}, {'id': '101201304', 'city': '随县', 'province': '湖北', 'leader': '随州'}, {'id': '101201401', 'city': '荆门', 'province': '湖北', 'leader': '荆门'}, {'id': '101201402', 'city': '钟祥', 'province': '湖北', 'leader': '荆门'}, {'id': '101201403', 'city': '京山', 'province': '湖北', 'leader': '荆门'}, {'id': '101201404', 'city': '掇刀', 'province': '湖北', 'leader': '荆门'}, {'id': '101201405', 'city': '沙洋', 'province': '湖北', 'leader': '荆门'}, {'id': '101201406', 'city': '东宝', 'province': '湖北', 'leader': '荆门'}, {'id': '101201501', 'city': '天门', 'province': '湖北', 'leader': '天门'}, {'id': '101201601', 'city': '仙桃', 'province': '湖北', 'leader': '仙桃'}, {'id': '101201701', 'city': '潜江', 'province': '湖北', 'leader': '潜江'}, {'id': '101210101', 'city': '杭州', 'province': '浙江', 'leader': '杭州'}, {'id': '101210102', 'city': '萧山', 'province': '浙江', 'leader': '杭州'}, {'id': '101210103', 'city': '桐庐', 'province': '浙江', 'leader': '杭州'}, {'id': '101210104', 'city': '淳安', 'province': '浙江', 'leader': '杭州'}, {'id': '101210105', 'city': '建德', 'province': '浙江', 'leader': '杭州'}, {'id': '101210106', 'city': '余杭', 'province': '浙江', 'leader': '杭州'}, {'id': '101210107', 'city': '临安', 'province': '浙江', 'leader': '杭州'}, {'id': '101210108', 'city': '富阳', 'province': '浙江', 'leader': '杭州'}, {'id': '101210109', 'city': '上城', 'province': '浙江', 'leader': '杭州'}, {'id': '101210110', 'city': '下城', 'province': '浙江', 'leader': '杭州'}, {'id': '101210111', 'city': '江干', 'province': '浙江', 'leader': '杭州'}, {'id': '101210112', 'city': '拱墅', 'province': '浙江', 'leader': '杭州'}, {'id': '101210113', 'city': '西湖', 'province': '浙江', 'leader': '杭州'}, {'id': '101210114', 'city': '滨江', 'province': '浙江', 'leader': '杭州'}, {'id': '101210201', 'city': '湖州', 'province': '浙江', 'leader': '湖州'}, {'id': '101210202', 'city': '长兴', 'province': '浙江', 'leader': '湖州'}, {'id': '101210203', 'city': '安吉', 'province': '浙江', 'leader': '湖州'}, {'id': '101210204', 'city': '德清', 'province': '浙江', 'leader': '湖州'}, {'id': '101210205', 'city': '吴兴', 'province': '浙江', 'leader': '湖州'}, {'id': '101210206', 'city': '南浔', 'province': '浙江', 'leader': '湖州'}, {'id': '101210301', 'city': '嘉兴', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210302', 'city': '嘉善', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210303', 'city': '海宁', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210304', 'city': '桐乡', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210305', 'city': '平湖', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210306', 'city': '海盐', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210307', 'city': '南湖', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210308', 'city': '秀洲', 'province': '浙江', 'leader': '嘉兴'}, {'id': '101210401', 'city': '宁波', 'province': '浙江', 'leader': '宁波'}, {'id': '101210402', 'city': '海曙', 'province': '浙江', 'leader': '宁波'}, {'id': '101210403', 'city': '慈溪', 'province': '浙江', 'leader': '宁波'}, {'id': '101210404', 'city': '余姚', 'province': '浙江', 'leader': '宁波'}, {'id': '101210405', 'city': '奉化', 'province': '浙江', 'leader': '宁波'}, {'id': '101210406', 'city': '象山', 'province': '浙江', 'leader': '宁波'}, {'id': '101210407', 'city': '江东', 'province': '浙江', 'leader': '宁波'}, {'id': '101210408', 'city': '宁海', 'province': '浙江', 'leader': '宁波'}, {'id': '101210409', 'city': '江北', 'province': '浙江', 'leader': '宁波'}, {'id': '101210410', 'city': '北仑', 'province': '浙江', 'leader': '宁波'}, {'id': '101210411', 'city': '鄞州', 'province': '浙江', 'leader': '宁波'}, {'id': '101210412', 'city': '镇海', 'province': '浙江', 'leader': '宁波'}, {'id': '101210501', 'city': '越城', 'province': '浙江', 'leader': '绍兴'}, {'id': '101210502', 'city': '诸暨', 'province': '浙江', 'leader': '绍兴'}, {'id': '101210503', 'city': '上虞', 'province': '浙江', 'leader': '绍兴'}, {'id': '101210504', 'city': '新昌', 'province': '浙江', 'leader': '绍兴'}, {'id': '101210505', 'city': '嵊州', 'province': '浙江', 'leader': '绍兴'}, {'id': '101210506', 'city': '柯桥', 'province': '浙江', 'leader': '绍兴'}, {'id': '101210507', 'city': '绍兴', 'province': '浙江', 'leader': '绍兴'}, {'id': '101210601', 'city': '台州', 'province': '浙江', 'leader': '台州'}, {'id': '101210603', 'city': '玉环', 'province': '浙江', 'leader': '台州'}, {'id': '101210604', 'city': '三门', 'province': '浙江', 'leader': '台州'}, {'id': '101210605', 'city': '天台', 'province': '浙江', 'leader': '台州'}, {'id': '101210606', 'city': '仙居', 'province': '浙江', 'leader': '台州'}, {'id': '101210607', 'city': '温岭', 'province': '浙江', 'leader': '台州'}, {'id': '101210610', 'city': '临海', 'province': '浙江', 'leader': '台州'}, {'id': '101210611', 'city': '椒江', 'province': '浙江', 'leader': '台州'}, {'id': '101210612', 'city': '黄岩', 'province': '浙江', 'leader': '台州'}, {'id': '101210613', 'city': '路桥', 'province': '浙江', 'leader': '台州'}, {'id': '101210701', 'city': '温州', 'province': '浙江', 'leader': '温州'}, {'id': '101210702', 'city': '泰顺', 'province': '浙江', 'leader': '温州'}, {'id': '101210703', 'city': '文成', 'province': '浙江', 'leader': '温州'}, {'id': '101210704', 'city': '平阳', 'province': '浙江', 'leader': '温州'}, {'id': '101210705', 'city': '瑞安', 'province': '浙江', 'leader': '温州'}, {'id': '101210706', 'city': '洞头', 'province': '浙江', 'leader': '温州'}, {'id': '101210707', 'city': '乐清', 'province': '浙江', 'leader': '温州'}, {'id': '101210708', 'city': '永嘉', 'province': '浙江', 'leader': '温州'}, {'id': '101210709', 'city': '苍南', 'province': '浙江', 'leader': '温州'}, {'id': '101210710', 'city': '鹿城', 'province': '浙江', 'leader': '温州'}, {'id': '101210711', 'city': '龙湾', 'province': '浙江', 'leader': '温州'}, {'id': '101210712', 'city': '瓯海', 'province': '浙江', 'leader': '温州'}, {'id': '101210801', 'city': '丽水', 'province': '浙江', 'leader': '丽水'}, {'id': '101210802', 'city': '遂昌', 'province': '浙江', 'leader': '丽水'}, {'id': '101210803', 'city': '龙泉', 'province': '浙江', 'leader': '丽水'}, {'id': '101210804', 'city': '缙云', 'province': '浙江', 'leader': '丽水'}, {'id': '101210805', 'city': '青田', 'province': '浙江', 'leader': '丽水'}, {'id': '101210806', 'city': '云和', 'province': '浙江', 'leader': '丽水'}, {'id': '101210807', 'city': '庆元', 'province': '浙江', 'leader': '丽水'}, {'id': '101210808', 'city': '松阳', 'province': '浙江', 'leader': '丽水'}, {'id': '101210809', 'city': '景宁', 'province': '浙江', 'leader': '丽水'}, {'id': '101210810', 'city': '莲都', 'province': '浙江', 'leader': '丽水'}, {'id': '101210901', 'city': '金华', 'province': '浙江', 'leader': '金华'}, {'id': '101210902', 'city': '浦江', 'province': '浙江', 'leader': '金华'}, {'id': '101210903', 'city': '兰溪', 'province': '浙江', 'leader': '金华'}, {'id': '101210904', 'city': '义乌', 'province': '浙江', 'leader': '金华'}, {'id': '101210905', 'city': '东阳', 'province': '浙江', 'leader': '金华'}, {'id': '101210906', 'city': '武义', 'province': '浙江', 'leader': '金华'}, {'id': '101210907', 'city': '永康', 'province': '浙江', 'leader': '金华'}, {'id': '101210908', 'city': '磐安', 'province': '浙江', 'leader': '金华'}, {'id': '101210909', 'city': '婺城', 'province': '浙江', 'leader': '金华'}, {'id': '101210910', 'city': '金东', 'province': '浙江', 'leader': '金华'}, {'id': '101211001', 'city': '衢州', 'province': '浙江', 'leader': '衢州'}, {'id': '101211002', 'city': '常山', 'province': '浙江', 'leader': '衢州'}, {'id': '101211003', 'city': '开化', 'province': '浙江', 'leader': '衢州'}, {'id': '101211004', 'city': '龙游', 'province': '浙江', 'leader': '衢州'}, {'id': '101211005', 'city': '江山', 'province': '浙江', 'leader': '衢州'}, {'id': '101211006', 'city': '衢江', 'province': '浙江', 'leader': '衢州'}, {'id': '101211007', 'city': '柯城', 'province': '浙江', 'leader': '衢州'}, {'id': '101211101', 'city': '舟山', 'province': '浙江', 'leader': '舟山'}, {'id': '101211102', 'city': '嵊泗', 'province': '浙江', 'leader': '舟山'}, {'id': '101211104', 'city': '岱山', 'province': '浙江', 'leader': '舟山'}, {'id': '101211105', 'city': '普陀', 'province': '浙江', 'leader': '舟山'}, {'id': '101211106', 'city': '定海', 'province': '浙江', 'leader': '舟山'}, {'id': '101220101', 'city': '合肥', 'province': '安徽', 'leader': '合肥'}, {'id': '101220102', 'city': '长丰', 'province': '安徽', 'leader': '合肥'}, {'id': '101220103', 'city': '肥东', 'province': '安徽', 'leader': '合肥'}, {'id': '101220104', 'city': '肥西', 'province': '安徽', 'leader': '合肥'}, {'id': '101220105', 'city': '巢湖', 'province': '安徽', 'leader': '合肥'}, {'id': '101220106', 'city': '庐江', 'province': '安徽', 'leader': '合肥'}, {'id': '101220107', 'city': '瑶海', 'province': '安徽', 'leader': '合肥'}, {'id': '101220108', 'city': '庐阳', 'province': '安徽', 'leader': '合肥'}, {'id': '101220109', 'city': '蜀山', 'province': '安徽', 'leader': '合肥'}, {'id': '101220110', 'city': '包河', 'province': '安徽', 'leader': '合肥'}, {'id': '101220201', 'city': '蚌埠', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220202', 'city': '怀远', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220203', 'city': '固镇', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220204', 'city': '五河', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220205', 'city': '龙子湖', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220206', 'city': '蚌山', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220207', 'city': '禹会', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220208', 'city': '淮上', 'province': '安徽', 'leader': '蚌埠'}, {'id': '101220301', 'city': '芜湖', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220302', 'city': '繁昌', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220303', 'city': '芜湖县', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220304', 'city': '南陵', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220305', 'city': '无为', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220306', 'city': '镜湖', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220307', 'city': '弋江', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220308', 'city': '鸠江', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220309', 'city': '三山', 'province': '安徽', 'leader': '芜湖'}, {'id': '101220401', 'city': '淮南', 'province': '安徽', 'leader': '淮南'}, {'id': '101220402', 'city': '凤台', 'province': '安徽', 'leader': '淮南'}, {'id': '101220403', 'city': '潘集', 'province': '安徽', 'leader': '淮南'}, {'id': '101220404', 'city': '大通', 'province': '安徽', 'leader': '淮南'}, {'id': '101220405', 'city': '田家庵', 'province': '安徽', 'leader': '淮南'}, {'id': '101220406', 'city': '谢家集', 'province': '安徽', 'leader': '淮南'}, {'id': '101220407', 'city': '八公山', 'province': '安徽', 'leader': '淮南'}, {'id': '101220408', 'city': '寿县', 'province': '安徽', 'leader': '淮南'}, {'id': '101220501', 'city': '马鞍山', 'province': '安徽', 'leader': '马鞍山'}, {'id': '101220502', 'city': '当涂', 'province': '安徽', 'leader': '马鞍山'}, {'id': '101220503', 'city': '含山', 'province': '安徽', 'leader': '马鞍山'}, {'id': '101220504', 'city': '和县', 'province': '安徽', 'leader': '马鞍山'}, {'id': '101220505', 'city': '花山', 'province': '安徽', 'leader': '马鞍山'}, {'id': '101220506', 'city': '雨山', 'province': '安徽', 'leader': '马鞍山'}, {'id': '101220507', 'city': '博望', 'province': '安徽', 'leader': '马鞍山'}, {'id': '101220601', 'city': '安庆', 'province': '安徽', 'leader': '安庆'}, {'id': '101220603', 'city': '太湖', 'province': '安徽', 'leader': '安庆'}, {'id': '101220604', 'city': '潜山', 'province': '安徽', 'leader': '安庆'}, {'id': '101220605', 'city': '怀宁', 'province': '安徽', 'leader': '安庆'}, {'id': '101220606', 'city': '宿松', 'province': '安徽', 'leader': '安庆'}, {'id': '101220607', 'city': '望江', 'province': '安徽', 'leader': '安庆'}, {'id': '101220608', 'city': '岳西', 'province': '安徽', 'leader': '安庆'}, {'id': '101220609', 'city': '桐城', 'province': '安徽', 'leader': '安庆'}, {'id': '101220610', 'city': '迎江', 'province': '安徽', 'leader': '安庆'}, {'id': '101220611', 'city': '大观', 'province': '安徽', 'leader': '安庆'}, {'id': '101220612', 'city': '宜秀', 'province': '安徽', 'leader': '安庆'}, {'id': '101220701', 'city': '宿州', 'province': '安徽', 'leader': '宿州'}, {'id': '101220702', 'city': '砀山', 'province': '安徽', 'leader': '宿州'}, {'id': '101220703', 'city': '灵璧', 'province': '安徽', 'leader': '宿州'}, {'id': '101220704', 'city': '泗县', 'province': '安徽', 'leader': '宿州'}, {'id': '101220705', 'city': '萧县', 'province': '安徽', 'leader': '宿州'}, {'id': '101220706', 'city': '埇桥', 'province': '安徽', 'leader': '宿州'}, {'id': '101220801', 'city': '阜阳', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220802', 'city': '阜南', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220803', 'city': '颍上', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220804', 'city': '临泉', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220805', 'city': '界首', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220806', 'city': '太和', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220807', 'city': '颍州', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220808', 'city': '颍东', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220809', 'city': '颍泉', 'province': '安徽', 'leader': '阜阳'}, {'id': '101220901', 'city': '亳州', 'province': '安徽', 'leader': '亳州'}, {'id': '101220902', 'city': '涡阳', 'province': '安徽', 'leader': '亳州'}, {'id': '101220903', 'city': '利辛', 'province': '安徽', 'leader': '亳州'}, {'id': '101220904', 'city': '蒙城', 'province': '安徽', 'leader': '亳州'}, {'id': '101220905', 'city': '谯城', 'province': '安徽', 'leader': '亳州'}, {'id': '101221001', 'city': '黄山', 'province': '安徽', 'leader': '黄山'}, {'id': '101221002', 'city': '黄山区', 'province': '安徽', 'leader': '黄山'}, {'id': '101221003', 'city': '屯溪', 'province': '安徽', 'leader': '黄山'}, {'id': '101221004', 'city': '祁门', 'province': '安徽', 'leader': '黄山'}, {'id': '101221005', 'city': '黟县', 'province': '安徽', 'leader': '黄山'}, {'id': '101221006', 'city': '歙县', 'province': '安徽', 'leader': '黄山'}, {'id': '101221007', 'city': '休宁', 'province': '安徽', 'leader': '黄山'}, {'id': '101221009', 'city': '徽州', 'province': '安徽', 'leader': '黄山'}, {'id': '101221101', 'city': '滁州', 'province': '安徽', 'leader': '滁州'}, {'id': '101221102', 'city': '凤阳', 'province': '安徽', 'leader': '滁州'}, {'id': '101221103', 'city': '明光', 'province': '安徽', 'leader': '滁州'}, {'id': '101221104', 'city': '定远', 'province': '安徽', 'leader': '滁州'}, {'id': '101221105', 'city': '全椒', 'province': '安徽', 'leader': '滁州'}, {'id': '101221106', 'city': '来安', 'province': '安徽', 'leader': '滁州'}, {'id': '101221107', 'city': '天长', 'province': '安徽', 'leader': '滁州'}, {'id': '101221108', 'city': '琅琊', 'province': '安徽', 'leader': '滁州'}, {'id': '101221109', 'city': '南谯', 'province': '安徽', 'leader': '滁州'}, {'id': '101221201', 'city': '淮北', 'province': '安徽', 'leader': '淮北'}, {'id': '101221202', 'city': '濉溪', 'province': '安徽', 'leader': '淮北'}, {'id': '101221203', 'city': '杜集', 'province': '安徽', 'leader': '淮北'}, {'id': '101221204', 'city': '相山', 'province': '安徽', 'leader': '淮北'}, {'id': '101221205', 'city': '烈山', 'province': '安徽', 'leader': '淮北'}, {'id': '101221301', 'city': '铜陵', 'province': '安徽', 'leader': '铜陵'}, {'id': '101221302', 'city': '铜官', 'province': '安徽', 'leader': '铜陵'}, {'id': '101221303', 'city': '义安', 'province': '安徽', 'leader': '铜陵'}, {'id': '101221304', 'city': '郊区', 'province': '安徽', 'leader': '铜陵'}, {'id': '101221305', 'city': '枞阳', 'province': '安徽', 'leader': '铜陵'}, {'id': '101221401', 'city': '宣城', 'province': '安徽', 'leader': '宣城'}, {'id': '101221402', 'city': '泾县', 'province': '安徽', 'leader': '宣城'}, {'id': '101221403', 'city': '旌德', 'province': '安徽', 'leader': '宣城'}, {'id': '101221404', 'city': '宁国', 'province': '安徽', 'leader': '宣城'}, {'id': '101221405', 'city': '绩溪', 'province': '安徽', 'leader': '宣城'}, {'id': '101221406', 'city': '广德', 'province': '安徽', 'leader': '宣城'}, {'id': '101221407', 'city': '郎溪', 'province': '安徽', 'leader': '宣城'}, {'id': '101221408', 'city': '宣州', 'province': '安徽', 'leader': '宣城'}, {'id': '101221501', 'city': '六安', 'province': '安徽', 'leader': '六安'}, {'id': '101221502', 'city': '霍邱', 'province': '安徽', 'leader': '六安'}, {'id': '101221504', 'city': '金安', 'province': '安徽', 'leader': '六安'}, {'id': '101221505', 'city': '金寨', 'province': '安徽', 'leader': '六安'}, {'id': '101221506', 'city': '霍山', 'province': '安徽', 'leader': '六安'}, {'id': '101221507', 'city': '舒城', 'province': '安徽', 'leader': '六安'}, {'id': '101221508', 'city': '裕安', 'province': '安徽', 'leader': '六安'}, {'id': '101221509', 'city': '叶集', 'province': '安徽', 'leader': '六安'}, {'id': '101221701', 'city': '池州', 'province': '安徽', 'leader': '池州'}, {'id': '101221702', 'city': '东至', 'province': '安徽', 'leader': '池州'}, {'id': '101221703', 'city': '青阳', 'province': '安徽', 'leader': '池州'}, {'id': '101221704', 'city': '九华山', 'province': '安徽', 'leader': '池州'}, {'id': '101221705', 'city': '石台', 'province': '安徽', 'leader': '池州'}, {'id': '101221706', 'city': '贵池', 'province': '安徽', 'leader': '池州'}, {'id': '101230101', 'city': '福州', 'province': '福建', 'leader': '福州'}, {'id': '101230102', 'city': '闽清', 'province': '福建', 'leader': '福州'}, {'id': '101230103', 'city': '闽侯', 'province': '福建', 'leader': '福州'}, {'id': '101230104', 'city': '罗源', 'province': '福建', 'leader': '福州'}, {'id': '101230105', 'city': '连江', 'province': '福建', 'leader': '福州'}, {'id': '101230106', 'city': '鼓楼', 'province': '福建', 'leader': '福州'}, {'id': '101230107', 'city': '永泰', 'province': '福建', 'leader': '福州'}, {'id': '101230108', 'city': '平潭', 'province': '福建', 'leader': '福州'}, {'id': '101230109', 'city': '台江', 'province': '福建', 'leader': '福州'}, {'id': '101230110', 'city': '长乐', 'province': '福建', 'leader': '福州'}, {'id': '101230111', 'city': '福清', 'province': '福建', 'leader': '福州'}, {'id': '101230112', 'city': '仓山', 'province': '福建', 'leader': '福州'}, {'id': '101230113', 'city': '马尾', 'province': '福建', 'leader': '福州'}, {'id': '101230114', 'city': '晋安', 'province': '福建', 'leader': '福州'}, {'id': '101230201', 'city': '厦门', 'province': '福建', 'leader': '厦门'}, {'id': '101230202', 'city': '同安', 'province': '福建', 'leader': '厦门'}, {'id': '101230203', 'city': '思明', 'province': '福建', 'leader': '厦门'}, {'id': '101230204', 'city': '海沧', 'province': '福建', 'leader': '厦门'}, {'id': '101230205', 'city': '湖里', 'province': '福建', 'leader': '厦门'}, {'id': '101230206', 'city': '集美', 'province': '福建', 'leader': '厦门'}, {'id': '101230207', 'city': '翔安', 'province': '福建', 'leader': '厦门'}, {'id': '101230301', 'city': '宁德', 'province': '福建', 'leader': '宁德'}, {'id': '101230302', 'city': '古田', 'province': '福建', 'leader': '宁德'}, {'id': '101230303', 'city': '霞浦', 'province': '福建', 'leader': '宁德'}, {'id': '101230304', 'city': '寿宁', 'province': '福建', 'leader': '宁德'}, {'id': '101230305', 'city': '周宁', 'province': '福建', 'leader': '宁德'}, {'id': '101230306', 'city': '福安', 'province': '福建', 'leader': '宁德'}, {'id': '101230307', 'city': '柘荣', 'province': '福建', 'leader': '宁德'}, {'id': '101230308', 'city': '福鼎', 'province': '福建', 'leader': '宁德'}, {'id': '101230309', 'city': '屏南', 'province': '福建', 'leader': '宁德'}, {'id': '101230310', 'city': '蕉城', 'province': '福建', 'leader': '宁德'}, {'id': '101230401', 'city': '莆田', 'province': '福建', 'leader': '莆田'}, {'id': '101230402', 'city': '仙游', 'province': '福建', 'leader': '莆田'}, {'id': '101230404', 'city': '涵江', 'province': '福建', 'leader': '莆田'}, {'id': '101230405', 'city': '秀屿', 'province': '福建', 'leader': '莆田'}, {'id': '101230406', 'city': '荔城', 'province': '福建', 'leader': '莆田'}, {'id': '101230407', 'city': '城厢', 'province': '福建', 'leader': '莆田'}, {'id': '101230501', 'city': '泉州', 'province': '福建', 'leader': '泉州'}, {'id': '101230502', 'city': '安溪', 'province': '福建', 'leader': '泉州'}, {'id': '101230503', 'city': '金门', 'province': '福建', 'leader': '泉州'}, {'id': '101230504', 'city': '永春', 'province': '福建', 'leader': '泉州'}, {'id': '101230505', 'city': '德化', 'province': '福建', 'leader': '泉州'}, {'id': '101230506', 'city': '南安', 'province': '福建', 'leader': '泉州'}, {'id': '101230508', 'city': '惠安', 'province': '福建', 'leader': '泉州'}, {'id': '101230509', 'city': '晋江', 'province': '福建', 'leader': '泉州'}, {'id': '101230510', 'city': '石狮', 'province': '福建', 'leader': '泉州'}, {'id': '101230511', 'city': '鲤城', 'province': '福建', 'leader': '泉州'}, {'id': '101230512', 'city': '丰泽', 'province': '福建', 'leader': '泉州'}, {'id': '101230513', 'city': '洛江', 'province': '福建', 'leader': '泉州'}, {'id': '101230514', 'city': '泉港', 'province': '福建', 'leader': '泉州'}, {'id': '101230601', 'city': '漳州', 'province': '福建', 'leader': '漳州'}, {'id': '101230602', 'city': '长泰', 'province': '福建', 'leader': '漳州'}, {'id': '101230603', 'city': '南靖', 'province': '福建', 'leader': '漳州'}, {'id': '101230604', 'city': '平和', 'province': '福建', 'leader': '漳州'}, {'id': '101230605', 'city': '龙海', 'province': '福建', 'leader': '漳州'}, {'id': '101230606', 'city': '漳浦', 'province': '福建', 'leader': '漳州'}, {'id': '101230607', 'city': '诏安', 'province': '福建', 'leader': '漳州'}, {'id': '101230608', 'city': '东山', 'province': '福建', 'leader': '漳州'}, {'id': '101230609', 'city': '云霄', 'province': '福建', 'leader': '漳州'}, {'id': '101230610', 'city': '华安', 'province': '福建', 'leader': '漳州'}, {'id': '101230611', 'city': '芗城', 'province': '福建', 'leader': '漳州'}, {'id': '101230612', 'city': '龙文', 'province': '福建', 'leader': '漳州'}, {'id': '101230701', 'city': '龙岩', 'province': '福建', 'leader': '龙岩'}, {'id': '101230702', 'city': '长汀', 'province': '福建', 'leader': '龙岩'}, {'id': '101230703', 'city': '连城', 'province': '福建', 'leader': '龙岩'}, {'id': '101230704', 'city': '武平', 'province': '福建', 'leader': '龙岩'}, {'id': '101230705', 'city': '上杭', 'province': '福建', 'leader': '龙岩'}, {'id': '101230706', 'city': '永定', 'province': '福建', 'leader': '龙岩'}, {'id': '101230707', 'city': '漳平', 'province': '福建', 'leader': '龙岩'}, {'id': '101230708', 'city': '新罗', 'province': '福建', 'leader': '龙岩'}, {'id': '101230801', 'city': '三明', 'province': '福建', 'leader': '三明'}, {'id': '101230802', 'city': '宁化', 'province': '福建', 'leader': '三明'}, {'id': '101230803', 'city': '清流', 'province': '福建', 'leader': '三明'}, {'id': '101230804', 'city': '泰宁', 'province': '福建', 'leader': '三明'}, {'id': '101230805', 'city': '将乐', 'province': '福建', 'leader': '三明'}, {'id': '101230806', 'city': '建宁', 'province': '福建', 'leader': '三明'}, {'id': '101230807', 'city': '明溪', 'province': '福建', 'leader': '三明'}, {'id': '101230808', 'city': '沙县', 'province': '福建', 'leader': '三明'}, {'id': '101230809', 'city': '尤溪', 'province': '福建', 'leader': '三明'}, {'id': '101230810', 'city': '永安', 'province': '福建', 'leader': '三明'}, {'id': '101230811', 'city': '大田', 'province': '福建', 'leader': '三明'}, {'id': '101230812', 'city': '梅列', 'province': '福建', 'leader': '三明'}, {'id': '101230813', 'city': '三元', 'province': '福建', 'leader': '三明'}, {'id': '101230901', 'city': '南平', 'province': '福建', 'leader': '南平'}, {'id': '101230902', 'city': '顺昌', 'province': '福建', 'leader': '南平'}, {'id': '101230903', 'city': '光泽', 'province': '福建', 'leader': '南平'}, {'id': '101230904', 'city': '邵武', 'province': '福建', 'leader': '南平'}, {'id': '101230905', 'city': '武夷山', 'province': '福建', 'leader': '南平'}, {'id': '101230906', 'city': '浦城', 'province': '福建', 'leader': '南平'}, {'id': '101230907', 'city': '建阳', 'province': '福建', 'leader': '南平'}, {'id': '101230908', 'city': '松溪', 'province': '福建', 'leader': '南平'}, {'id': '101230909', 'city': '政和', 'province': '福建', 'leader': '南平'}, {'id': '101230910', 'city': '建瓯', 'province': '福建', 'leader': '南平'}, {'id': '101230911', 'city': '延平', 'province': '福建', 'leader': '南平'}, {'id': '101231001', 'city': '钓鱼岛', 'province': '福建', 'leader': '钓鱼岛'}, {'id': '101240101', 'city': '南昌', 'province': '江西', 'leader': '南昌'}, {'id': '101240102', 'city': '新建', 'province': '江西', 'leader': '南昌'}, {'id': '101240103', 'city': '南昌县', 'province': '江西', 'leader': '南昌'}, {'id': '101240104', 'city': '安义', 'province': '江西', 'leader': '南昌'}, {'id': '101240105', 'city': '进贤', 'province': '江西', 'leader': '南昌'}, {'id': '101240106', 'city': '东湖', 'province': '江西', 'leader': '南昌'}, {'id': '101240107', 'city': '西湖', 'province': '江西', 'leader': '南昌'}, {'id': '101240108', 'city': '青云谱', 'province': '江西', 'leader': '南昌'}, {'id': '101240109', 'city': '湾里', 'province': '江西', 'leader': '南昌'}, {'id': '101240110', 'city': '青山湖', 'province': '江西', 'leader': '南昌'}, {'id': '101240201', 'city': '九江', 'province': '江西', 'leader': '九江'}, {'id': '101240202', 'city': '瑞昌', 'province': '江西', 'leader': '九江'}, {'id': '101240203', 'city': '庐山', 'province': '江西', 'leader': '九江'}, {'id': '101240204', 'city': '武宁', 'province': '江西', 'leader': '九江'}, {'id': '101240205', 'city': '德安', 'province': '江西', 'leader': '九江'}, {'id': '101240206', 'city': '永修', 'province': '江西', 'leader': '九江'}, {'id': '101240207', 'city': '湖口', 'province': '江西', 'leader': '九江'}, {'id': '101240208', 'city': '彭泽', 'province': '江西', 'leader': '九江'}, {'id': '101240209', 'city': '星子', 'province': '江西', 'leader': '九江'}, {'id': '101240210', 'city': '都昌', 'province': '江西', 'leader': '九江'}, {'id': '101240211', 'city': '浔阳', 'province': '江西', 'leader': '九江'}, {'id': '101240212', 'city': '修水', 'province': '江西', 'leader': '九江'}, {'id': '101240213', 'city': '共青城', 'province': '江西', 'leader': '九江'}, {'id': '101240301', 'city': '上饶', 'province': '江西', 'leader': '上饶'}, {'id': '101240302', 'city': '鄱阳', 'province': '江西', 'leader': '上饶'}, {'id': '101240303', 'city': '婺源', 'province': '江西', 'leader': '上饶'}, {'id': '101240304', 'city': '信州', 'province': '江西', 'leader': '上饶'}, {'id': '101240305', 'city': '余干', 'province': '江西', 'leader': '上饶'}, {'id': '101240306', 'city': '万年', 'province': '江西', 'leader': '上饶'}, {'id': '101240307', 'city': '德兴', 'province': '江西', 'leader': '上饶'}, {'id': '101240308', 'city': '上饶县', 'province': '江西', 'leader': '上饶'}, {'id': '101240309', 'city': '弋阳', 'province': '江西', 'leader': '上饶'}, {'id': '101240310', 'city': '横峰', 'province': '江西', 'leader': '上饶'}, {'id': '101240311', 'city': '铅山', 'province': '江西', 'leader': '上饶'}, {'id': '101240312', 'city': '玉山', 'province': '江西', 'leader': '上饶'}, {'id': '101240313', 'city': '广丰', 'province': '江西', 'leader': '上饶'}, {'id': '101240401', 'city': '抚州', 'province': '江西', 'leader': '抚州'}, {'id': '101240402', 'city': '广昌', 'province': '江西', 'leader': '抚州'}, {'id': '101240403', 'city': '乐安', 'province': '江西', 'leader': '抚州'}, {'id': '101240404', 'city': '崇仁', 'province': '江西', 'leader': '抚州'}, {'id': '101240405', 'city': '金溪', 'province': '江西', 'leader': '抚州'}, {'id': '101240406', 'city': '资溪', 'province': '江西', 'leader': '抚州'}, {'id': '101240407', 'city': '宜黄', 'province': '江西', 'leader': '抚州'}, {'id': '101240408', 'city': '南城', 'province': '江西', 'leader': '抚州'}, {'id': '101240409', 'city': '南丰', 'province': '江西', 'leader': '抚州'}, {'id': '101240410', 'city': '黎川', 'province': '江西', 'leader': '抚州'}, {'id': '101240411', 'city': '东乡', 'province': '江西', 'leader': '抚州'}, {'id': '101240412', 'city': '临川', 'province': '江西', 'leader': '抚州'}, {'id': '101240501', 'city': '宜春', 'province': '江西', 'leader': '宜春'}, {'id': '101240502', 'city': '铜鼓', 'province': '江西', 'leader': '宜春'}, {'id': '101240503', 'city': '宜丰', 'province': '江西', 'leader': '宜春'}, {'id': '101240504', 'city': '万载', 'province': '江西', 'leader': '宜春'}, {'id': '101240505', 'city': '上高', 'province': '江西', 'leader': '宜春'}, {'id': '101240506', 'city': '靖安', 'province': '江西', 'leader': '宜春'}, {'id': '101240507', 'city': '奉新', 'province': '江西', 'leader': '宜春'}, {'id': '101240508', 'city': '高安', 'province': '江西', 'leader': '宜春'}, {'id': '101240509', 'city': '樟树', 'province': '江西', 'leader': '宜春'}, {'id': '101240510', 'city': '丰城', 'province': '江西', 'leader': '宜春'}, {'id': '101240511', 'city': '袁州', 'province': '江西', 'leader': '宜春'}, {'id': '101240601', 'city': '吉安', 'province': '江西', 'leader': '吉安'}, {'id': '101240602', 'city': '吉安县', 'province': '江西', 'leader': '吉安'}, {'id': '101240603', 'city': '吉水', 'province': '江西', 'leader': '吉安'}, {'id': '101240604', 'city': '新干', 'province': '江西', 'leader': '吉安'}, {'id': '101240605', 'city': '峡江', 'province': '江西', 'leader': '吉安'}, {'id': '101240606', 'city': '永丰', 'province': '江西', 'leader': '吉安'}, {'id': '101240607', 'city': '永新', 'province': '江西', 'leader': '吉安'}, {'id': '101240608', 'city': '井冈山', 'province': '江西', 'leader': '吉安'}, {'id': '101240609', 'city': '万安', 'province': '江西', 'leader': '吉安'}, {'id': '101240610', 'city': '遂川', 'province': '江西', 'leader': '吉安'}, {'id': '101240611', 'city': '泰和', 'province': '江西', 'leader': '吉安'}, {'id': '101240612', 'city': '安福', 'province': '江西', 'leader': '吉安'}, {'id': '101240614', 'city': '吉州', 'province': '江西', 'leader': '吉安'}, {'id': '101240615', 'city': '青原', 'province': '江西', 'leader': '吉安'}, {'id': '101240701', 'city': '赣州', 'province': '江西', 'leader': '赣州'}, {'id': '101240702', 'city': '崇义', 'province': '江西', 'leader': '赣州'}, {'id': '101240703', 'city': '上犹', 'province': '江西', 'leader': '赣州'}, {'id': '101240704', 'city': '南康', 'province': '江西', 'leader': '赣州'}, {'id': '101240705', 'city': '大余', 'province': '江西', 'leader': '赣州'}, {'id': '101240706', 'city': '信丰', 'province': '江西', 'leader': '赣州'}, {'id': '101240707', 'city': '宁都', 'province': '江西', 'leader': '赣州'}, {'id': '101240708', 'city': '石城', 'province': '江西', 'leader': '赣州'}, {'id': '101240709', 'city': '瑞金', 'province': '江西', 'leader': '赣州'}, {'id': '101240710', 'city': '于都', 'province': '江西', 'leader': '赣州'}, {'id': '101240711', 'city': '会昌', 'province': '江西', 'leader': '赣州'}, {'id': '101240712', 'city': '安远', 'province': '江西', 'leader': '赣州'}, {'id': '101240713', 'city': '全南', 'province': '江西', 'leader': '赣州'}, {'id': '101240714', 'city': '龙南', 'province': '江西', 'leader': '赣州'}, {'id': '101240715', 'city': '定南', 'province': '江西', 'leader': '赣州'}, {'id': '101240716', 'city': '寻乌', 'province': '江西', 'leader': '赣州'}, {'id': '101240717', 'city': '兴国', 'province': '江西', 'leader': '赣州'}, {'id': '101240718', 'city': '赣县', 'province': '江西', 'leader': '赣州'}, {'id': '101240719', 'city': '章贡', 'province': '江西', 'leader': '赣州'}, {'id': '101240801', 'city': '景德镇', 'province': '江西', 'leader': '景德镇'}, {'id': '101240802', 'city': '乐平', 'province': '江西', 'leader': '景德镇'}, {'id': '101240803', 'city': '浮梁', 'province': '江西', 'leader': '景德镇'}, {'id': '101240804', 'city': '昌江', 'province': '江西', 'leader': '景德镇'}, {'id': '101240805', 'city': '珠山', 'province': '江西', 'leader': '景德镇'}, {'id': '101240901', 'city': '萍乡', 'province': '江西', 'leader': '萍乡'}, {'id': '101240902', 'city': '莲花', 'province': '江西', 'leader': '萍乡'}, {'id': '101240903', 'city': '上栗', 'province': '江西', 'leader': '萍乡'}, {'id': '101240904', 'city': '安源', 'province': '江西', 'leader': '萍乡'}, {'id': '101240905', 'city': '芦溪', 'province': '江西', 'leader': '萍乡'}, {'id': '101240906', 'city': '湘东', 'province': '江西', 'leader': '萍乡'}, {'id': '101241001', 'city': '新余', 'province': '江西', 'leader': '新余'}, {'id': '101241002', 'city': '分宜', 'province': '江西', 'leader': '新余'}, {'id': '101241003', 'city': '渝水', 'province': '江西', 'leader': '新余'}, {'id': '101241101', 'city': '鹰潭', 'province': '江西', 'leader': '鹰潭'}, {'id': '101241102', 'city': '余江', 'province': '江西', 'leader': '鹰潭'}, {'id': '101241103', 'city': '贵溪', 'province': '江西', 'leader': '鹰潭'}, {'id': '101241104', 'city': '月湖', 'province': '江西', 'leader': '鹰潭'}, {'id': '101250101', 'city': '长沙', 'province': '湖南', 'leader': '长沙'}, {'id': '101250102', 'city': '宁乡', 'province': '湖南', 'leader': '长沙'}, {'id': '101250103', 'city': '浏阳', 'province': '湖南', 'leader': '长沙'}, {'id': '101250104', 'city': '湘江新区', 'province': '湖南', 'leader': '长沙'}, {'id': '101250105', 'city': '望城', 'province': '湖南', 'leader': '长沙'}, {'id': '101250106', 'city': '长沙县', 'province': '湖南', 'leader': '长沙'}, {'id': '101250107', 'city': '芙蓉', 'province': '湖南', 'leader': '长沙'}, {'id': '101250108', 'city': '天心', 'province': '湖南', 'leader': '长沙'}, {'id': '101250109', 'city': '岳麓', 'province': '湖南', 'leader': '长沙'}, {'id': '101250110', 'city': '开福', 'province': '湖南', 'leader': '长沙'}, {'id': '101250111', 'city': '雨花', 'province': '湖南', 'leader': '长沙'}, {'id': '101250201', 'city': '湘潭', 'province': '湖南', 'leader': '湘潭'}, {'id': '101250202', 'city': '韶山', 'province': '湖南', 'leader': '湘潭'}, {'id': '101250203', 'city': '湘乡', 'province': '湖南', 'leader': '湘潭'}, {'id': '101250204', 'city': '雨湖', 'province': '湖南', 'leader': '湘潭'}, {'id': '101250205', 'city': '岳塘', 'province': '湖南', 'leader': '湘潭'}, {'id': '101250301', 'city': '株洲', 'province': '湖南', 'leader': '株洲'}, {'id': '101250302', 'city': '攸县', 'province': '湖南', 'leader': '株洲'}, {'id': '101250303', 'city': '醴陵', 'province': '湖南', 'leader': '株洲'}, {'id': '101250304', 'city': '荷塘', 'province': '湖南', 'leader': '株洲'}, {'id': '101250305', 'city': '茶陵', 'province': '湖南', 'leader': '株洲'}, {'id': '101250306', 'city': '炎陵', 'province': '湖南', 'leader': '株洲'}, {'id': '101250307', 'city': '芦淞', 'province': '湖南', 'leader': '株洲'}, {'id': '101250308', 'city': '石峰', 'province': '湖南', 'leader': '株洲'}, {'id': '101250309', 'city': '天元', 'province': '湖南', 'leader': '株洲'}, {'id': '101250401', 'city': '衡阳', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250402', 'city': '衡山', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250403', 'city': '衡东', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250404', 'city': '祁东', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250405', 'city': '衡阳县', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250406', 'city': '常宁', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250407', 'city': '衡南', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250408', 'city': '耒阳', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250409', 'city': '南岳', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250410', 'city': '珠晖', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250411', 'city': '雁峰', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250412', 'city': '石鼓', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250413', 'city': '蒸湘', 'province': '湖南', 'leader': '衡阳'}, {'id': '101250501', 'city': '郴州', 'province': '湖南', 'leader': '郴州'}, {'id': '101250502', 'city': '桂阳', 'province': '湖南', 'leader': '郴州'}, {'id': '101250503', 'city': '嘉禾', 'province': '湖南', 'leader': '郴州'}, {'id': '101250504', 'city': '宜章', 'province': '湖南', 'leader': '郴州'}, {'id': '101250505', 'city': '临武', 'province': '湖南', 'leader': '郴州'}, {'id': '101250506', 'city': '北湖', 'province': '湖南', 'leader': '郴州'}, {'id': '101250507', 'city': '资兴', 'province': '湖南', 'leader': '郴州'}, {'id': '101250508', 'city': '汝城', 'province': '湖南', 'leader': '郴州'}, {'id': '101250509', 'city': '安仁', 'province': '湖南', 'leader': '郴州'}, {'id': '101250510', 'city': '永兴', 'province': '湖南', 'leader': '郴州'}, {'id': '101250511', 'city': '桂东', 'province': '湖南', 'leader': '郴州'}, {'id': '101250512', 'city': '苏仙', 'province': '湖南', 'leader': '郴州'}, {'id': '101250601', 'city': '常德', 'province': '湖南', 'leader': '常德'}, {'id': '101250602', 'city': '安乡', 'province': '湖南', 'leader': '常德'}, {'id': '101250603', 'city': '桃源', 'province': '湖南', 'leader': '常德'}, {'id': '101250604', 'city': '汉寿', 'province': '湖南', 'leader': '常德'}, {'id': '101250605', 'city': '澧县', 'province': '湖南', 'leader': '常德'}, {'id': '101250606', 'city': '临澧', 'province': '湖南', 'leader': '常德'}, {'id': '101250607', 'city': '石门', 'province': '湖南', 'leader': '常德'}, {'id': '101250608', 'city': '津市', 'province': '湖南', 'leader': '常德'}, {'id': '101250609', 'city': '武陵', 'province': '湖南', 'leader': '常德'}, {'id': '101250610', 'city': '鼎城', 'province': '湖南', 'leader': '常德'}, {'id': '101250700', 'city': '益阳', 'province': '湖南', 'leader': '益阳'}, {'id': '101250701', 'city': '赫山区', 'province': '湖南', 'leader': '益阳'}, {'id': '101250702', 'city': '南县', 'province': '湖南', 'leader': '益阳'}, {'id': '101250703', 'city': '桃江', 'province': '湖南', 'leader': '益阳'}, {'id': '101250704', 'city': '安化', 'province': '湖南', 'leader': '益阳'}, {'id': '101250705', 'city': '沅江', 'province': '湖南', 'leader': '益阳'}, {'id': '101250706', 'city': '资阳', 'province': '湖南', 'leader': '益阳'}, {'id': '101250801', 'city': '娄底', 'province': '湖南', 'leader': '娄底'}, {'id': '101250802', 'city': '双峰', 'province': '湖南', 'leader': '娄底'}, {'id': '101250803', 'city': '冷水江', 'province': '湖南', 'leader': '娄底'}, {'id': '101250804', 'city': '娄星', 'province': '湖南', 'leader': '娄底'}, {'id': '101250805', 'city': '新化', 'province': '湖南', 'leader': '娄底'}, {'id': '101250806', 'city': '涟源', 'province': '湖南', 'leader': '娄底'}, {'id': '101250901', 'city': '邵阳', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250902', 'city': '隆回', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250903', 'city': '洞口', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250904', 'city': '新邵', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250905', 'city': '邵东', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250906', 'city': '绥宁', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250907', 'city': '新宁', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250908', 'city': '武冈', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250909', 'city': '城步', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250910', 'city': '邵阳县', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250911', 'city': '双清', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250912', 'city': '大祥', 'province': '湖南', 'leader': '邵阳'}, {'id': '101250913', 'city': '北塔', 'province': '湖南', 'leader': '邵阳'}, {'id': '101251001', 'city': '岳阳', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251002', 'city': '华容', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251003', 'city': '湘阴', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251004', 'city': '汨罗', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251005', 'city': '平江', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251006', 'city': '临湘', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251007', 'city': '岳阳楼区', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251008', 'city': '云溪', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251009', 'city': '君山', 'province': '湖南', 'leader': '岳阳'}, {'id': '101251101', 'city': '张家界', 'province': '湖南', 'leader': '张家界'}, {'id': '101251102', 'city': '桑植', 'province': '湖南', 'leader': '张家界'}, {'id': '101251103', 'city': '慈利', 'province': '湖南', 'leader': '张家界'}, {'id': '101251104', 'city': '武陵源', 'province': '湖南', 'leader': '张家界'}, {'id': '101251105', 'city': '永定', 'province': '湖南', 'leader': '张家界'}, {'id': '101251201', 'city': '怀化', 'province': '湖南', 'leader': '怀化'}, {'id': '101251202', 'city': '鹤城', 'province': '湖南', 'leader': '怀化'}, {'id': '101251203', 'city': '沅陵', 'province': '湖南', 'leader': '怀化'}, {'id': '101251204', 'city': '辰溪', 'province': '湖南', 'leader': '怀化'}, {'id': '101251205', 'city': '靖州', 'province': '湖南', 'leader': '怀化'}, {'id': '101251206', 'city': '会同', 'province': '湖南', 'leader': '怀化'}, {'id': '101251207', 'city': '通道', 'province': '湖南', 'leader': '怀化'}, {'id': '101251208', 'city': '麻阳', 'province': '湖南', 'leader': '怀化'}, {'id': '101251209', 'city': '新晃', 'province': '湖南', 'leader': '怀化'}, {'id': '101251210', 'city': '芷江', 'province': '湖南', 'leader': '怀化'}, {'id': '101251211', 'city': '溆浦', 'province': '湖南', 'leader': '怀化'}, {'id': '101251212', 'city': '中方', 'province': '湖南', 'leader': '怀化'}, {'id': '101251213', 'city': '洪江', 'province': '湖南', 'leader': '怀化'}, {'id': '101251401', 'city': '永州', 'province': '湖南', 'leader': '永州'}, {'id': '101251402', 'city': '祁阳', 'province': '湖南', 'leader': '永州'}, {'id': '101251403', 'city': '东安', 'province': '湖南', 'leader': '永州'}, {'id': '101251404', 'city': '双牌', 'province': '湖南', 'leader': '永州'}, {'id': '101251405', 'city': '道县', 'province': '湖南', 'leader': '永州'}, {'id': '101251406', 'city': '宁远', 'province': '湖南', 'leader': '永州'}, {'id': '101251407', 'city': '江永', 'province': '湖南', 'leader': '永州'}, {'id': '101251408', 'city': '蓝山', 'province': '湖南', 'leader': '永州'}, {'id': '101251409', 'city': '新田', 'province': '湖南', 'leader': '永州'}, {'id': '101251410', 'city': '江华', 'province': '湖南', 'leader': '永州'}, {'id': '101251411', 'city': '冷水滩', 'province': '湖南', 'leader': '永州'}, {'id': '101251412', 'city': '零陵', 'province': '湖南', 'leader': '永州'}, {'id': '101251501', 'city': '吉首', 'province': '湖南', 'leader': '湘西'}, {'id': '101251502', 'city': '保靖', 'province': '湖南', 'leader': '湘西'}, {'id': '101251503', 'city': '永顺', 'province': '湖南', 'leader': '湘西'}, {'id': '101251504', 'city': '古丈', 'province': '湖南', 'leader': '湘西'}, {'id': '101251505', 'city': '凤凰', 'province': '湖南', 'leader': '湘西'}, {'id': '101251506', 'city': '泸溪', 'province': '湖南', 'leader': '湘西'}, {'id': '101251507', 'city': '龙山', 'province': '湖南', 'leader': '湘西'}, {'id': '101251508', 'city': '花垣', 'province': '湖南', 'leader': '湘西'}, {'id': '101251509', 'city': '湘西', 'province': '湖南', 'leader': '湘西'}, {'id': '101260101', 'city': '贵阳', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260102', 'city': '白云', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260103', 'city': '花溪', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260104', 'city': '乌当', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260105', 'city': '息烽', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260106', 'city': '开阳', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260107', 'city': '修文', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260108', 'city': '清镇', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260110', 'city': '云岩', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260111', 'city': '南明', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260112', 'city': '观山湖', 'province': '贵州', 'leader': '贵阳'}, {'id': '101260201', 'city': '遵义', 'province': '贵州', 'leader': '遵义'}, {'id': '101260202', 'city': '遵义县', 'province': '贵州', 'leader': '遵义'}, {'id': '101260203', 'city': '仁怀', 'province': '贵州', 'leader': '遵义'}, {'id': '101260204', 'city': '绥阳', 'province': '贵州', 'leader': '遵义'}, {'id': '101260205', 'city': '湄潭', 'province': '贵州', 'leader': '遵义'}, {'id': '101260206', 'city': '凤冈', 'province': '贵州', 'leader': '遵义'}, {'id': '101260207', 'city': '桐梓', 'province': '贵州', 'leader': '遵义'}, {'id': '101260208', 'city': '赤水', 'province': '贵州', 'leader': '遵义'}, {'id': '101260209', 'city': '习水', 'province': '贵州', 'leader': '遵义'}, {'id': '101260210', 'city': '道真', 'province': '贵州', 'leader': '遵义'}, {'id': '101260211', 'city': '正安', 'province': '贵州', 'leader': '遵义'}, {'id': '101260212', 'city': '务川', 'province': '贵州', 'leader': '遵义'}, {'id': '101260213', 'city': '余庆', 'province': '贵州', 'leader': '遵义'}, {'id': '101260214', 'city': '汇川', 'province': '贵州', 'leader': '遵义'}, {'id': '101260215', 'city': '红花岗', 'province': '贵州', 'leader': '遵义'}, {'id': '101260216', 'city': '播州', 'province': '贵州', 'leader': '遵义'}, {'id': '101260301', 'city': '安顺', 'province': '贵州', 'leader': '安顺'}, {'id': '101260302', 'city': '普定', 'province': '贵州', 'leader': '安顺'}, {'id': '101260303', 'city': '镇宁', 'province': '贵州', 'leader': '安顺'}, {'id': '101260304', 'city': '平坝', 'province': '贵州', 'leader': '安顺'}, {'id': '101260305', 'city': '紫云', 'province': '贵州', 'leader': '安顺'}, {'id': '101260306', 'city': '关岭', 'province': '贵州', 'leader': '安顺'}, {'id': '101260307', 'city': '西秀', 'province': '贵州', 'leader': '安顺'}, {'id': '101260401', 'city': '都匀', 'province': '贵州', 'leader': '黔南'}, {'id': '101260402', 'city': '贵定', 'province': '贵州', 'leader': '黔南'}, {'id': '101260403', 'city': '瓮安', 'province': '贵州', 'leader': '黔南'}, {'id': '101260404', 'city': '长顺', 'province': '贵州', 'leader': '黔南'}, {'id': '101260405', 'city': '福泉', 'province': '贵州', 'leader': '黔南'}, {'id': '101260406', 'city': '惠水', 'province': '贵州', 'leader': '黔南'}, {'id': '101260407', 'city': '龙里', 'province': '贵州', 'leader': '黔南'}, {'id': '101260408', 'city': '罗甸', 'province': '贵州', 'leader': '黔南'}, {'id': '101260409', 'city': '平塘', 'province': '贵州', 'leader': '黔南'}, {'id': '101260410', 'city': '独山', 'province': '贵州', 'leader': '黔南'}, {'id': '101260411', 'city': '三都', 'province': '贵州', 'leader': '黔南'}, {'id': '101260412', 'city': '荔波', 'province': '贵州', 'leader': '黔南'}, {'id': '101260413', 'city': '黔南', 'province': '贵州', 'leader': '黔南'}, {'id': '101260501', 'city': '凯里', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260502', 'city': '岑巩', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260503', 'city': '施秉', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260504', 'city': '镇远', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260505', 'city': '黄平', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260506', 'city': '黔东南', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260507', 'city': '麻江', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260508', 'city': '丹寨', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260509', 'city': '三穗', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260510', 'city': '台江', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260511', 'city': '剑河', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260512', 'city': '雷山', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260513', 'city': '黎平', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260514', 'city': '天柱', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260515', 'city': '锦屏', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260516', 'city': '榕江', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260517', 'city': '从江', 'province': '贵州', 'leader': '黔东南'}, {'id': '101260601', 'city': '铜仁', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260602', 'city': '江口', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260603', 'city': '玉屏', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260604', 'city': '万山', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260605', 'city': '思南', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260606', 'city': '碧江', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260607', 'city': '印江', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260608', 'city': '石阡', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260609', 'city': '沿河', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260610', 'city': '德江', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260611', 'city': '松桃', 'province': '贵州', 'leader': '铜仁'}, {'id': '101260701', 'city': '毕节', 'province': '贵州', 'leader': '毕节'}, {'id': '101260702', 'city': '赫章', 'province': '贵州', 'leader': '毕节'}, {'id': '101260703', 'city': '金沙', 'province': '贵州', 'leader': '毕节'}, {'id': '101260704', 'city': '威宁', 'province': '贵州', 'leader': '毕节'}, {'id': '101260705', 'city': '大方', 'province': '贵州', 'leader': '毕节'}, {'id': '101260706', 'city': '纳雍', 'province': '贵州', 'leader': '毕节'}, {'id': '101260707', 'city': '织金', 'province': '贵州', 'leader': '毕节'}, {'id': '101260708', 'city': '黔西', 'province': '贵州', 'leader': '毕节'}, {'id': '101260709', 'city': '七星关', 'province': '贵州', 'leader': '毕节'}, {'id': '101260801', 'city': '水城', 'province': '贵州', 'leader': '六盘水'}, {'id': '101260802', 'city': '六枝', 'province': '贵州', 'leader': '六盘水'}, {'id': '101260803', 'city': '六盘水', 'province': '贵州', 'leader': '六盘水'}, {'id': '101260804', 'city': '盘县', 'province': '贵州', 'leader': '六盘水'}, {'id': '101260805', 'city': '钟山', 'province': '贵州', 'leader': '六盘水'}, {'id': '101260901', 'city': '兴义', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260902', 'city': '晴隆', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260903', 'city': '兴仁', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260904', 'city': '贞丰', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260905', 'city': '望谟', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260906', 'city': '黔西南', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260907', 'city': '安龙', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260908', 'city': '册亨', 'province': '贵州', 'leader': '黔西南'}, {'id': '101260909', 'city': '普安', 'province': '贵州', 'leader': '黔西南'}, {'id': '101270101', 'city': '成都', 'province': '四川', 'leader': '成都'}, {'id': '101270102', 'city': '龙泉驿', 'province': '四川', 'leader': '成都'}, {'id': '101270103', 'city': '新都', 'province': '四川', 'leader': '成都'}, {'id': '101270104', 'city': '温江', 'province': '四川', 'leader': '成都'}, {'id': '101270105', 'city': '金堂', 'province': '四川', 'leader': '成都'}, {'id': '101270106', 'city': '双流', 'province': '四川', 'leader': '成都'}, {'id': '101270107', 'city': '郫县', 'province': '四川', 'leader': '成都'}, {'id': '101270108', 'city': '大邑', 'province': '四川', 'leader': '成都'}, {'id': '101270109', 'city': '蒲江', 'province': '四川', 'leader': '成都'}, {'id': '101270110', 'city': '新津', 'province': '四川', 'leader': '成都'}, {'id': '101270111', 'city': '都江堰', 'province': '四川', 'leader': '成都'}, {'id': '101270112', 'city': '彭州', 'province': '四川', 'leader': '成都'}, {'id': '101270113', 'city': '邛崃', 'province': '四川', 'leader': '成都'}, {'id': '101270114', 'city': '崇州', 'province': '四川', 'leader': '成都'}, {'id': '101270115', 'city': '青白江', 'province': '四川', 'leader': '成都'}, {'id': '101270116', 'city': '锦江', 'province': '四川', 'leader': '成都'}, {'id': '101270117', 'city': '青羊', 'province': '四川', 'leader': '成都'}, {'id': '101270118', 'city': '金牛', 'province': '四川', 'leader': '成都'}, {'id': '101270119', 'city': '武侯', 'province': '四川', 'leader': '成都'}, {'id': '101270120', 'city': '成华', 'province': '四川', 'leader': '成都'}, {'id': '101270121', 'city': '简阳', 'province': '四川', 'leader': '成都'}, {'id': '101270201', 'city': '攀枝花', 'province': '四川', 'leader': '攀枝花'}, {'id': '101270202', 'city': '仁和', 'province': '四川', 'leader': '攀枝花'}, {'id': '101270203', 'city': '米易', 'province': '四川', 'leader': '攀枝花'}, {'id': '101270204', 'city': '盐边', 'province': '四川', 'leader': '攀枝花'}, {'id': '101270205', 'city': '东区', 'province': '四川', 'leader': '攀枝花'}, {'id': '101270206', 'city': '西区', 'province': '四川', 'leader': '攀枝花'}, {'id': '101270301', 'city': '自贡', 'province': '四川', 'leader': '自贡'}, {'id': '101270302', 'city': '富顺', 'province': '四川', 'leader': '自贡'}, {'id': '101270303', 'city': '荣县', 'province': '四川', 'leader': '自贡'}, {'id': '101270304', 'city': '自流井', 'province': '四川', 'leader': '自贡'}, {'id': '101270305', 'city': '贡井', 'province': '四川', 'leader': '自贡'}, {'id': '101270306', 'city': '大安', 'province': '四川', 'leader': '自贡'}, {'id': '101270307', 'city': '沿滩', 'province': '四川', 'leader': '自贡'}, {'id': '101270401', 'city': '绵阳', 'province': '四川', 'leader': '绵阳'}, {'id': '101270402', 'city': '三台', 'province': '四川', 'leader': '绵阳'}, {'id': '101270403', 'city': '盐亭', 'province': '四川', 'leader': '绵阳'}, {'id': '101270404', 'city': '安县', 'province': '四川', 'leader': '绵阳'}, {'id': '101270405', 'city': '梓潼', 'province': '四川', 'leader': '绵阳'}, {'id': '101270406', 'city': '北川', 'province': '四川', 'leader': '绵阳'}, {'id': '101270407', 'city': '平武', 'province': '四川', 'leader': '绵阳'}, {'id': '101270408', 'city': '江油', 'province': '四川', 'leader': '绵阳'}, {'id': '101270409', 'city': '涪城', 'province': '四川', 'leader': '绵阳'}, {'id': '101270410', 'city': '游仙', 'province': '四川', 'leader': '绵阳'}, {'id': '101270411', 'city': '安州', 'province': '四川', 'leader': '绵阳'}, {'id': '101270501', 'city': '南充', 'province': '四川', 'leader': '南充'}, {'id': '101270502', 'city': '南部', 'province': '四川', 'leader': '南充'}, {'id': '101270503', 'city': '营山', 'province': '四川', 'leader': '南充'}, {'id': '101270504', 'city': '蓬安', 'province': '四川', 'leader': '南充'}, {'id': '101270505', 'city': '仪陇', 'province': '四川', 'leader': '南充'}, {'id': '101270506', 'city': '西充', 'province': '四川', 'leader': '南充'}, {'id': '101270507', 'city': '阆中', 'province': '四川', 'leader': '南充'}, {'id': '101270508', 'city': '顺庆', 'province': '四川', 'leader': '南充'}, {'id': '101270509', 'city': '高坪', 'province': '四川', 'leader': '南充'}, {'id': '101270510', 'city': '嘉陵', 'province': '四川', 'leader': '南充'}, {'id': '101270601', 'city': '达州', 'province': '四川', 'leader': '达州'}, {'id': '101270602', 'city': '宣汉', 'province': '四川', 'leader': '达州'}, {'id': '101270603', 'city': '开江', 'province': '四川', 'leader': '达州'}, {'id': '101270604', 'city': '大竹', 'province': '四川', 'leader': '达州'}, {'id': '101270605', 'city': '渠县', 'province': '四川', 'leader': '达州'}, {'id': '101270606', 'city': '万源', 'province': '四川', 'leader': '达州'}, {'id': '101270607', 'city': '通川', 'province': '四川', 'leader': '达州'}, {'id': '101270608', 'city': '达川', 'province': '四川', 'leader': '达州'}, {'id': '101270701', 'city': '遂宁', 'province': '四川', 'leader': '遂宁'}, {'id': '101270702', 'city': '蓬溪', 'province': '四川', 'leader': '遂宁'}, {'id': '101270703', 'city': '射洪', 'province': '四川', 'leader': '遂宁'}, {'id': '101270704', 'city': '船山', 'province': '四川', 'leader': '遂宁'}, {'id': '101270705', 'city': '安居', 'province': '四川', 'leader': '遂宁'}, {'id': '101270706', 'city': '大英', 'province': '四川', 'leader': '遂宁'}, {'id': '101270801', 'city': '广安', 'province': '四川', 'leader': '广安'}, {'id': '101270802', 'city': '岳池', 'province': '四川', 'leader': '广安'}, {'id': '101270803', 'city': '武胜', 'province': '四川', 'leader': '广安'}, {'id': '101270804', 'city': '邻水', 'province': '四川', 'leader': '广安'}, {'id': '101270805', 'city': '华蓥', 'province': '四川', 'leader': '广安'}, {'id': '101270806', 'city': '前锋', 'province': '四川', 'leader': '广安'}, {'id': '101270901', 'city': '巴中', 'province': '四川', 'leader': '巴中'}, {'id': '101270902', 'city': '通江', 'province': '四川', 'leader': '巴中'}, {'id': '101270903', 'city': '南江', 'province': '四川', 'leader': '巴中'}, {'id': '101270904', 'city': '平昌', 'province': '四川', 'leader': '巴中'}, {'id': '101270905', 'city': '巴州', 'province': '四川', 'leader': '巴中'}, {'id': '101270906', 'city': '恩阳', 'province': '四川', 'leader': '巴中'}, {'id': '101271001', 'city': '泸州', 'province': '四川', 'leader': '泸州'}, {'id': '101271002', 'city': '江阳', 'province': '四川', 'leader': '泸州'}, {'id': '101271003', 'city': '泸县', 'province': '四川', 'leader': '泸州'}, {'id': '101271004', 'city': '合江', 'province': '四川', 'leader': '泸州'}, {'id': '101271005', 'city': '叙永', 'province': '四川', 'leader': '泸州'}, {'id': '101271006', 'city': '古蔺', 'province': '四川', 'leader': '泸州'}, {'id': '101271007', 'city': '纳溪', 'province': '四川', 'leader': '泸州'}, {'id': '101271008', 'city': '龙马潭', 'province': '四川', 'leader': '泸州'}, {'id': '101271101', 'city': '宜宾', 'province': '四川', 'leader': '宜宾'}, {'id': '101271102', 'city': '翠屏', 'province': '四川', 'leader': '宜宾'}, {'id': '101271103', 'city': '宜宾县', 'province': '四川', 'leader': '宜宾'}, {'id': '101271104', 'city': '南溪', 'province': '四川', 'leader': '宜宾'}, {'id': '101271105', 'city': '江安', 'province': '四川', 'leader': '宜宾'}, {'id': '101271106', 'city': '长宁', 'province': '四川', 'leader': '宜宾'}, {'id': '101271107', 'city': '高县', 'province': '四川', 'leader': '宜宾'}, {'id': '101271108', 'city': '珙县', 'province': '四川', 'leader': '宜宾'}, {'id': '101271109', 'city': '筠连', 'province': '四川', 'leader': '宜宾'}, {'id': '101271110', 'city': '兴文', 'province': '四川', 'leader': '宜宾'}, {'id': '101271111', 'city': '屏山', 'province': '四川', 'leader': '宜宾'}, {'id': '101271201', 'city': '内江', 'province': '四川', 'leader': '内江'}, {'id': '101271202', 'city': '东兴', 'province': '四川', 'leader': '内江'}, {'id': '101271203', 'city': '威远', 'province': '四川', 'leader': '内江'}, {'id': '101271204', 'city': '资中', 'province': '四川', 'leader': '内江'}, {'id': '101271205', 'city': '隆昌', 'province': '四川', 'leader': '内江'}, {'id': '101271206', 'city': '市中', 'province': '四川', 'leader': '内江'}, {'id': '101271301', 'city': '资阳', 'province': '四川', 'leader': '资阳'}, {'id': '101271302', 'city': '安岳', 'province': '四川', 'leader': '资阳'}, {'id': '101271303', 'city': '乐至', 'province': '四川', 'leader': '资阳'}, {'id': '101271305', 'city': '雁江', 'province': '四川', 'leader': '资阳'}, {'id': '101271401', 'city': '乐山', 'province': '四川', 'leader': '乐山'}, {'id': '101271402', 'city': '犍为', 'province': '四川', 'leader': '乐山'}, {'id': '101271403', 'city': '井研', 'province': '四川', 'leader': '乐山'}, {'id': '101271404', 'city': '夹江', 'province': '四川', 'leader': '乐山'}, {'id': '101271405', 'city': '沐川', 'province': '四川', 'leader': '乐山'}, {'id': '101271406', 'city': '峨边', 'province': '四川', 'leader': '乐山'}, {'id': '101271407', 'city': '马边', 'province': '四川', 'leader': '乐山'}, {'id': '101271409', 'city': '峨眉山', 'province': '四川', 'leader': '乐山'}, {'id': '101271410', 'city': '市中', 'province': '四川', 'leader': '乐山'}, {'id': '101271411', 'city': '沙湾', 'province': '四川', 'leader': '乐山'}, {'id': '101271412', 'city': '五通桥', 'province': '四川', 'leader': '乐山'}, {'id': '101271413', 'city': '金口河', 'province': '四川', 'leader': '乐山'}, {'id': '101271501', 'city': '眉山', 'province': '四川', 'leader': '眉山'}, {'id': '101271502', 'city': '仁寿', 'province': '四川', 'leader': '眉山'}, {'id': '101271503', 'city': '彭山', 'province': '四川', 'leader': '眉山'}, {'id': '101271504', 'city': '洪雅', 'province': '四川', 'leader': '眉山'}, {'id': '101271505', 'city': '丹棱', 'province': '四川', 'leader': '眉山'}, {'id': '101271506', 'city': '青神', 'province': '四川', 'leader': '眉山'}, {'id': '101271507', 'city': '东坡', 'province': '四川', 'leader': '眉山'}, {'id': '101271601', 'city': '凉山', 'province': '四川', 'leader': '凉山'}, {'id': '101271603', 'city': '木里', 'province': '四川', 'leader': '凉山'}, {'id': '101271604', 'city': '盐源', 'province': '四川', 'leader': '凉山'}, {'id': '101271605', 'city': '德昌', 'province': '四川', 'leader': '凉山'}, {'id': '101271606', 'city': '会理', 'province': '四川', 'leader': '凉山'}, {'id': '101271607', 'city': '会东', 'province': '四川', 'leader': '凉山'}, {'id': '101271608', 'city': '宁南', 'province': '四川', 'leader': '凉山'}, {'id': '101271609', 'city': '普格', 'province': '四川', 'leader': '凉山'}, {'id': '101271610', 'city': '西昌', 'province': '四川', 'leader': '凉山'}, {'id': '101271611', 'city': '金阳', 'province': '四川', 'leader': '凉山'}, {'id': '101271612', 'city': '昭觉', 'province': '四川', 'leader': '凉山'}, {'id': '101271613', 'city': '喜德', 'province': '四川', 'leader': '凉山'}, {'id': '101271614', 'city': '冕宁', 'province': '四川', 'leader': '凉山'}, {'id': '101271615', 'city': '越西', 'province': '四川', 'leader': '凉山'}, {'id': '101271616', 'city': '甘洛', 'province': '四川', 'leader': '凉山'}, {'id': '101271617', 'city': '雷波', 'province': '四川', 'leader': '凉山'}, {'id': '101271618', 'city': '美姑', 'province': '四川', 'leader': '凉山'}, {'id': '101271619', 'city': '布拖', 'province': '四川', 'leader': '凉山'}, {'id': '101271701', 'city': '雅安', 'province': '四川', 'leader': '雅安'}, {'id': '101271702', 'city': '名山', 'province': '四川', 'leader': '雅安'}, {'id': '101271703', 'city': '荥经', 'province': '四川', 'leader': '雅安'}, {'id': '101271704', 'city': '汉源', 'province': '四川', 'leader': '雅安'}, {'id': '101271705', 'city': '石棉', 'province': '四川', 'leader': '雅安'}, {'id': '101271706', 'city': '天全', 'province': '四川', 'leader': '雅安'}, {'id': '101271707', 'city': '芦山', 'province': '四川', 'leader': '雅安'}, {'id': '101271708', 'city': '宝兴', 'province': '四川', 'leader': '雅安'}, {'id': '101271709', 'city': '雨城', 'province': '四川', 'leader': '雅安'}, {'id': '101271801', 'city': '甘孜', 'province': '四川', 'leader': '甘孜'}, {'id': '101271802', 'city': '康定', 'province': '四川', 'leader': '甘孜'}, {'id': '101271803', 'city': '泸定', 'province': '四川', 'leader': '甘孜'}, {'id': '101271804', 'city': '丹巴', 'province': '四川', 'leader': '甘孜'}, {'id': '101271805', 'city': '九龙', 'province': '四川', 'leader': '甘孜'}, {'id': '101271806', 'city': '雅江', 'province': '四川', 'leader': '甘孜'}, {'id': '101271807', 'city': '道孚', 'province': '四川', 'leader': '甘孜'}, {'id': '101271808', 'city': '炉霍', 'province': '四川', 'leader': '甘孜'}, {'id': '101271809', 'city': '新龙', 'province': '四川', 'leader': '甘孜'}, {'id': '101271810', 'city': '德格', 'province': '四川', 'leader': '甘孜'}, {'id': '101271811', 'city': '白玉', 'province': '四川', 'leader': '甘孜'}, {'id': '101271812', 'city': '石渠', 'province': '四川', 'leader': '甘孜'}, {'id': '101271813', 'city': '色达', 'province': '四川', 'leader': '甘孜'}, {'id': '101271814', 'city': '理塘', 'province': '四川', 'leader': '甘孜'}, {'id': '101271815', 'city': '巴塘', 'province': '四川', 'leader': '甘孜'}, {'id': '101271816', 'city': '乡城', 'province': '四川', 'leader': '甘孜'}, {'id': '101271817', 'city': '稻城', 'province': '四川', 'leader': '甘孜'}, {'id': '101271818', 'city': '得荣', 'province': '四川', 'leader': '甘孜'}, {'id': '101271901', 'city': '阿坝', 'province': '四川', 'leader': '阿坝'}, {'id': '101271902', 'city': '汶川', 'province': '四川', 'leader': '阿坝'}, {'id': '101271903', 'city': '理县', 'province': '四川', 'leader': '阿坝'}, {'id': '101271904', 'city': '茂县', 'province': '四川', 'leader': '阿坝'}, {'id': '101271905', 'city': '松潘', 'province': '四川', 'leader': '阿坝'}, {'id': '101271906', 'city': '九寨沟', 'province': '四川', 'leader': '阿坝'}, {'id': '101271907', 'city': '金川', 'province': '四川', 'leader': '阿坝'}, {'id': '101271908', 'city': '小金', 'province': '四川', 'leader': '阿坝'}, {'id': '101271909', 'city': '黑水', 'province': '四川', 'leader': '阿坝'}, {'id': '101271910', 'city': '马尔康', 'province': '四川', 'leader': '阿坝'}, {'id': '101271911', 'city': '壤塘', 'province': '四川', 'leader': '阿坝'}, {'id': '101271912', 'city': '若尔盖', 'province': '四川', 'leader': '阿坝'}, {'id': '101271913', 'city': '红原', 'province': '四川', 'leader': '阿坝'}, {'id': '101272001', 'city': '德阳', 'province': '四川', 'leader': '德阳'}, {'id': '101272002', 'city': '中江', 'province': '四川', 'leader': '德阳'}, {'id': '101272003', 'city': '广汉', 'province': '四川', 'leader': '德阳'}, {'id': '101272004', 'city': '什邡', 'province': '四川', 'leader': '德阳'}, {'id': '101272005', 'city': '绵竹', 'province': '四川', 'leader': '德阳'}, {'id': '101272006', 'city': '罗江', 'province': '四川', 'leader': '德阳'}, {'id': '101272007', 'city': '旌阳', 'province': '四川', 'leader': '德阳'}, {'id': '101272101', 'city': '广元', 'province': '四川', 'leader': '广元'}, {'id': '101272102', 'city': '旺苍', 'province': '四川', 'leader': '广元'}, {'id': '101272103', 'city': '青川', 'province': '四川', 'leader': '广元'}, {'id': '101272104', 'city': '剑阁', 'province': '四川', 'leader': '广元'}, {'id': '101272105', 'city': '苍溪', 'province': '四川', 'leader': '广元'}, {'id': '101272106', 'city': '利州', 'province': '四川', 'leader': '广元'}, {'id': '101272107', 'city': '昭化', 'province': '四川', 'leader': '广元'}, {'id': '101272108', 'city': '朝天', 'province': '四川', 'leader': '广元'}, {'id': '101280101', 'city': '广州', 'province': '广东', 'leader': '广州'}, {'id': '101280102', 'city': '番禺', 'province': '广东', 'leader': '广州'}, {'id': '101280103', 'city': '从化', 'province': '广东', 'leader': '广州'}, {'id': '101280104', 'city': '增城', 'province': '广东', 'leader': '广州'}, {'id': '101280105', 'city': '花都', 'province': '广东', 'leader': '广州'}, {'id': '101280106', 'city': '荔湾', 'province': '广东', 'leader': '广州'}, {'id': '101280107', 'city': '越秀', 'province': '广东', 'leader': '广州'}, {'id': '101280108', 'city': '海珠', 'province': '广东', 'leader': '广州'}, {'id': '101280109', 'city': '天河', 'province': '广东', 'leader': '广州'}, {'id': '101280110', 'city': '白云', 'province': '广东', 'leader': '广州'}, {'id': '101280111', 'city': '黄埔', 'province': '广东', 'leader': '广州'}, {'id': '101280112', 'city': '南沙', 'province': '广东', 'leader': '广州'}, {'id': '101280201', 'city': '韶关', 'province': '广东', 'leader': '韶关'}, {'id': '101280202', 'city': '乳源', 'province': '广东', 'leader': '韶关'}, {'id': '101280203', 'city': '始兴', 'province': '广东', 'leader': '韶关'}, {'id': '101280204', 'city': '翁源', 'province': '广东', 'leader': '韶关'}, {'id': '101280205', 'city': '乐昌', 'province': '广东', 'leader': '韶关'}, {'id': '101280206', 'city': '仁化', 'province': '广东', 'leader': '韶关'}, {'id': '101280207', 'city': '南雄', 'province': '广东', 'leader': '韶关'}, {'id': '101280208', 'city': '新丰', 'province': '广东', 'leader': '韶关'}, {'id': '101280209', 'city': '曲江', 'province': '广东', 'leader': '韶关'}, {'id': '101280210', 'city': '浈江', 'province': '广东', 'leader': '韶关'}, {'id': '101280211', 'city': '武江', 'province': '广东', 'leader': '韶关'}, {'id': '101280301', 'city': '惠州', 'province': '广东', 'leader': '惠州'}, {'id': '101280302', 'city': '博罗', 'province': '广东', 'leader': '惠州'}, {'id': '101280303', 'city': '惠阳', 'province': '广东', 'leader': '惠州'}, {'id': '101280304', 'city': '惠东', 'province': '广东', 'leader': '惠州'}, {'id': '101280305', 'city': '龙门', 'province': '广东', 'leader': '惠州'}, {'id': '101280306', 'city': '惠城', 'province': '广东', 'leader': '惠州'}, {'id': '101280401', 'city': '梅州', 'province': '广东', 'leader': '梅州'}, {'id': '101280402', 'city': '兴宁', 'province': '广东', 'leader': '梅州'}, {'id': '101280403', 'city': '蕉岭', 'province': '广东', 'leader': '梅州'}, {'id': '101280404', 'city': '大埔', 'province': '广东', 'leader': '梅州'}, {'id': '101280405', 'city': '梅江', 'province': '广东', 'leader': '梅州'}, {'id': '101280406', 'city': '丰顺', 'province': '广东', 'leader': '梅州'}, {'id': '101280407', 'city': '平远', 'province': '广东', 'leader': '梅州'}, {'id': '101280408', 'city': '五华', 'province': '广东', 'leader': '梅州'}, {'id': '101280409', 'city': '梅县', 'province': '广东', 'leader': '梅州'}, {'id': '101280501', 'city': '汕头', 'province': '广东', 'leader': '汕头'}, {'id': '101280502', 'city': '潮阳', 'province': '广东', 'leader': '汕头'}, {'id': '101280503', 'city': '澄海', 'province': '广东', 'leader': '汕头'}, {'id': '101280504', 'city': '南澳', 'province': '广东', 'leader': '汕头'}, {'id': '101280505', 'city': '龙湖', 'province': '广东', 'leader': '汕头'}, {'id': '101280506', 'city': '金平', 'province': '广东', 'leader': '汕头'}, {'id': '101280507', 'city': '濠江', 'province': '广东', 'leader': '汕头'}, {'id': '101280508', 'city': '潮南', 'province': '广东', 'leader': '汕头'}, {'id': '101280601', 'city': '深圳', 'province': '广东', 'leader': '深圳'}, {'id': '101280602', 'city': '罗湖', 'province': '广东', 'leader': '深圳'}, {'id': '101280603', 'city': '福田', 'province': '广东', 'leader': '深圳'}, {'id': '101280604', 'city': '南山', 'province': '广东', 'leader': '深圳'}, {'id': '101280605', 'city': '宝安', 'province': '广东', 'leader': '深圳'}, {'id': '101280606', 'city': '龙岗', 'province': '广东', 'leader': '深圳'}, {'id': '101280607', 'city': '盐田', 'province': '广东', 'leader': '深圳'}, {'id': '101280701', 'city': '珠海', 'province': '广东', 'leader': '珠海'}, {'id': '101280702', 'city': '斗门', 'province': '广东', 'leader': '珠海'}, {'id': '101280703', 'city': '金湾', 'province': '广东', 'leader': '珠海'}, {'id': '101280704', 'city': '香洲', 'province': '广东', 'leader': '珠海'}, {'id': '101280800', 'city': '佛山', 'province': '广东', 'leader': '佛山'}, {'id': '101280801', 'city': '顺德', 'province': '广东', 'leader': '佛山'}, {'id': '101280802', 'city': '三水', 'province': '广东', 'leader': '佛山'}, {'id': '101280803', 'city': '南海', 'province': '广东', 'leader': '佛山'}, {'id': '101280804', 'city': '高明', 'province': '广东', 'leader': '佛山'}, {'id': '101280805', 'city': '禅城', 'province': '广东', 'leader': '佛山'}, {'id': '101280901', 'city': '肇庆', 'province': '广东', 'leader': '肇庆'}, {'id': '101280902', 'city': '广宁', 'province': '广东', 'leader': '肇庆'}, {'id': '101280903', 'city': '四会', 'province': '广东', 'leader': '肇庆'}, {'id': '101280904', 'city': '端州', 'province': '广东', 'leader': '肇庆'}, {'id': '101280905', 'city': '德庆', 'province': '广东', 'leader': '肇庆'}, {'id': '101280906', 'city': '怀集', 'province': '广东', 'leader': '肇庆'}, {'id': '101280907', 'city': '封开', 'province': '广东', 'leader': '肇庆'}, {'id': '101280908', 'city': '高要', 'province': '广东', 'leader': '肇庆'}, {'id': '101280909', 'city': '鼎湖', 'province': '广东', 'leader': '肇庆'}, {'id': '101281001', 'city': '湛江', 'province': '广东', 'leader': '湛江'}, {'id': '101281002', 'city': '吴川', 'province': '广东', 'leader': '湛江'}, {'id': '101281003', 'city': '雷州', 'province': '广东', 'leader': '湛江'}, {'id': '101281004', 'city': '徐闻', 'province': '广东', 'leader': '湛江'}, {'id': '101281005', 'city': '廉江', 'province': '广东', 'leader': '湛江'}, {'id': '101281006', 'city': '赤坎', 'province': '广东', 'leader': '湛江'}, {'id': '101281007', 'city': '遂溪', 'province': '广东', 'leader': '湛江'}, {'id': '101281008', 'city': '坡头', 'province': '广东', 'leader': '湛江'}, {'id': '101281009', 'city': '霞山', 'province': '广东', 'leader': '湛江'}, {'id': '101281010', 'city': '麻章', 'province': '广东', 'leader': '湛江'}, {'id': '101281101', 'city': '江门', 'province': '广东', 'leader': '江门'}, {'id': '101281103', 'city': '开平', 'province': '广东', 'leader': '江门'}, {'id': '101281104', 'city': '新会', 'province': '广东', 'leader': '江门'}, {'id': '101281105', 'city': '恩平', 'province': '广东', 'leader': '江门'}, {'id': '101281106', 'city': '台山', 'province': '广东', 'leader': '江门'}, {'id': '101281107', 'city': '蓬江', 'province': '广东', 'leader': '江门'}, {'id': '101281108', 'city': '鹤山', 'province': '广东', 'leader': '江门'}, {'id': '101281109', 'city': '江海', 'province': '广东', 'leader': '江门'}, {'id': '101281201', 'city': '河源', 'province': '广东', 'leader': '河源'}, {'id': '101281202', 'city': '紫金', 'province': '广东', 'leader': '河源'}, {'id': '101281203', 'city': '连平', 'province': '广东', 'leader': '河源'}, {'id': '101281204', 'city': '和平', 'province': '广东', 'leader': '河源'}, {'id': '101281205', 'city': '龙川', 'province': '广东', 'leader': '河源'}, {'id': '101281206', 'city': '东源', 'province': '广东', 'leader': '河源'}, {'id': '101281207', 'city': '源城', 'province': '广东', 'leader': '河源'}, {'id': '101281301', 'city': '清远', 'province': '广东', 'leader': '清远'}, {'id': '101281302', 'city': '连南', 'province': '广东', 'leader': '清远'}, {'id': '101281303', 'city': '连州', 'province': '广东', 'leader': '清远'}, {'id': '101281304', 'city': '连山', 'province': '广东', 'leader': '清远'}, {'id': '101281305', 'city': '阳山', 'province': '广东', 'leader': '清远'}, {'id': '101281306', 'city': '佛冈', 'province': '广东', 'leader': '清远'}, {'id': '101281307', 'city': '英德', 'province': '广东', 'leader': '清远'}, {'id': '101281308', 'city': '清新', 'province': '广东', 'leader': '清远'}, {'id': '101281309', 'city': '清城', 'province': '广东', 'leader': '清远'}, {'id': '101281401', 'city': '云浮', 'province': '广东', 'leader': '云浮'}, {'id': '101281402', 'city': '罗定', 'province': '广东', 'leader': '云浮'}, {'id': '101281403', 'city': '新兴', 'province': '广东', 'leader': '云浮'}, {'id': '101281404', 'city': '郁南', 'province': '广东', 'leader': '云浮'}, {'id': '101281405', 'city': '云城', 'province': '广东', 'leader': '云浮'}, {'id': '101281406', 'city': '云安', 'province': '广东', 'leader': '云浮'}, {'id': '101281501', 'city': '潮州', 'province': '广东', 'leader': '潮州'}, {'id': '101281502', 'city': '饶平', 'province': '广东', 'leader': '潮州'}, {'id': '101281503', 'city': '潮安', 'province': '广东', 'leader': '潮州'}, {'id': '101281504', 'city': '湘桥', 'province': '广东', 'leader': '潮州'}, {'id': '101281601', 'city': '东莞', 'province': '广东', 'leader': '东莞'}, {'id': '101281701', 'city': '中山', 'province': '广东', 'leader': '中山'}, {'id': '101281801', 'city': '阳江', 'province': '广东', 'leader': '阳江'}, {'id': '101281802', 'city': '阳春', 'province': '广东', 'leader': '阳江'}, {'id': '101281803', 'city': '阳东', 'province': '广东', 'leader': '阳江'}, {'id': '101281804', 'city': '阳西', 'province': '广东', 'leader': '阳江'}, {'id': '101281805', 'city': '江城', 'province': '广东', 'leader': '阳江'}, {'id': '101281901', 'city': '揭阳', 'province': '广东', 'leader': '揭阳'}, {'id': '101281902', 'city': '揭西', 'province': '广东', 'leader': '揭阳'}, {'id': '101281903', 'city': '普宁', 'province': '广东', 'leader': '揭阳'}, {'id': '101281904', 'city': '惠来', 'province': '广东', 'leader': '揭阳'}, {'id': '101281905', 'city': '揭东', 'province': '广东', 'leader': '揭阳'}, {'id': '101281906', 'city': '榕城', 'province': '广东', 'leader': '揭阳'}, {'id': '101282001', 'city': '茂名', 'province': '广东', 'leader': '茂名'}, {'id': '101282002', 'city': '高州', 'province': '广东', 'leader': '茂名'}, {'id': '101282003', 'city': '化州', 'province': '广东', 'leader': '茂名'}, {'id': '101282004', 'city': '电白', 'province': '广东', 'leader': '茂名'}, {'id': '101282005', 'city': '信宜', 'province': '广东', 'leader': '茂名'}, {'id': '101282007', 'city': '茂南', 'province': '广东', 'leader': '茂名'}, {'id': '101282101', 'city': '汕尾', 'province': '广东', 'leader': '汕尾'}, {'id': '101282102', 'city': '海丰', 'province': '广东', 'leader': '汕尾'}, {'id': '101282103', 'city': '陆丰', 'province': '广东', 'leader': '汕尾'}, {'id': '101282104', 'city': '陆河', 'province': '广东', 'leader': '汕尾'}, {'id': '101290101', 'city': '昆明', 'province': '云南', 'leader': '昆明'}, {'id': '101290102', 'city': '五华', 'province': '云南', 'leader': '昆明'}, {'id': '101290103', 'city': '东川', 'province': '云南', 'leader': '昆明'}, {'id': '101290104', 'city': '寻甸', 'province': '云南', 'leader': '昆明'}, {'id': '101290105', 'city': '晋宁', 'province': '云南', 'leader': '昆明'}, {'id': '101290106', 'city': '宜良', 'province': '云南', 'leader': '昆明'}, {'id': '101290107', 'city': '石林', 'province': '云南', 'leader': '昆明'}, {'id': '101290108', 'city': '呈贡', 'province': '云南', 'leader': '昆明'}, {'id': '101290109', 'city': '富民', 'province': '云南', 'leader': '昆明'}, {'id': '101290110', 'city': '嵩明', 'province': '云南', 'leader': '昆明'}, {'id': '101290111', 'city': '禄劝', 'province': '云南', 'leader': '昆明'}, {'id': '101290112', 'city': '安宁', 'province': '云南', 'leader': '昆明'}, {'id': '101290114', 'city': '盘龙', 'province': '云南', 'leader': '昆明'}, {'id': '101290115', 'city': '官渡', 'province': '云南', 'leader': '昆明'}, {'id': '101290116', 'city': '西山', 'province': '云南', 'leader': '昆明'}, {'id': '101290201', 'city': '大理', 'province': '云南', 'leader': '大理'}, {'id': '101290202', 'city': '云龙', 'province': '云南', 'leader': '大理'}, {'id': '101290203', 'city': '漾濞', 'province': '云南', 'leader': '大理'}, {'id': '101290204', 'city': '永平', 'province': '云南', 'leader': '大理'}, {'id': '101290205', 'city': '宾川', 'province': '云南', 'leader': '大理'}, {'id': '101290206', 'city': '弥渡', 'province': '云南', 'leader': '大理'}, {'id': '101290207', 'city': '祥云', 'province': '云南', 'leader': '大理'}, {'id': '101290208', 'city': '巍山', 'province': '云南', 'leader': '大理'}, {'id': '101290209', 'city': '剑川', 'province': '云南', 'leader': '大理'}, {'id': '101290210', 'city': '洱源', 'province': '云南', 'leader': '大理'}, {'id': '101290211', 'city': '鹤庆', 'province': '云南', 'leader': '大理'}, {'id': '101290212', 'city': '南涧', 'province': '云南', 'leader': '大理'}, {'id': '101290301', 'city': '红河', 'province': '云南', 'leader': '红河'}, {'id': '101290302', 'city': '石屏', 'province': '云南', 'leader': '红河'}, {'id': '101290303', 'city': '建水', 'province': '云南', 'leader': '红河'}, {'id': '101290304', 'city': '弥勒', 'province': '云南', 'leader': '红河'}, {'id': '101290305', 'city': '元阳', 'province': '云南', 'leader': '红河'}, {'id': '101290306', 'city': '绿春', 'province': '云南', 'leader': '红河'}, {'id': '101290307', 'city': '开远', 'province': '云南', 'leader': '红河'}, {'id': '101290308', 'city': '个旧', 'province': '云南', 'leader': '红河'}, {'id': '101290309', 'city': '蒙自', 'province': '云南', 'leader': '红河'}, {'id': '101290310', 'city': '屏边', 'province': '云南', 'leader': '红河'}, {'id': '101290311', 'city': '泸西', 'province': '云南', 'leader': '红河'}, {'id': '101290312', 'city': '金平', 'province': '云南', 'leader': '红河'}, {'id': '101290313', 'city': '河口', 'province': '云南', 'leader': '红河'}, {'id': '101290401', 'city': '曲靖', 'province': '云南', 'leader': '曲靖'}, {'id': '101290402', 'city': '沾益', 'province': '云南', 'leader': '曲靖'}, {'id': '101290403', 'city': '陆良', 'province': '云南', 'leader': '曲靖'}, {'id': '101290404', 'city': '富源', 'province': '云南', 'leader': '曲靖'}, {'id': '101290405', 'city': '马龙', 'province': '云南', 'leader': '曲靖'}, {'id': '101290406', 'city': '师宗', 'province': '云南', 'leader': '曲靖'}, {'id': '101290407', 'city': '罗平', 'province': '云南', 'leader': '曲靖'}, {'id': '101290408', 'city': '会泽', 'province': '云南', 'leader': '曲靖'}, {'id': '101290409', 'city': '宣威', 'province': '云南', 'leader': '曲靖'}, {'id': '101290410', 'city': '麒麟', 'province': '云南', 'leader': '曲靖'}, {'id': '101290501', 'city': '保山', 'province': '云南', 'leader': '保山'}, {'id': '101290502', 'city': '隆阳', 'province': '云南', 'leader': '保山'}, {'id': '101290503', 'city': '龙陵', 'province': '云南', 'leader': '保山'}, {'id': '101290504', 'city': '施甸', 'province': '云南', 'leader': '保山'}, {'id': '101290505', 'city': '昌宁', 'province': '云南', 'leader': '保山'}, {'id': '101290506', 'city': '腾冲', 'province': '云南', 'leader': '保山'}, {'id': '101290601', 'city': '文山', 'province': '云南', 'leader': '文山'}, {'id': '101290602', 'city': '西畴', 'province': '云南', 'leader': '文山'}, {'id': '101290603', 'city': '马关', 'province': '云南', 'leader': '文山'}, {'id': '101290604', 'city': '麻栗坡', 'province': '云南', 'leader': '文山'}, {'id': '101290605', 'city': '砚山', 'province': '云南', 'leader': '文山'}, {'id': '101290606', 'city': '丘北', 'province': '云南', 'leader': '文山'}, {'id': '101290607', 'city': '广南', 'province': '云南', 'leader': '文山'}, {'id': '101290608', 'city': '富宁', 'province': '云南', 'leader': '文山'}, {'id': '101290701', 'city': '玉溪', 'province': '云南', 'leader': '玉溪'}, {'id': '101290702', 'city': '澄江', 'province': '云南', 'leader': '玉溪'}, {'id': '101290703', 'city': '江川', 'province': '云南', 'leader': '玉溪'}, {'id': '101290704', 'city': '通海', 'province': '云南', 'leader': '玉溪'}, {'id': '101290705', 'city': '华宁', 'province': '云南', 'leader': '玉溪'}, {'id': '101290706', 'city': '新平', 'province': '云南', 'leader': '玉溪'}, {'id': '101290707', 'city': '易门', 'province': '云南', 'leader': '玉溪'}, {'id': '101290708', 'city': '峨山', 'province': '云南', 'leader': '玉溪'}, {'id': '101290709', 'city': '元江', 'province': '云南', 'leader': '玉溪'}, {'id': '101290710', 'city': '红塔', 'province': '云南', 'leader': '玉溪'}, {'id': '101290801', 'city': '楚雄', 'province': '云南', 'leader': '楚雄'}, {'id': '101290802', 'city': '大姚', 'province': '云南', 'leader': '楚雄'}, {'id': '101290803', 'city': '元谋', 'province': '云南', 'leader': '楚雄'}, {'id': '101290804', 'city': '姚安', 'province': '云南', 'leader': '楚雄'}, {'id': '101290805', 'city': '牟定', 'province': '云南', 'leader': '楚雄'}, {'id': '101290806', 'city': '南华', 'province': '云南', 'leader': '楚雄'}, {'id': '101290807', 'city': '武定', 'province': '云南', 'leader': '楚雄'}, {'id': '101290808', 'city': '禄丰', 'province': '云南', 'leader': '楚雄'}, {'id': '101290809', 'city': '双柏', 'province': '云南', 'leader': '楚雄'}, {'id': '101290810', 'city': '永仁', 'province': '云南', 'leader': '楚雄'}, {'id': '101290901', 'city': '普洱', 'province': '云南', 'leader': '普洱'}, {'id': '101290902', 'city': '景谷', 'province': '云南', 'leader': '普洱'}, {'id': '101290903', 'city': '景东', 'province': '云南', 'leader': '普洱'}, {'id': '101290904', 'city': '澜沧', 'province': '云南', 'leader': '普洱'}, {'id': '101290905', 'city': '思茅', 'province': '云南', 'leader': '普洱'}, {'id': '101290906', 'city': '墨江', 'province': '云南', 'leader': '普洱'}, {'id': '101290907', 'city': '江城', 'province': '云南', 'leader': '普洱'}, {'id': '101290908', 'city': '孟连', 'province': '云南', 'leader': '普洱'}, {'id': '101290909', 'city': '西盟', 'province': '云南', 'leader': '普洱'}, {'id': '101290911', 'city': '镇沅', 'province': '云南', 'leader': '普洱'}, {'id': '101290912', 'city': '宁洱', 'province': '云南', 'leader': '普洱'}, {'id': '101291001', 'city': '昭通', 'province': '云南', 'leader': '昭通'}, {'id': '101291002', 'city': '鲁甸', 'province': '云南', 'leader': '昭通'}, {'id': '101291003', 'city': '彝良', 'province': '云南', 'leader': '昭通'}, {'id': '101291004', 'city': '镇雄', 'province': '云南', 'leader': '昭通'}, {'id': '101291005', 'city': '威信', 'province': '云南', 'leader': '昭通'}, {'id': '101291006', 'city': '巧家', 'province': '云南', 'leader': '昭通'}, {'id': '101291007', 'city': '绥江', 'province': '云南', 'leader': '昭通'}, {'id': '101291008', 'city': '永善', 'province': '云南', 'leader': '昭通'}, {'id': '101291009', 'city': '盐津', 'province': '云南', 'leader': '昭通'}, {'id': '101291010', 'city': '大关', 'province': '云南', 'leader': '昭通'}, {'id': '101291011', 'city': '水富', 'province': '云南', 'leader': '昭通'}, {'id': '101291012', 'city': '昭阳', 'province': '云南', 'leader': '昭通'}, {'id': '101291101', 'city': '临沧', 'province': '云南', 'leader': '临沧'}, {'id': '101291102', 'city': '沧源', 'province': '云南', 'leader': '临沧'}, {'id': '101291103', 'city': '耿马', 'province': '云南', 'leader': '临沧'}, {'id': '101291104', 'city': '双江', 'province': '云南', 'leader': '临沧'}, {'id': '101291105', 'city': '凤庆', 'province': '云南', 'leader': '临沧'}, {'id': '101291106', 'city': '永德', 'province': '云南', 'leader': '临沧'}, {'id': '101291107', 'city': '云县', 'province': '云南', 'leader': '临沧'}, {'id': '101291108', 'city': '镇康', 'province': '云南', 'leader': '临沧'}, {'id': '101291109', 'city': '临翔', 'province': '云南', 'leader': '临沧'}, {'id': '101291201', 'city': '怒江', 'province': '云南', 'leader': '怒江'}, {'id': '101291203', 'city': '福贡', 'province': '云南', 'leader': '怒江'}, {'id': '101291204', 'city': '兰坪', 'province': '云南', 'leader': '怒江'}, {'id': '101291205', 'city': '泸水', 'province': '云南', 'leader': '怒江'}, {'id': '101291207', 'city': '贡山', 'province': '云南', 'leader': '怒江'}, {'id': '101291301', 'city': '香格里拉', 'province': '云南', 'leader': '迪庆'}, {'id': '101291302', 'city': '德钦', 'province': '云南', 'leader': '迪庆'}, {'id': '101291303', 'city': '维西', 'province': '云南', 'leader': '迪庆'}, {'id': '101291305', 'city': '迪庆', 'province': '云南', 'leader': '迪庆'}, {'id': '101291401', 'city': '丽江', 'province': '云南', 'leader': '丽江'}, {'id': '101291402', 'city': '永胜', 'province': '云南', 'leader': '丽江'}, {'id': '101291403', 'city': '华坪', 'province': '云南', 'leader': '丽江'}, {'id': '101291404', 'city': '宁蒗', 'province': '云南', 'leader': '丽江'}, {'id': '101291405', 'city': '古城', 'province': '云南', 'leader': '丽江'}, {'id': '101291406', 'city': '玉龙', 'province': '云南', 'leader': '丽江'}, {'id': '101291501', 'city': '德宏', 'province': '云南', 'leader': '德宏'}, {'id': '101291503', 'city': '陇川', 'province': '云南', 'leader': '德宏'}, {'id': '101291504', 'city': '盈江', 'province': '云南', 'leader': '德宏'}, {'id': '101291506', 'city': '瑞丽', 'province': '云南', 'leader': '德宏'}, {'id': '101291507', 'city': '梁河', 'province': '云南', 'leader': '德宏'}, {'id': '101291508', 'city': '芒市', 'province': '云南', 'leader': '德宏'}, {'id': '101291601', 'city': '景洪', 'province': '云南', 'leader': '西双版纳'}, {'id': '101291602', 'city': '西双版纳', 'province': '云南', 'leader': '西双版纳'}, {'id': '101291603', 'city': '勐海', 'province': '云南', 'leader': '西双版纳'}, {'id': '101291605', 'city': '勐腊', 'province': '云南', 'leader': '西双版纳'}, {'id': '101300101', 'city': '南宁', 'province': '广西', 'leader': '南宁'}, {'id': '101300102', 'city': '兴宁', 'province': '广西', 'leader': '南宁'}, {'id': '101300103', 'city': '邕宁', 'province': '广西', 'leader': '南宁'}, {'id': '101300104', 'city': '横县', 'province': '广西', 'leader': '南宁'}, {'id': '101300105', 'city': '隆安', 'province': '广西', 'leader': '南宁'}, {'id': '101300106', 'city': '马山', 'province': '广西', 'leader': '南宁'}, {'id': '101300107', 'city': '上林', 'province': '广西', 'leader': '南宁'}, {'id': '101300108', 'city': '武鸣', 'province': '广西', 'leader': '南宁'}, {'id': '101300109', 'city': '宾阳', 'province': '广西', 'leader': '南宁'}, {'id': '101300110', 'city': '青秀', 'province': '广西', 'leader': '南宁'}, {'id': '101300111', 'city': '江南', 'province': '广西', 'leader': '南宁'}, {'id': '101300112', 'city': '西乡塘', 'province': '广西', 'leader': '南宁'}, {'id': '101300113', 'city': '良庆', 'province': '广西', 'leader': '南宁'}, {'id': '101300201', 'city': '崇左', 'province': '广西', 'leader': '崇左'}, {'id': '101300202', 'city': '天等', 'province': '广西', 'leader': '崇左'}, {'id': '101300203', 'city': '龙州', 'province': '广西', 'leader': '崇左'}, {'id': '101300204', 'city': '凭祥', 'province': '广西', 'leader': '崇左'}, {'id': '101300205', 'city': '大新', 'province': '广西', 'leader': '崇左'}, {'id': '101300206', 'city': '扶绥', 'province': '广西', 'leader': '崇左'}, {'id': '101300207', 'city': '宁明', 'province': '广西', 'leader': '崇左'}, {'id': '101300208', 'city': '江州', 'province': '广西', 'leader': '崇左'}, {'id': '101300301', 'city': '柳州', 'province': '广西', 'leader': '柳州'}, {'id': '101300302', 'city': '柳城', 'province': '广西', 'leader': '柳州'}, {'id': '101300303', 'city': '城中', 'province': '广西', 'leader': '柳州'}, {'id': '101300304', 'city': '鹿寨', 'province': '广西', 'leader': '柳州'}, {'id': '101300305', 'city': '柳江', 'province': '广西', 'leader': '柳州'}, {'id': '101300306', 'city': '融安', 'province': '广西', 'leader': '柳州'}, {'id': '101300307', 'city': '融水', 'province': '广西', 'leader': '柳州'}, {'id': '101300308', 'city': '三江', 'province': '广西', 'leader': '柳州'}, {'id': '101300309', 'city': '鱼峰', 'province': '广西', 'leader': '柳州'}, {'id': '101300310', 'city': '柳南', 'province': '广西', 'leader': '柳州'}, {'id': '101300311', 'city': '柳北', 'province': '广西', 'leader': '柳州'}, {'id': '101300401', 'city': '来宾', 'province': '广西', 'leader': '来宾'}, {'id': '101300402', 'city': '忻城', 'province': '广西', 'leader': '来宾'}, {'id': '101300403', 'city': '金秀', 'province': '广西', 'leader': '来宾'}, {'id': '101300404', 'city': '象州', 'province': '广西', 'leader': '来宾'}, {'id': '101300405', 'city': '武宣', 'province': '广西', 'leader': '来宾'}, {'id': '101300406', 'city': '合山', 'province': '广西', 'leader': '来宾'}, {'id': '101300407', 'city': '兴宾', 'province': '广西', 'leader': '来宾'}, {'id': '101300501', 'city': '桂林', 'province': '广西', 'leader': '桂林'}, {'id': '101300502', 'city': '秀峰', 'province': '广西', 'leader': '桂林'}, {'id': '101300503', 'city': '龙胜', 'province': '广西', 'leader': '桂林'}, {'id': '101300504', 'city': '永福', 'province': '广西', 'leader': '桂林'}, {'id': '101300505', 'city': '临桂', 'province': '广西', 'leader': '桂林'}, {'id': '101300506', 'city': '兴安', 'province': '广西', 'leader': '桂林'}, {'id': '101300507', 'city': '灵川', 'province': '广西', 'leader': '桂林'}, {'id': '101300508', 'city': '全州', 'province': '广西', 'leader': '桂林'}, {'id': '101300509', 'city': '灌阳', 'province': '广西', 'leader': '桂林'}, {'id': '101300510', 'city': '阳朔', 'province': '广西', 'leader': '桂林'}, {'id': '101300511', 'city': '恭城', 'province': '广西', 'leader': '桂林'}, {'id': '101300512', 'city': '平乐', 'province': '广西', 'leader': '桂林'}, {'id': '101300513', 'city': '荔浦', 'province': '广西', 'leader': '桂林'}, {'id': '101300514', 'city': '资源', 'province': '广西', 'leader': '桂林'}, {'id': '101300515', 'city': '叠彩', 'province': '广西', 'leader': '桂林'}, {'id': '101300516', 'city': '象山', 'province': '广西', 'leader': '桂林'}, {'id': '101300517', 'city': '七星', 'province': '广西', 'leader': '桂林'}, {'id': '101300518', 'city': '雁山', 'province': '广西', 'leader': '桂林'}, {'id': '101300601', 'city': '梧州', 'province': '广西', 'leader': '梧州'}, {'id': '101300602', 'city': '藤县', 'province': '广西', 'leader': '梧州'}, {'id': '101300603', 'city': '万秀', 'province': '广西', 'leader': '梧州'}, {'id': '101300604', 'city': '苍梧', 'province': '广西', 'leader': '梧州'}, {'id': '101300605', 'city': '蒙山', 'province': '广西', 'leader': '梧州'}, {'id': '101300606', 'city': '岑溪', 'province': '广西', 'leader': '梧州'}, {'id': '101300607', 'city': '长洲', 'province': '广西', 'leader': '梧州'}, {'id': '101300608', 'city': '龙圩', 'province': '广西', 'leader': '梧州'}, {'id': '101300701', 'city': '贺州', 'province': '广西', 'leader': '贺州'}, {'id': '101300702', 'city': '昭平', 'province': '广西', 'leader': '贺州'}, {'id': '101300703', 'city': '富川', 'province': '广西', 'leader': '贺州'}, {'id': '101300704', 'city': '钟山', 'province': '广西', 'leader': '贺州'}, {'id': '101300705', 'city': '八步', 'province': '广西', 'leader': '贺州'}, {'id': '101300706', 'city': '平桂', 'province': '广西', 'leader': '贺州'}, {'id': '101300801', 'city': '贵港', 'province': '广西', 'leader': '贵港'}, {'id': '101300802', 'city': '桂平', 'province': '广西', 'leader': '贵港'}, {'id': '101300803', 'city': '平南', 'province': '广西', 'leader': '贵港'}, {'id': '101300804', 'city': '港北', 'province': '广西', 'leader': '贵港'}, {'id': '101300805', 'city': '港南', 'province': '广西', 'leader': '贵港'}, {'id': '101300806', 'city': '覃塘', 'province': '广西', 'leader': '贵港'}, {'id': '101300901', 'city': '玉林', 'province': '广西', 'leader': '玉林'}, {'id': '101300902', 'city': '博白', 'province': '广西', 'leader': '玉林'}, {'id': '101300903', 'city': '北流', 'province': '广西', 'leader': '玉林'}, {'id': '101300904', 'city': '容县', 'province': '广西', 'leader': '玉林'}, {'id': '101300905', 'city': '陆川', 'province': '广西', 'leader': '玉林'}, {'id': '101300906', 'city': '兴业', 'province': '广西', 'leader': '玉林'}, {'id': '101300907', 'city': '玉州', 'province': '广西', 'leader': '玉林'}, {'id': '101300908', 'city': '福绵', 'province': '广西', 'leader': '玉林'}, {'id': '101301001', 'city': '百色', 'province': '广西', 'leader': '百色'}, {'id': '101301002', 'city': '那坡', 'province': '广西', 'leader': '百色'}, {'id': '101301003', 'city': '田阳', 'province': '广西', 'leader': '百色'}, {'id': '101301004', 'city': '德保', 'province': '广西', 'leader': '百色'}, {'id': '101301005', 'city': '靖西', 'province': '广西', 'leader': '百色'}, {'id': '101301006', 'city': '田东', 'province': '广西', 'leader': '百色'}, {'id': '101301007', 'city': '平果', 'province': '广西', 'leader': '百色'}, {'id': '101301008', 'city': '隆林', 'province': '广西', 'leader': '百色'}, {'id': '101301009', 'city': '西林', 'province': '广西', 'leader': '百色'}, {'id': '101301010', 'city': '乐业', 'province': '广西', 'leader': '百色'}, {'id': '101301011', 'city': '凌云', 'province': '广西', 'leader': '百色'}, {'id': '101301012', 'city': '田林', 'province': '广西', 'leader': '百色'}, {'id': '101301013', 'city': '右江', 'province': '广西', 'leader': '百色'}, {'id': '101301101', 'city': '钦州', 'province': '广西', 'leader': '钦州'}, {'id': '101301102', 'city': '浦北', 'province': '广西', 'leader': '钦州'}, {'id': '101301103', 'city': '灵山', 'province': '广西', 'leader': '钦州'}, {'id': '101301104', 'city': '钦南', 'province': '广西', 'leader': '钦州'}, {'id': '101301105', 'city': '钦北', 'province': '广西', 'leader': '钦州'}, {'id': '101301201', 'city': '河池', 'province': '广西', 'leader': '河池'}, {'id': '101301202', 'city': '天峨', 'province': '广西', 'leader': '河池'}, {'id': '101301203', 'city': '东兰', 'province': '广西', 'leader': '河池'}, {'id': '101301204', 'city': '巴马', 'province': '广西', 'leader': '河池'}, {'id': '101301205', 'city': '环江', 'province': '广西', 'leader': '河池'}, {'id': '101301206', 'city': '罗城', 'province': '广西', 'leader': '河池'}, {'id': '101301207', 'city': '宜州', 'province': '广西', 'leader': '河池'}, {'id': '101301208', 'city': '凤山', 'province': '广西', 'leader': '河池'}, {'id': '101301209', 'city': '南丹', 'province': '广西', 'leader': '河池'}, {'id': '101301210', 'city': '都安', 'province': '广西', 'leader': '河池'}, {'id': '101301211', 'city': '大化', 'province': '广西', 'leader': '河池'}, {'id': '101301212', 'city': '金城江', 'province': '广西', 'leader': '河池'}, {'id': '101301301', 'city': '北海', 'province': '广西', 'leader': '北海'}, {'id': '101301302', 'city': '合浦', 'province': '广西', 'leader': '北海'}, {'id': '101301304', 'city': '海城', 'province': '广西', 'leader': '北海'}, {'id': '101301305', 'city': '银海', 'province': '广西', 'leader': '北海'}, {'id': '101301306', 'city': '铁山港', 'province': '广西', 'leader': '北海'}, {'id': '101301401', 'city': '防城港', 'province': '广西', 'leader': '防城港'}, {'id': '101301402', 'city': '上思', 'province': '广西', 'leader': '防城港'}, {'id': '101301403', 'city': '东兴', 'province': '广西', 'leader': '防城港'}, {'id': '101301404', 'city': '港口', 'province': '广西', 'leader': '防城港'}, {'id': '101301405', 'city': '防城', 'province': '广西', 'leader': '防城港'}, {'id': '101310101', 'city': '海口', 'province': '海南', 'leader': '海口'}, {'id': '101310102', 'city': '秀英', 'province': '海南', 'leader': '海口'}, {'id': '101310103', 'city': '龙华', 'province': '海南', 'leader': '海口'}, {'id': '101310104', 'city': '琼山', 'province': '海南', 'leader': '海口'}, {'id': '101310105', 'city': '美兰', 'province': '海南', 'leader': '海口'}, {'id': '101310201', 'city': '三亚', 'province': '海南', 'leader': '三亚'}, {'id': '101310202', 'city': '东方', 'province': '海南', 'leader': '东方'}, {'id': '101310203', 'city': '临高', 'province': '海南', 'leader': '临高'}, {'id': '101310204', 'city': '澄迈', 'province': '海南', 'leader': '澄迈'}, {'id': '101310205', 'city': '儋州', 'province': '海南', 'leader': '儋州'}, {'id': '101310206', 'city': '昌江', 'province': '海南', 'leader': '昌江'}, {'id': '101310207', 'city': '白沙', 'province': '海南', 'leader': '白沙'}, {'id': '101310208', 'city': '琼中', 'province': '海南', 'leader': '琼中'}, {'id': '101310209', 'city': '定安', 'province': '海南', 'leader': '定安'}, {'id': '101310210', 'city': '屯昌', 'province': '海南', 'leader': '屯昌'}, {'id': '101310211', 'city': '琼海', 'province': '海南', 'leader': '琼海'}, {'id': '101310212', 'city': '文昌', 'province': '海南', 'leader': '文昌'}, {'id': '101310213', 'city': '海棠', 'province': '海南', 'leader': '三亚'}, {'id': '101310214', 'city': '保亭', 'province': '海南', 'leader': '保亭'}, {'id': '101310215', 'city': '万宁', 'province': '海南', 'leader': '万宁'}, {'id': '101310216', 'city': '陵水', 'province': '海南', 'leader': '陵水'}, {'id': '101310218', 'city': '吉阳', 'province': '海南', 'leader': '三亚'}, {'id': '101310219', 'city': '天涯', 'province': '海南', 'leader': '三亚'}, {'id': '101310221', 'city': '乐东', 'province': '海南', 'leader': '乐东'}, {'id': '101310222', 'city': '五指山', 'province': '海南', 'leader': '五指山'}, {'id': '101310223', 'city': '崖州', 'province': '海南', 'leader': '三亚'}, {'id': '101310301', 'city': '三沙', 'province': '海南', 'leader': '三沙'}, {'id': '101310302', 'city': '西沙', 'province': '海南', 'leader': '三沙'}, {'id': '101310303', 'city': '中沙', 'province': '海南', 'leader': '三沙'}, {'id': '101310304', 'city': '南沙', 'province': '海南', 'leader': '三沙'}, {'id': '101320101', 'city': '香港', 'province': '香港', 'leader': '香港'}, {'id': '101320102', 'city': '九龙', 'province': '香港', 'leader': '香港'}, {'id': '101320103', 'city': '新界', 'province': '香港', 'leader': '香港'}, {'id': '101330101', 'city': '澳门', 'province': '澳门', 'leader': '澳门'}, {'id': '101330102', 'city': '氹仔岛', 'province': '澳门', 'leader': '澳门'}, {'id': '101330103', 'city': '路环岛', 'province': '澳门', 'leader': '澳门'}, {'id': '101340101', 'city': '台北', 'province': '台湾', 'leader': '台北'}, {'id': '101340102', 'city': '桃园', 'province': '台湾', 'leader': '台北'}, {'id': '101340103', 'city': '新竹', 'province': '台湾', 'leader': '台北'}, {'id': '101340104', 'city': '宜兰', 'province': '台湾', 'leader': '台北'}, {'id': '101340201', 'city': '高雄', 'province': '台湾', 'leader': '高雄'}, {'id': '101340202', 'city': '嘉义', 'province': '台湾', 'leader': '高雄'}, {'id': '101340203', 'city': '台南', 'province': '台湾', 'leader': '高雄'}, {'id': '101340204', 'city': '台东', 'province': '台湾', 'leader': '高雄'}, {'id': '101340205', 'city': '屏东', 'province': '台湾', 'leader': '高雄'}, {'id': '101340401', 'city': '台中', 'province': '台湾', 'leader': '台中'}, {'id': '101340402', 'city': '苗栗', 'province': '台湾', 'leader': '台中'}, {'id': '101340403', 'city': '彰化', 'province': '台湾', 'leader': '台中'}, {'id': '101340404', 'city': '南投', 'province': '台湾', 'leader': '台中'}, {'id': '101340405', 'city': '花莲', 'province': '台湾', 'leader': '台中'}, {'id': '101340406', 'city': '云林', 'province': '台湾', 'leader': '台中'}]

def _get_tianqi_api(city):
    return requests.get('https://www.tianqiapi.com/api/?appid=14641533&appsecret=WY75ItCZ&version=v1&city='+city).json()

def weather(city, mode=0):
    assert isinstance(city, str), "`city` should be str."
    for i in city_dict.keys():
        if time.time()-city_dict[i]['time_now']>3600:
            city_dict.pop(i)
    
    if city in city_dict:
        a = city_dict[city]
    else:
        a = _get_tianqi_api(city)
        a['time_now'] = time.time()
        city_dict[city] = a
        
    if mode==-1:
        t = pd.DataFrame(city_info)
        return t[(t.city==city)].reset_index(drop=True)
    elif mode==0:
        name = ['week', 'wea', 'tem', 'tem1', 'tem2', 'humidity', 'visibility', 'pressure', 
                'win', 'win_speed', 'win_meter', 'sunrise', 'sunset', 'air', 'air_level', 'air_tips']
        name_zh = ['星期', '天气', '温度', '最高温度', '最低温度', '湿度', '能见度', '气压', '风向', '风力', '风速',
                   '日出', '日落', '空气质量指数', '空气质量等级', '出行建议']
        s = {j:[a['data'][0][j]] for j in name}
        s['city'] = [city]
        s = pd.DataFrame(s).reindex(columns=name)
        s.columns = name_zh
    elif mode==1:
        for i in a['data']:
            if i['date']==str(pd.to_datetime(datetime.datetime.now()))[:10]:
                break    
        s = (pd.DataFrame(i['hours'])
             .rename(columns={'hours':'分时', 'tem':'温度', 'wea':'天气', 'win':'风向', 'win_speed':'风力'})
             .drop(['wea_img'], axis=1))
    elif mode==2:
        for i in a['data']:
            if i['date']==str(pd.to_datetime(datetime.datetime.now()))[:10]:
                break
        s = {'指数':['空气质量指数', '紫外线指数', '运动指数', '血糖指数', '穿衣指数', '洗车指数', '空气污染扩散指数']}
        s['等级'] = [i['air_level']]+[j['level'] for j in i['index']]
        s['建议'] = [i['air_tips']]+[j['desc'] for j in i['index']]
        s = pd.DataFrame(s).reindex(columns=['指数', '等级', '建议'])
    elif mode==3:
        s = {}
        name = ['日期', '温度', '最高温度', '最低温度', '天气', '风向', '风力', '星期']
        name_en = ['date', 'tem', 'tem1', 'tem2', 'wea', 'win', 'win_speed', 'week']
        for i, j in zip(name, name_en):
            s[i] = [k[j] for k in a['data']]

        name = ['紫外线指数', '减肥指数', '血糖指数', '穿衣指数', '洗车指数', '空气污染扩散指数']
        for i, j in enumerate(name):
            s[j] = [k['index'][i]['level'] for k in a['data']]
        s = pd.DataFrame(s).drop(['减肥指数', '血糖指数'], axis=1)
    else:
        raise ValueError('`mode` velue error.')
    s['更新时间'] = a['update_time']
    return s
